=== modified file 'INSTALL'
--- INSTALL	2007-08-16 00:54:00 +0000
+++ INSTALL	2010-01-29 10:36:23 +0000
@@ -43,5 +43,6 @@
   python setup.py install
 
 For more information on installation, see
-http://bazaar-vcs.org/InstallationFaq
-or write to bazaar@lists.canonical.com.
+<http://wiki.bazaar.canonical.com/InstallationFaq>
+or write to bazaar@lists.canonical.com, or ask a question at
+<https://answers.launchpad.net/bzr/>.

=== modified file 'Makefile'
--- Makefile	2010-01-07 06:44:05 +0000
+++ Makefile	2010-01-29 10:29:17 +0000
@@ -406,7 +406,7 @@
 
 ### Packaging Targets ###
 
-.PHONY: dist dist-upload-escudero check-dist-tarball
+.PHONY: dist check-dist-tarball
 
 # build a distribution source tarball
 #
@@ -434,18 +434,3 @@
 	tar Cxz $$tmpdir -f $$tarball && \
 	$(MAKE) -C $$tmpdir/bzr-$$version check && \
 	rm -rf $$tmpdir
-
-
-# upload previously built tarball to the download directory on bazaar-vcs.org,
-# and verify that it can be downloaded ok.
-dist-upload-escudero:
-	version=`./bzr version --short` && \
-	tarball=../bzr-$$version.tar.gz && \
-	scp $$tarball $$tarball.sig \
-	    escudero.ubuntu.com:/srv/bazaar.canonical.com/www/releases/src \
-		&& \
-	echo verifying over http... && \
-	curl http://bazaar-vcs.org/releases/src/bzr-$$version.tar.gz \
-		| diff -s - $$tarball && \
-	curl http://bazaar-vcs.org/releases/src/bzr-$$version.tar.gz.sig \
-		| diff -s - $$tarball.sig 

=== modified file 'NEWS'
--- NEWS	2010-01-16 10:06:21 +0000
+++ NEWS	2010-02-03 07:16:18 +0000
@@ -5,14 +5,108 @@
 .. contents:: List of Releases
    :depth: 1
 
-bzr 2.1.0rc1 (not released yet)
-###############################
+bzr 2.2.0b1 (not released yet)
+##############################
+
+:Codename: ???
+:2.2.0b1: ???
+
+Compatibility Breaks
+********************
+
+* ``Repository.get_inventory_sha1()`` has been removed. (Jelmer Vernooij)
+
+New Features
+************
+
+bzr 2.1.0 (not released yet)
+############################
+
+:Codename: 
+:2.1.0: 
+
+Bug Fixes
+*********
+
+* Fix "AttributeError in Inter1and2Helper" during fetch.
+  (Martin Pool, #513432)
+
+* Set the mtime of files exported to a directory by ``bzr export`` all to
+  the same value to avoid confusing ``make`` and other date-based build
+  systems. (Robert Collins, #515631)
+
+Improvements
+************
+
+Documentation
+*************
+
+API Changes
+***********
+
+* ``Repository.deserialise_inventory`` has been renamed to 
+  ``Repository._deserialise_inventory`` to indicate it is private.
+  (Jelmer Vernooij)
+
+* ``Repository.get_inventory_xml`` has been renamed to 
+  ``Repository._get_inventory_xml`` to indicate it is private. 
+  (Jelmer Vernooij)
+
+* ``Repository.serialise_inventory`` has been renamed to 
+  ``Repository._serialise_inventory`` to indicate it is private.
+
+Internals
+*********
+
+Testing
+*******
+* Using the ``bzrlib.chk_map`` module from within multiple threads at the
+  same time was broken due to race conditions with a module level page
+  cache. This shows up as a KeyError in the ``bzrlib.lru_cache`` code with
+  ``bzrlib.chk_map`` in the backtrace, and can be triggered without using
+  the same high level objects such as ``bzrlib.repository.Repository``
+  from different threads. chk_map now uses a thread local cache which may
+  increase memory pressure on processes using threads.
+  (Robert Collins, John Arbash Meinel, #514090)
+
+
+bzr 2.1.0rc2
+############
+
+:Codename: after the bubbles
+:2.1.0rc2: 2010-01-29
+
+This is a quick-turn-around to update a small issue with our new per-file
+merge hook. We expect no major changes from this to the final 2.1.0.
+
+API Changes
+***********
+
+* The new ``merge_file_content`` hook point has been altered to provide a
+  better API where state for extensions can be stored rather than the
+  too-simple function based approach. This fixes a performance regression
+  where branch configuration would be parsed per-file during merge. As
+  part of this the included news_merger has been refactored into a base
+  helper class ``bzrlib.merge.ConfigurableFileMerger``.
+  (Robert Collins, John Arbash Meinel, #513822)
+
+
+bzr 2.1.0rc1
+############
 
 :Codename: the 'new' stable
-:2.1.0rc1: 2009-01-06 (expected)
-
-Compatibility Breaks
-********************
+:2.1.0rc1: 2009-01-21
+
+This is the first stable release candidate for Bazaar's 2.1 series. From
+this point onwards, the 2.1 series will be considered stable (as the 2.0
+series) and only bugfixes are expected to be incorporated. The dozen or so
+bugfixes in the 2.0.4 release are also included in this release (along
+with more than 15 more bugfixes). Some of the interesting features are
+support for per-file merge hooks, ``bzr unshelve --preview``, support
+for using ! in ignore files to exclude files from being ignored, a small
+memory leak was squashed, and many ``ObjectNotLocked`` errors were fixed.
+This looks to be a very good start for a new stable series.
+
 
 New Features
 ************
@@ -20,6 +114,15 @@
 * Add bug information to log output when available.
   (Neil Martinsen-Burrell, Guillermo Gonzalez, #251729)
 
+* Added ``merge_file_content`` hook point to ``Merger``, allowing plugins
+  to register custom merge logic, e.g. to provide smarter merging for
+  particular files.
+
+* Bazaar now includes the ``news_merge`` plugin.  It is disabled by
+  default, to enable it add a ``news_merge_files`` option to your
+  configuration.  Consult ``bzr help news_merge`` for more information.
+  (Andrew Bennetts)
+  
 * ``bzr branch`` now takes a ``--bind`` option. This lets you
   branch and bind all in one command. (Ian Clatworthy)
 
@@ -39,10 +142,17 @@
   transferred for the current command. This information is always logged
   to ``.bzr.log`` for later inspection. (John Arbash Meinel)
 
-* The ``suppress_warnings`` configuration option has been introduced and
-  accept the ``format_deprecation`` value to disable the corresponding
-  warning for repositories. It can be set to in either ``bazaar.conf``,
-  ``locations.conf`` or ``branch.conf``.
+* New ignore patterns.  Patterns prefixed with '!' are exceptions to 
+  ignore patterns and take precedence over regular ignores.  Such 
+  exceptions are used to specify files that should be versioned which 
+  would otherwise be ignored.  Patterns prefixed with '!!' act as regular 
+  ignore patterns, but have highest precedence, even over the '!' 
+  exception patterns. (John Whitley, #428031)
+
+* The ``supress_warnings`` configuration option has been introduced to disable
+  various warnings (it currently only supports the ``format_deprecation``
+  warning). The new option can be set in any of the following locations:
+  ``bazaar.conf``, ``locations.conf`` and/or ``branch.conf``.
   (Ted Gould, Matthew Fuller, Vincent Ladeuil)
 
 * Tree-shape conflicts can be resolved by providing ``--keep-mine`` and
@@ -57,16 +167,9 @@
   user-specified commit message editor.
   (Martin Pool, #504842)
 
-* ``bzr export dir`` now requests all file content as a record stream,
-  rather than requsting the file content one file-at-a-time. This can make
-  exporting over the network significantly faster (54min => 9min in one
-  case). (John Arbash Meinel, #343218)
-
-* ``bzr serve`` no longer slowly leaks memory. The compiled
-  ``bzrlib.bencode.Encoder()`` class was using ``__del__`` to cleanup and
-  free resources, and it should have been using ``__dealloc__``.
-  This will likely have an impact on any other process that is serving for
-  an extended period of time.  (John Arbash Meinel, #494406)
+* ``bzr diff`` will now use the epoch when it is unable to determine 
+  the timestamp of a file, if the revision it was introduced in is a
+  ghost. (Jelmer Vernooij, #295611)
 
 * ``bzr switch -b`` can now create branches that are located using directory
   services such as ``lp:``, even when the branch name doesn't contain a
@@ -75,9 +178,12 @@
 * ``bzr unshelve`` has improved messages about what it is doing.
   (Neil Martinsen-Burrell, #496917)
 
-* Check for SIGINT (Ctrl-C) and other signals immediately if ``readdir``
-  returns ``EINTR`` by calling ``PyErr_CheckSignals``.  This affected the
-  optional ``_readdir_pyx`` extension.  (Andrew Bennetts, #495023)
+* Concurrent autopacking is more resilient to already-renamed pack files.
+  If we find that a file we are about to obsolete is already obsoleted, we
+  do not try to rename it, and we leave the file in ``obsolete_packs``.
+  The code is also fault tolerant if a file goes missing, assuming that
+  another process already removed the file.
+  (John Arbash Meinel, Gareth White, #507557)
 
 * Fix "Too many concurrent requests" in reconcile when network connection
   fails.  (Andrew Bennetts, #503878)
@@ -92,9 +198,6 @@
 * FTP transports support Unicode paths by encoding/decoding them as utf8.
   (Vincent Ladeuil, #472161)
 
-* Give a clearer message if the lockdir disappears after being apparently
-  successfully taken.  (Martin Pool, #498378)
-
 * Listen to the SIGWINCH signal to update the terminal width.
   (Vincent Ladeuil, #316357)
 
@@ -106,10 +209,6 @@
   depended on this behaviour.
   (Martin Pool, #499757)
 
-* The 2a format wasn't properly restarting autopacks when something
-  changed underneath it (like another autopack). Now concurrent
-  autopackers will properly succeed. (John Arbash Meinel, #495000)
-
 * When operations update the working tree, all affected files should end
   up with the same mtime. (eg. when versioning a generated file, if you
   update the source and the generated file together, the generated file
@@ -124,6 +223,9 @@
   ``try``/``finally`` blocks where applicable as it is simpler and more
   robust.  (Andrew Bennetts)
 
+* All except a small number of storage formats are now hidden, making
+  the help for numerous commands far more digestible. (Ian Clatworthy)
+
 * Attempts to open a shared repository as a branch (e.g. ``bzr branch
   path/to/repo``) will now include "location is a repository" as a hint in
   the error message.  (Brian de Alwis, Andrew Bennetts, #440952)
@@ -142,6 +244,15 @@
 Documentation
 *************
 
+* Add documentation on creating merges with more than one parent.
+  (Neil Martinsen-Burrell, #481526)
+
+* Better explain the --uncommitted option of merge.
+  (Neil Martinsen-Burrell, #505088)
+
+* Improve discussion of pending merges in the documentation for
+  ``revert``.  (Neil Martinsen-Burrell, #505093)
+
 * Improved help for ``bzr send``. 
   (Martin Pool, Bojan Nikolic)
 
@@ -159,11 +270,18 @@
 API Changes
 ***********
 
+* Added ``cachedproperty`` decorator to ``bzrlib.decorators``.
+  (Andrew Bennetts)
+
 * Many test features were renamed from ``FooFeature`` to ``foo_feature``
   to be consistent with instances being lower case and classes being
   CamelCase. For the features that were more likely to be used, we added a
   deprecation thunk, but not all. (John Arbash Meinel)
 
+* Merger classes (such as ``Merge3Merger``) now expect a ``this_branch``
+  parameter in their constructors, and provide ``this_branch`` as an
+  attribute. (Andrew Bennetts)
+  
 * The Branch hooks pre_change_branch_tip no longer masks exceptions raised
   by plugins - the original exceptions are now preserved. (Robert Collins)
 
@@ -214,17 +332,18 @@
   tests that 'failed' - they're all just failures.
   (Martin Pool)
 
-bzr 2.0.4 (not released yet)
-############################
-
-:Codename:
-:2.0.4: smooth sailing
-
-Compatibility Breaks
-********************
-
-New Features
-************
+
+bzr 2.0.4
+#########
+
+:Codename: smooth sailing
+:2.0.4: 2010-01-21
+
+The fourth bugfix-only release in the 2.0 series contains more than a
+dozen bugfixes relative to 2.0.3. The primary focus is on handling
+interruptions and concurrent operations more cleanly, there is also a fair
+improvement to ``bzr export`` when exporting a remote branch.
+
 
 Bug Fixes
 *********
@@ -247,6 +366,11 @@
   returns ``EINTR`` by calling ``PyErr_CheckSignals``.  This affected the
   optional ``_readdir_pyx`` extension.  (Andrew Bennetts, #495023)
 
+* Concurrent autopacks will no longer lose a newly created pack file.
+  There was a race condition, where if the reload happened at the right
+  time, the second packer would forget the name of the newly added pack
+  file. (John Arbash Meinel, Gareth White, #507566)
+
 * Give a clearer message if the lockdir disappears after being apparently
   successfully taken.  (Martin Pool, #498378)
 
@@ -283,18 +407,6 @@
   the right time will get propagated, rather than silently failing to move
   the block pointer. (John Arbash Meinel, Gareth White, #495023)
 
-Improvements
-************
-
-Documentation
-*************
-
-API Changes
-***********
-
-Internals
-*********
-
 Testing
 *******
 
@@ -363,7 +475,7 @@
   and issues a warning.
   (Gioele Barabucci, #73073)
 
-* ``bzr ignore /`` no longer causes an IndexError. (Gorder Tyler, #456036)
+* ``bzr ignore /`` no longer causes an IndexError. (Gorden Tyler, #456036)
 
 * ``bzr log -n0 -rN`` should not return revisions beyond its merged revisions.
   (#325618, #484109, Marius Kruger)
@@ -612,6 +724,9 @@
 * ``--parallel=fork`` is now compatible with --subunit.
   (Robert Collins, Vincent Ladeuil, #419776)
 
+* Reporting of failures shows test ids not descriptions and thus shows
+  parameterised tests correctly. (Robert Collins)
+
 * TestNotApplicable is now handled within the TestCase.run method rather
   than being looked for within ``ExtendedTestResult.addError``. This
   provides better handling with other ``TestResult`` objects, degrading to

=== modified file 'README'
--- README	2009-10-06 07:41:02 +0000
+++ README	2010-01-29 14:09:05 +0000
@@ -3,25 +3,24 @@
 =================
 
 Bazaar (``bzr``) is a decentralized revision control system, designed to be
-easy for developers and end users alike.  Bazaar is part of the GNU project
-to develop a complete free operating system.
-
-To install Bazaar, follow the instructions given at
-http://bazaar-vcs.org/Download. Ready-to-install packages are available
-for most popular operating systems or you can install from source.
-
-To learn how to use Bazaar, see the official documentation at:
-
-    http://doc.bazaar-vcs.org/en/
+easy for developers and end users alike.  Bazaar is part of the GNU project to
+develop a complete free operating system <http://www.gnu.org/>, and a project
+of Canonical <http://www.canonical.com/>.
+
+Ready-to-install packages are available for most popular operating systems from
+<http://wiki.bazaar.canonical.com/Download/> or you can install from source by
+following the instructions in the INSTALL file.
+
+To learn how to use Bazaar, see the official documentation in the `doc`
+directory or at <http://doc.bazaar.canonical.com/en/>.
 
 For additional training materials including screencasts and slides,
 visit our community wiki documentation page at:
 
-    http://bazaar-vcs.org/Documentation/
+    http://wiki.bazaar.canonical.com/Documentation/
 
-Bazaar is written in Python, and is sponsored by Canonical Limited, the
-founders of Ubuntu and Launchpad. Bazaar is Free Software, and is released
-under the GNU General Public License.
+Bazaar is Free Software, and is released under the GNU General Public License,
+version 2 or later.
 
 Bazaar highlights
 =================

=== modified file 'bzr'
--- bzr	2009-12-15 19:59:00 +0000
+++ bzr	2010-01-21 22:23:29 +0000
@@ -23,7 +23,7 @@
 import warnings
 
 # update this on each release
-_script_version = (2, 1, 0)
+_script_version = (2, 2, 0)
 
 if __doc__ is None:
     print "bzr does not support python -OO."

=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2009-12-15 19:59:00 +0000
+++ bzrlib/__init__.py	2010-01-29 11:09:30 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -44,7 +44,7 @@
 # Python version 2.0 is (2, 0, 0, 'final', 0)."  Additionally we use a
 # releaselevel of 'dev' for unreleased under-development code.
 
-version_info = (2, 1, 0, 'dev', 5)
+version_info = (2, 2, 0, 'dev', 1)
 
 # API compatibility version: bzrlib is currently API compatible with 1.15.
 api_minimum_version = (2, 1, 0)

=== modified file 'bzrlib/benchmarks/bench_knit.py'
--- bzrlib/benchmarks/bench_knit.py	2009-08-11 03:26:03 +0000
+++ bzrlib/benchmarks/bench_knit.py	2010-01-25 17:48:22 +0000
@@ -61,20 +61,12 @@
 
     def setup_load_data_c(self):
         self.requireFeature(CompiledKnitFeature)
-        orig = knit._load_data
-        def reset():
-            knit._load_data = orig
-        self.addCleanup(reset)
         from bzrlib._knit_load_data_pyx import _load_data_c
-        knit._load_data = _load_data_c
+        self.overrideAttr(knit, '_load_data', _load_data_c)
 
     def setup_load_data_py(self):
-        orig = knit._load_data
-        def reset():
-            knit._load_data = orig
-        self.addCleanup(reset)
         from bzrlib._knit_load_data_py import _load_data_py
-        knit._load_data = _load_data_py
+        self.overrideAttr(knit, '_load_data', _load_data_py)
 
     def test_read_50k_index_c(self):
         self.setup_load_data_c()

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2010-01-15 04:05:36 +0000
+++ bzrlib/builtins.py	2010-01-29 10:36:23 +0000
@@ -2191,13 +2191,10 @@
     :Tips & tricks:
 
       GUI tools and IDEs are often better at exploring history than command
-      line tools. You may prefer qlog or glog from the QBzr and Bzr-Gtk packages
-      respectively for example. (TortoiseBzr uses qlog for displaying logs.) See
-      http://bazaar-vcs.org/BzrPlugins and http://bazaar-vcs.org/IDEIntegration.
-
-      Web interfaces are often better at exploring history than command line
-      tools, particularly for branches on servers. You may prefer Loggerhead
-      or one of its alternatives. See http://bazaar-vcs.org/WebInterface.
+      line tools: you may prefer qlog or viz from qbzr or bzr-gtk, the
+      bzr-explorer shell, or the Loggerhead web interface.  See the Plugin
+      Guide <http://doc.bazaar.canonical.com/plugins/en/> and
+      <http://wiki.bazaar.canonical.com/IDEIntegration>.  
 
       You may find it useful to add the aliases below to ``bazaar.conf``::
 
@@ -2609,6 +2606,13 @@
     After adding, editing or deleting that file either indirectly by
     using this command or directly by using an editor, be sure to commit
     it.
+    
+    Patterns prefixed with '!' are exceptions to ignore patterns and take
+    precedence over regular ignores.  Such exceptions are used to specify
+    files that should be versioned which would otherwise be ignored.
+    
+    Patterns prefixed with '!!' act as regular ignore patterns, but have
+    precedence over the '!' exception patterns.
 
     Note: ignore patterns containing shell wildcards must be quoted from
     the shell on Unix.
@@ -2618,10 +2622,14 @@
 
             bzr ignore ./Makefile
 
-        Ignore class files in all directories::
+        Ignore .class files in all directories...::
 
             bzr ignore "*.class"
 
+        ...but do not ignore "special.class"::
+
+            bzr ignore "!special.class"
+
         Ignore .o files under the lib directory::
 
             bzr ignore "lib/**/*.o"
@@ -2633,6 +2641,13 @@
         Ignore everything but the "debian" toplevel directory::
 
             bzr ignore "RE:(?!debian/).*"
+        
+        Ignore everything except the "local" toplevel directory,
+        but always ignore "*~" autosave files, even under local/::
+        
+            bzr ignore "*"
+            bzr ignore "!./local"
+            bzr ignore "!!*~"
     """
 
     _see_also = ['status', 'ignored', 'patterns']
@@ -3647,7 +3662,12 @@
     committed to record the result of the merge.
 
     merge refuses to run if there are any uncommitted changes, unless
-    --force is given.
+    --force is given. The --force option can also be used to create a
+    merge revision which has more than two parents.
+
+    If one would like to merge changes from the working tree of the other
+    branch without merging any committed revisions, the --uncommitted option
+    can be given.
 
     To select only some changes to merge, use "merge -i", which will prompt
     you to apply each diff hunk and file change, similar to "shelve".
@@ -3668,6 +3688,13 @@
         To apply a merge directive contained in /tmp/merge::
 
             bzr merge /tmp/merge
+
+        To create a merge revision with three parents from two branches
+        feature1a and feature1b:
+
+            bzr merge ../feature1a
+            bzr merge ../feature1b --force
+            bzr commit -m 'revision with three parents'
     """
 
     encoding_type = 'exact'
@@ -4083,22 +4110,23 @@
     created as above.  Directories containing unknown files will not be
     deleted.
 
-    The working tree contains a list of pending merged revisions, which will
-    be included as parents in the next commit.  Normally, revert clears that
-    list as well as reverting the files.  If any files are specified, revert
-    leaves the pending merge list alone and reverts only the files.  Use "bzr
-    revert ." in the tree root to revert all files but keep the merge record,
-    and "bzr revert --forget-merges" to clear the pending merge list without
+    The working tree contains a list of revisions that have been merged but
+    not yet committed. These revisions will be included as additional parents
+    of the next commit.  Normally, using revert clears that list as well as
+    reverting the files.  If any files are specified, revert leaves the list
+    of uncommitted merges alone and reverts only the files.  Use ``bzr revert
+    .`` in the tree root to revert all files but keep the recorded merges,
+    and ``bzr revert --forget-merges`` to clear the pending merge list without
     reverting any files.
 
-    Using "bzr revert --forget-merges", it is possible to apply the changes
-    from an arbitrary merge as a single revision.  To do this, perform the
-    merge as desired.  Then doing revert with the "--forget-merges" option will
-    keep the content of the tree as it was, but it will clear the list of
-    pending merges.  The next commit will then contain all of the changes that
-    would have been in the merge, but without any mention of the other parent
-    revisions.  Because this technique forgets where these changes originated,
-    it may cause additional conflicts on later merges involving the source and
+    Using "bzr revert --forget-merges", it is possible to apply all of the
+    changes from a branch in a single revision.  To do this, perform the merge
+    as desired.  Then doing revert with the "--forget-merges" option will keep
+    the content of the tree as it was, but it will clear the list of pending
+    merges.  The next commit will then contain all of the changes that are
+    present in the other branch, but without any other parent revisions.
+    Because this technique forgets where these changes originated, it may
+    cause additional conflicts on later merges involving the same source and
     target branches.
     """
 
@@ -4377,10 +4405,10 @@
     adding new commands, providing additional network transports and
     customizing log output.
 
-    See the Bazaar web site, http://bazaar-vcs.org, for further
-    information on plugins including where to find them and how to
-    install them. Instructions are also provided there on how to
-    write new plugins using the Python programming language.
+    See the Bazaar Plugin Guide <http://doc.bazaar.canonical.com/plugins/en/>
+    for further information on plugins including where to find them and how to
+    install them. Instructions are also provided there on how to write new
+    plugins using the Python programming language.
     """
     takes_options = ['verbose']
 

=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2010-01-12 02:48:41 +0000
+++ bzrlib/bzrdir.py	2010-01-29 10:36:23 +0000
@@ -3714,18 +3714,21 @@
 format_registry.register('weave', BzrDirFormat6,
     'Pre-0.8 format.  Slower than knit and does not'
     ' support checkouts or shared repositories.',
+    hidden=True,
     deprecated=True)
 format_registry.register_metadir('metaweave',
     'bzrlib.repofmt.weaverepo.RepositoryFormat7',
     'Transitional format in 0.8.  Slower than knit.',
     branch_format='bzrlib.branch.BzrBranchFormat5',
     tree_format='bzrlib.workingtree.WorkingTreeFormat3',
+    hidden=True,
     deprecated=True)
 format_registry.register_metadir('knit',
     'bzrlib.repofmt.knitrepo.RepositoryFormatKnit1',
     'Format using knits.  Recommended for interoperation with bzr <= 0.14.',
     branch_format='bzrlib.branch.BzrBranchFormat5',
     tree_format='bzrlib.workingtree.WorkingTreeFormat3',
+    hidden=True,
     deprecated=True)
 format_registry.register_metadir('dirstate',
     'bzrlib.repofmt.knitrepo.RepositoryFormatKnit1',
@@ -3735,6 +3738,7 @@
     # this uses bzrlib.workingtree.WorkingTreeFormat4 because importing
     # directly from workingtree_4 triggers a circular import.
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
+    hidden=True,
     deprecated=True)
 format_registry.register_metadir('dirstate-tags',
     'bzrlib.repofmt.knitrepo.RepositoryFormatKnit1',
@@ -3743,6 +3747,7 @@
         ' Incompatible with bzr < 0.15.',
     branch_format='bzrlib.branch.BzrBranchFormat6',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
+    hidden=True,
     deprecated=True)
 format_registry.register_metadir('rich-root',
     'bzrlib.repofmt.knitrepo.RepositoryFormatKnit4',
@@ -3750,6 +3755,7 @@
         ' bzr < 1.0.',
     branch_format='bzrlib.branch.BzrBranchFormat6',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
+    hidden=True,
     deprecated=True)
 format_registry.register_metadir('dirstate-with-subtree',
     'bzrlib.repofmt.knitrepo.RepositoryFormatKnit3',
@@ -3766,9 +3772,7 @@
     help='New in 0.92: Pack-based format with data compatible with '
         'dirstate-tags format repositories. Interoperates with '
         'bzr repositories before 0.92 but cannot be read by bzr < 0.92. '
-        'Previously called knitpack-experimental.  '
-        'For more information, see '
-        'http://doc.bazaar-vcs.org/latest/developers/packrepo.html.',
+        ,
     branch_format='bzrlib.branch.BzrBranchFormat6',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
     )
@@ -3777,9 +3781,7 @@
     help='New in 0.92: Pack-based format with data compatible with '
         'dirstate-with-subtree format repositories. Interoperates with '
         'bzr repositories before 0.92 but cannot be read by bzr < 0.92. '
-        'Previously called knitpack-experimental.  '
-        'For more information, see '
-        'http://doc.bazaar-vcs.org/latest/developers/packrepo.html.',
+        ,
     branch_format='bzrlib.branch.BzrBranchFormat6',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
     hidden=True,
@@ -3791,6 +3793,7 @@
          '(needed for bzr-svn and bzr-git).',
     branch_format='bzrlib.branch.BzrBranchFormat6',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
+    hidden=True,
     )
 format_registry.register_metadir('1.6',
     'bzrlib.repofmt.pack_repo.RepositoryFormatKnitPack5',
@@ -3799,6 +3802,7 @@
          'not present locally.',
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
+    hidden=True,
     )
 format_registry.register_metadir('1.6.1-rich-root',
     'bzrlib.repofmt.pack_repo.RepositoryFormatKnitPack5RichRoot',
@@ -3806,6 +3810,7 @@
          '(needed for bzr-svn and bzr-git).',
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
+    hidden=True,
     )
 format_registry.register_metadir('1.9',
     'bzrlib.repofmt.pack_repo.RepositoryFormatKnitPack6',
@@ -3814,6 +3819,7 @@
          'performance for most operations.',
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
+    hidden=True,
     )
 format_registry.register_metadir('1.9-rich-root',
     'bzrlib.repofmt.pack_repo.RepositoryFormatKnitPack6RichRoot',
@@ -3821,6 +3827,7 @@
          '(needed for bzr-svn and bzr-git).',
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
+    hidden=True,
     )
 format_registry.register_metadir('1.14',
     'bzrlib.repofmt.pack_repo.RepositoryFormatKnitPack6',
@@ -3842,12 +3849,13 @@
         'to and from rich-root-pack (and anything compatible with '
         'rich-root-pack) format repositories. Repositories and branches in '
         'this format can only be read by bzr.dev. Please read '
-        'http://doc.bazaar-vcs.org/latest/developers/development-repo.html '
+        'http://doc.bazaar.canonical.com/latest/developers/development-repo.html '
         'before use.',
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat6',
     experimental=True,
     alias=True,
+    hidden=True,
     )
 format_registry.register_metadir('development-subtree',
     'bzrlib.repofmt.pack_repo.RepositoryFormatPackDevelopment2Subtree',
@@ -3855,11 +3863,12 @@
         'from pack-0.92-subtree (and anything compatible with '
         'pack-0.92-subtree) format repositories. Repositories and branches in '
         'this format can only be read by bzr.dev. Please read '
-        'http://doc.bazaar-vcs.org/latest/developers/development-repo.html '
+        'http://doc.bazaar.canonical.com/latest/developers/development-repo.html '
         'before use.',
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat6',
     experimental=True,
+    hidden=True,
     alias=False, # Restore to being an alias when an actual development subtree format is added
                  # This current non-alias status is simply because we did not introduce a
                  # chk based subtree format.
@@ -3870,7 +3879,7 @@
     'bzrlib.repofmt.groupcompress_repo.RepositoryFormatCHK1',
     help='pack-1.9 with 255-way hashed CHK inv, group compress, rich roots '
         'Please read '
-        'http://doc.bazaar-vcs.org/latest/developers/development-repo.html '
+        'http://doc.bazaar.canonical.com/latest/developers/development-repo.html '
         'before use.',
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat6',
@@ -3882,7 +3891,7 @@
     'bzrlib.repofmt.groupcompress_repo.RepositoryFormatCHK2',
     help='pack-1.9 with 255-way hashed CHK inv, bencode revision, group compress, '
         'rich roots. Please read '
-        'http://doc.bazaar-vcs.org/latest/developers/development-repo.html '
+        'http://doc.bazaar.canonical.com/latest/developers/development-repo.html '
         'before use.',
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat6',
@@ -3909,6 +3918,7 @@
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat6',
     alias=True,
+    hidden=True,
     help='Same as 2a.')
 
 # The current format that is made on 'bzr init'.

=== modified file 'bzrlib/chk_map.py'
--- bzrlib/chk_map.py	2009-11-02 17:27:52 +0000
+++ bzrlib/chk_map.py	2010-01-29 15:18:58 +0000
@@ -38,6 +38,7 @@
 """
 
 import heapq
+import threading
 
 from bzrlib import lazy_import
 lazy_import.lazy_import(globals(), """
@@ -59,11 +60,31 @@
 # If each line is 50 bytes, and you have 255 internal pages, with 255-way fan
 # out, it takes 3.1MB to cache the layer.
 _PAGE_CACHE_SIZE = 4*1024*1024
-# We are caching bytes so len(value) is perfectly accurate
-_page_cache = lru_cache.LRUSizeCache(_PAGE_CACHE_SIZE)
+# Per thread caches for 2 reasons:
+# - in the server we may be serving very different content, so we get less
+#   cache thrashing.
+# - we avoid locking on every cache lookup.
+_thread_caches = threading.local()
+# The page cache.
+_thread_caches.page_cache = None
+
+def _get_cache():
+    """Get the per-thread page cache.
+
+    We need a function to do this because in a new thread the _thread_caches
+    threading.local object does not have the cache initialized yet.
+    """
+    page_cache = getattr(_thread_caches, 'page_cache', None)
+    if page_cache is None:
+        # We are caching bytes so len(value) is perfectly accurate
+        page_cache = lru_cache.LRUSizeCache(_PAGE_CACHE_SIZE)
+        _thread_caches.page_cache = page_cache
+    return page_cache
+
 
 def clear_cache():
-    _page_cache.clear()
+    _get_cache().clear()
+
 
 # If a ChildNode falls below this many bytes, we check for a remap
 _INTERESTING_NEW_SIZE = 50
@@ -161,11 +182,11 @@
 
     def _read_bytes(self, key):
         try:
-            return _page_cache[key]
+            return _get_cache()[key]
         except KeyError:
             stream = self._store.get_record_stream([key], 'unordered', True)
             bytes = stream.next().get_bytes_as('fulltext')
-            _page_cache[key] = bytes
+            _get_cache()[key] = bytes
             return bytes
 
     def _dump_tree(self, include_keys=False):
@@ -901,7 +922,7 @@
         bytes = ''.join(lines)
         if len(bytes) != self._current_size():
             raise AssertionError('Invalid _current_size')
-        _page_cache.add(self._key, bytes)
+        _get_cache().add(self._key, bytes)
         return [self._key]
 
     def refs(self):
@@ -1143,7 +1164,7 @@
             found_keys = set()
             for key in keys:
                 try:
-                    bytes = _page_cache[key]
+                    bytes = _get_cache()[key]
                 except KeyError:
                     continue
                 else:
@@ -1174,7 +1195,7 @@
                     prefix, node_key_filter = keys[record.key]
                     node_and_filters.append((node, node_key_filter))
                     self._items[prefix] = node
-                    _page_cache.add(record.key, bytes)
+                    _get_cache().add(record.key, bytes)
                 for info in node_and_filters:
                     yield info
 
@@ -1300,7 +1321,7 @@
             lines.append(serialised[prefix_len:])
         sha1, _, _ = store.add_lines((None,), (), lines)
         self._key = StaticTuple("sha1:" + sha1,).intern()
-        _page_cache.add(self._key, ''.join(lines))
+        _get_cache().add(self._key, ''.join(lines))
         yield self._key
 
     def _search_key(self, key):
@@ -1489,11 +1510,11 @@
         self._state = None
 
     def _read_nodes_from_store(self, keys):
-        # We chose not to use _page_cache, because we think in terms of records
-        # to be yielded. Also, we expect to touch each page only 1 time during
-        # this code. (We may want to evaluate saving the raw bytes into the
-        # page cache, which would allow a working tree update after the fetch
-        # to not have to read the bytes again.)
+        # We chose not to use _get_cache(), because we think in
+        # terms of records to be yielded. Also, we expect to touch each page
+        # only 1 time during this code. (We may want to evaluate saving the
+        # raw bytes into the page cache, which would allow a working tree
+        # update after the fetch to not have to read the bytes again.)
         as_st = StaticTuple.from_sequence
         stream = self._store.get_record_stream(keys, 'unordered', True)
         for record in stream:

=== modified file 'bzrlib/decorators.py'
--- bzrlib/decorators.py	2009-10-15 02:19:43 +0000
+++ bzrlib/decorators.py	2010-01-20 16:05:28 +0000
@@ -253,3 +253,80 @@
     global needs_read_lock, needs_write_lock
     needs_read_lock = _pretty_needs_read_lock
     needs_write_lock = _pretty_needs_write_lock
+
+
+# This implementation of cachedproperty is copied from Launchpad's
+# canonical.launchpad.cachedproperty module (with permission from flacoste)
+# -- spiv & vila 100120
+def cachedproperty(attrname_or_fn):
+    """A decorator for methods that makes them properties with their return
+    value cached.
+
+    The value is cached on the instance, using the attribute name provided.
+
+    If you don't provide a name, the mangled name of the property is used.
+
+    >>> class CachedPropertyTest(object):
+    ...
+    ...     @cachedproperty('_foo_cache')
+    ...     def foo(self):
+    ...         print 'foo computed'
+    ...         return 23
+    ...
+    ...     @cachedproperty
+    ...     def bar(self):
+    ...         print 'bar computed'
+    ...         return 69
+
+    >>> cpt = CachedPropertyTest()
+    >>> getattr(cpt, '_foo_cache', None) is None
+    True
+    >>> cpt.foo
+    foo computed
+    23
+    >>> cpt.foo
+    23
+    >>> cpt._foo_cache
+    23
+    >>> cpt.bar
+    bar computed
+    69
+    >>> cpt._bar_cached_value
+    69
+
+    """
+    if isinstance(attrname_or_fn, basestring):
+        attrname = attrname_or_fn
+        return _CachedPropertyForAttr(attrname)
+    else:
+        fn = attrname_or_fn
+        attrname = '_%s_cached_value' % fn.__name__
+        return _CachedProperty(attrname, fn)
+
+
+class _CachedPropertyForAttr(object):
+
+    def __init__(self, attrname):
+        self.attrname = attrname
+
+    def __call__(self, fn):
+        return _CachedProperty(self.attrname, fn)
+
+
+class _CachedProperty(object):
+
+    def __init__(self, attrname, fn):
+        self.fn = fn
+        self.attrname = attrname
+        self.marker = object()
+
+    def __get__(self, inst, cls=None):
+        if inst is None:
+            return self
+        cachedresult = getattr(inst, self.attrname, self.marker)
+        if cachedresult is self.marker:
+            result = self.fn(inst)
+            setattr(inst, self.attrname, result)
+            return result
+        else:
+            return cachedresult

=== modified file 'bzrlib/diff.py'
--- bzrlib/diff.py	2009-12-03 07:36:17 +0000
+++ bzrlib/diff.py	2010-01-20 23:26:31 +0000
@@ -453,7 +453,10 @@
 
 def _patch_header_date(tree, file_id, path):
     """Returns a timestamp suitable for use in a patch header."""
-    mtime = tree.get_file_mtime(file_id, path)
+    try:
+        mtime = tree.get_file_mtime(file_id, path)
+    except errors.FileTimestampUnavailable:
+        mtime = 0
     return timestamp.format_patch_date(mtime)
 
 
@@ -747,7 +750,10 @@
             source.close()
         if not allow_write:
             osutils.make_readonly(full_path)
-        mtime = tree.get_file_mtime(file_id)
+        try:
+            mtime = tree.get_file_mtime(file_id)
+        except errors.FileTimestampUnavailable:
+            mtime = 0
         os.utime(full_path, (mtime, mtime))
         return full_path
 

=== modified file 'bzrlib/doc_generate/autodoc_man.py'
--- bzrlib/doc_generate/autodoc_man.py	2009-11-04 12:25:49 +0000
+++ bzrlib/doc_generate/autodoc_man.py	2010-01-29 10:36:23 +0000
@@ -241,7 +241,7 @@
 .br
 log10 = log --short -r -10..-1
 .SH "SEE ALSO"
-.UR http://www.bazaar-vcs.org/
-.BR http://www.bazaar-vcs.org/
+.UR http://www.bazaar.canonical.com/
+.BR http://www.bazaar.canonical.com/
 """
 

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2010-01-12 02:48:41 +0000
+++ bzrlib/errors.py	2010-01-20 22:32:07 +0000
@@ -3114,3 +3114,13 @@
     def __init__(self, source_branch, target_branch):
         self.source_branch = source_branch
         self.target_branch = target_branch
+
+
+class FileTimestampUnavailable(BzrError):
+
+    _fmt = "The filestamp for %(path)s is not available."
+
+    internal_error = True
+
+    def __init__(self, path):
+        self.path = path

=== modified file 'bzrlib/export/dir_exporter.py'
--- bzrlib/export/dir_exporter.py	2009-12-18 05:38:40 +0000
+++ bzrlib/export/dir_exporter.py	2010-02-01 22:22:28 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2009 Canonical Ltd
+# Copyright (C) 2005, 2009-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,12 +14,12 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-"""Export a Tree to a non-versioned directory.
-"""
+"""Export a bzrlib.tree.Tree to a new or empty directory."""
 
 import errno
 import os
 import StringIO
+import time
 
 from bzrlib import errors, osutils
 from bzrlib.export import _export_iter_entries
@@ -33,14 +33,11 @@
 def dir_exporter(tree, dest, root, subdir, filtered=False):
     """Export this tree to a new directory.
 
-    `dest` should not exist, and will be created holding the
-    contents of this tree.
-
-    TODO: To handle subdirectories we need to create the
-           directories first.
+    `dest` should either not exist or should be empty. If it does not exist it
+    will be created holding the contents of this tree.
 
     :note: If the export fails, the destination directory will be
-           left in a half-assed state.
+           left in an incompletely exported state: export is not transactional.
     """
     mutter('export version %r', tree)
     try:
@@ -79,6 +76,7 @@
     # The data returned here can be in any order, but we've already created all
     # the directories
     flags = os.O_CREAT | os.O_TRUNC | os.O_WRONLY | getattr(os, 'O_BINARY', 0)
+    now = time.time()
     for (relpath, executable), chunks in tree.iter_files_bytes(to_fetch):
         if filtered:
             filters = tree._content_filter_stack(relpath)
@@ -94,3 +92,4 @@
             out.writelines(chunks)
         finally:
             out.close()
+        os.utime(fullpath, (now, now))

=== modified file 'bzrlib/fetch.py'
--- bzrlib/fetch.py	2009-12-01 22:34:04 +0000
+++ bzrlib/fetch.py	2010-02-01 17:00:29 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008, 2009 Canonical Ltd
+# Copyright (C) 2005, 2006, 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -254,7 +254,9 @@
         root_id_order.sort(key=operator.itemgetter(0))
         # Create a record stream containing the roots to create.
         if len(revs) > 100:
-            graph = _get_rich_root_heads_graph(self.source_repo, revs)
+            # XXX: not covered by tests, should have a flag to always run
+            # this. -- mbp 20100129
+            graph = _get_rich_root_heads_graph(self.source, revs)
         new_roots_stream = _new_root_data_stream(
             root_id_order, rev_id_to_root_id, parent_map, self.source, graph)
         return [('texts', new_roots_stream)]

=== modified file 'bzrlib/foreign.py'
--- bzrlib/foreign.py	2009-10-27 21:54:26 +0000
+++ bzrlib/foreign.py	2010-02-01 11:40:56 +0000
@@ -225,19 +225,9 @@
         """Get the default mapping for this repository."""
         raise NotImplementedError(self.get_default_mapping)
 
-    def get_inventory_xml(self, revision_id):
-        """See Repository.get_inventory_xml()."""
-        return self.serialise_inventory(self.get_inventory(revision_id))
-
-    def get_inventory_sha1(self, revision_id):
-        """Get the sha1 for the XML representation of an inventory.
-
-        :param revision_id: Revision id of the inventory for which to return
-         the SHA1.
-        :return: XML string
-        """
-
-        return osutils.sha_string(self.get_inventory_xml(revision_id))
+    def _get_inventory_xml(self, revision_id):
+        """See Repository._get_inventory_xml()."""
+        return self._serialise_inventory(self.get_inventory(revision_id))
 
     def get_revision_xml(self, revision_id):
         """Return the XML representation of a revision.

=== modified file 'bzrlib/globbing.py'
--- bzrlib/globbing.py	2009-11-11 21:38:02 +0000
+++ bzrlib/globbing.py	2010-01-11 16:44:02 +0000
@@ -215,6 +215,40 @@
                 return patterns[match.lastindex -1]
         return None
 
+class ExceptionGlobster(object):
+    """A Globster that supports exception patterns.
+    
+    Exceptions are ignore patterns prefixed with '!'.  Exception
+    patterns take precedence over regular patterns and cause a 
+    matching filename to return None from the match() function.  
+    Patterns using a '!!' prefix are highest precedence, and act 
+    as regular ignores. '!!' patterns are useful to establish ignores
+    that apply under paths specified by '!' exception patterns.
+    """
+    
+    def __init__(self,patterns):
+        ignores = [[], [], []]
+        for p in patterns:
+            if p.startswith(u'!!'):
+                ignores[2].append(p[2:])
+            elif p.startswith(u'!'):
+                ignores[1].append(p[1:])
+            else:
+                ignores[0].append(p)
+        self._ignores = [Globster(i) for i in ignores]
+        
+    def match(self, filename):
+        """Searches for a pattern that matches the given filename.
+
+        :return A matching pattern or None if there is no matching pattern.
+        """
+        double_neg = self._ignores[2].match(filename)
+        if double_neg:
+            return "!!%s" % double_neg
+        elif self._ignores[1].match(filename):
+            return None
+        else:
+            return self._ignores[0].match(filename)
 
 class _OrderedGlobster(Globster):
     """A Globster that keeps pattern order."""
@@ -244,8 +278,7 @@
 
     Doesn't normalize regular expressions - they may contain escapes.
     """
-
-    if not pattern.startswith('RE:'):
+    if not (pattern.startswith('RE:') or pattern.startswith('!RE:')):
         pattern = _slashes.sub('/', pattern)
     if len(pattern) > 1:
         pattern = pattern.rstrip('/')

=== modified file 'bzrlib/help_topics/__init__.py'
--- bzrlib/help_topics/__init__.py	2010-01-08 07:34:31 +0000
+++ bzrlib/help_topics/__init__.py	2010-01-29 10:36:23 +0000
@@ -276,7 +276,7 @@
 
 _basic_help = \
 """Bazaar -- a free distributed version-control tool
-http://bazaar-vcs.org/
+http://www.bazaar.canonical.com/
 
 Basic commands:
   bzr init           makes this directory a versioned branch
@@ -520,11 +520,19 @@
 branch history is stored), but multiple branches may share the same
 repository (a shared repository). Branches can be copied and merged.
 
+In addition, one branch may be bound to another one.  Binding to another
+branch indicates that commits which happen in this branch must also 
+happen in the other branch.  Bazaar ensures consistency by not allowing 
+commits when the two branches are out of date.  In order for a commit 
+to succeed, it may be necessary to update the current branch using 
+``bzr update``.
+
 Related commands::
 
   init    Change a directory into a versioned branch.
   branch  Create a new branch that is a copy of an existing branch.
   merge   Perform a three-way merge.
+  bind    Bind a branch to another one.
 """
 
 

=== modified file 'bzrlib/help_topics/en/patterns.txt'
--- bzrlib/help_topics/en/patterns.txt	2008-06-25 07:17:14 +0000
+++ bzrlib/help_topics/en/patterns.txt	2010-01-02 07:36:36 +0000
@@ -23,3 +23,6 @@
 patterns are identified by a 'RE:' prefix followed by the regular
 expression.  Regular expression patterns may not include named or
 numbered groups.
+
+Ignore patterns may be prefixed with '!', which means that a filename
+matched by that pattern will not be ignored.

=== modified file 'bzrlib/hooks.py'
--- bzrlib/hooks.py	2010-01-03 03:49:07 +0000
+++ bzrlib/hooks.py	2010-01-15 03:58:20 +0000
@@ -45,6 +45,8 @@
     'bzrlib.info', 'InfoHooks')
 known_hooks.register_lazy(('bzrlib.lock', 'Lock.hooks'), 'bzrlib.lock',
     'LockHooks')
+known_hooks.register_lazy(('bzrlib.merge', 'Merger.hooks'), 'bzrlib.merge',
+    'MergeHooks')
 known_hooks.register_lazy(('bzrlib.msgeditor', 'hooks'), 'bzrlib.msgeditor',
     'MessageEditorHooks')
 known_hooks.register_lazy(('bzrlib.mutabletree', 'MutableTree.hooks'),

=== modified file 'bzrlib/log.py'
--- bzrlib/log.py	2010-01-05 02:13:02 +0000
+++ bzrlib/log.py	2010-01-23 11:37:40 +0000
@@ -88,6 +88,10 @@
     re_compile_checked,
     terminal_width,
     )
+from bzrlib.symbol_versioning import (
+    deprecated_function,
+    deprecated_in,
+    )
 
 
 def find_touching_revisions(branch, file_id):
@@ -304,7 +308,7 @@
 
 
 class Logger(object):
-    """An object the generates, formats and displays a log."""
+    """An object that generates, formats and displays a log."""
 
     def __init__(self, branch, rqst):
         """Create a Logger.
@@ -597,6 +601,8 @@
         else:
             # not obvious
             return False
+    # if either start or end is not specified then we use either the first or
+    # the last revision and *they* are obvious ancestors.
     return True
 
 
@@ -664,11 +670,16 @@
                 depth_adjustment = merge_depth
             if depth_adjustment:
                 if merge_depth < depth_adjustment:
+                    # From now on we reduce the depth adjustement, this can be
+                    # surprising for users. The alternative requires two passes
+                    # which breaks the fast display of the first revision
+                    # though.
                     depth_adjustment = merge_depth
                 merge_depth -= depth_adjustment
             yield rev_id, '.'.join(map(str, revno)), merge_depth
 
 
+@deprecated_function(deprecated_in((2, 2, 0)))
 def calculate_view_revisions(branch, start_revision, end_revision, direction,
         specific_fileid, generate_merge_revisions):
     """Calculate the revisions to view.
@@ -676,9 +687,6 @@
     :return: An iterator of (revision_id, dotted_revno, merge_depth) tuples OR
              a list of the same tuples.
     """
-    # This method is no longer called by the main code path.
-    # It is retained for API compatibility and may be deprecated
-    # soon. IGC 20090116
     start_rev_id, end_rev_id = _get_revision_limits(branch, start_revision,
         end_revision)
     view_revisions = list(_calc_view_revisions(branch, start_rev_id, end_rev_id,
@@ -1034,6 +1042,7 @@
     return mainline_revs, rev_nos, start_rev_id, end_rev_id
 
 
+@deprecated_function(deprecated_in((2, 2, 0)))
 def _filter_revision_range(view_revisions, start_rev_id, end_rev_id):
     """Filter view_revisions based on revision ranges.
 
@@ -1048,8 +1057,6 @@
 
     :return: The filtered view_revisions.
     """
-    # This method is no longer called by the main code path.
-    # It may be removed soon. IGC 20090127
     if start_rev_id or end_rev_id:
         revision_ids = [r for r, n, d in view_revisions]
         if start_rev_id:
@@ -1161,15 +1168,13 @@
     return result
 
 
+@deprecated_function(deprecated_in((2, 2, 0)))
 def get_view_revisions(mainline_revs, rev_nos, branch, direction,
                        include_merges=True):
     """Produce an iterator of revisions to show
     :return: an iterator of (revision_id, revno, merge_depth)
     (if there is no revno for a revision, None is supplied)
     """
-    # This method is no longer called by the main code path.
-    # It is retained for API compatibility and may be deprecated
-    # soon. IGC 20090127
     if not include_merges:
         revision_ids = mainline_revs[1:]
         if direction == 'reverse':
@@ -1293,8 +1298,8 @@
     preferred_levels = 0
 
     def __init__(self, to_file, show_ids=False, show_timezone='original',
-            delta_format=None, levels=None, show_advice=False,
-            to_exact_file=None):
+                 delta_format=None, levels=None, show_advice=False,
+                 to_exact_file=None):
         """Create a LogFormatter.
 
         :param to_file: the file to output to

=== modified file 'bzrlib/merge.py'
--- bzrlib/merge.py	2009-12-18 08:22:42 +0000
+++ bzrlib/merge.py	2010-01-29 08:28:47 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,8 +19,10 @@
     branch as _mod_branch,
     conflicts as _mod_conflicts,
     debug,
+    decorators,
     errors,
     graph as _mod_graph,
+    hooks,
     merge3,
     osutils,
     patiencediff,
@@ -50,7 +52,161 @@
         from_tree.unlock()
 
 
+class MergeHooks(hooks.Hooks):
+
+    def __init__(self):
+        hooks.Hooks.__init__(self)
+        self.create_hook(hooks.HookPoint('merge_file_content',
+            "Called with a bzrlib.merge.Merger object to create a per file "
+            "merge object when starting a merge. "
+            "Should return either None or a subclass of "
+            "``bzrlib.merge.AbstractPerFileMerger``. "
+            "Such objects will then be called per file "
+            "that needs to be merged (including when one "
+            "side has deleted the file and the other has changed it). "
+            "See the AbstractPerFileMerger API docs for details on how it is "
+            "used by merge.",
+            (2, 1), None))
+
+
+class AbstractPerFileMerger(object):
+    """PerFileMerger objects are used by plugins extending merge for bzrlib.
+
+    See ``bzrlib.plugins.news_merge.news_merge`` for an example concrete class.
+    
+    :ivar merger: The Merge3Merger performing the merge.
+    """
+
+    def __init__(self, merger):
+        """Create a PerFileMerger for use with merger."""
+        self.merger = merger
+
+    def merge_contents(self, merge_params):
+        """Attempt to merge the contents of a single file.
+        
+        :param merge_params: A bzrlib.merge.MergeHookParams
+        :return : A tuple of (status, chunks), where status is one of
+            'not_applicable', 'success', 'conflicted', or 'delete'.  If status
+            is 'success' or 'conflicted', then chunks should be an iterable of
+            strings for the new file contents.
+        """
+        return ('not applicable', None)
+
+
+class ConfigurableFileMerger(AbstractPerFileMerger):
+    """Merge individual files when configured via a .conf file.
+
+    This is a base class for concrete custom file merging logic. Concrete
+    classes should implement ``merge_text``.
+
+    :ivar affected_files: The configured file paths to merge.
+    :cvar name_prefix: The prefix to use when looking up configuration
+        details.
+    :cvar default_files: The default file paths to merge when no configuration
+        is present.
+    """
+
+    name_prefix = None
+    default_files = None
+
+    def __init__(self, merger):
+        super(ConfigurableFileMerger, self).__init__(merger)
+        self.affected_files = None
+        self.default_files = self.__class__.default_files or []
+        self.name_prefix = self.__class__.name_prefix
+        if self.name_prefix is None:
+            raise ValueError("name_prefix must be set.")
+
+    def filename_matches_config(self, params):
+        affected_files = self.affected_files
+        if affected_files is None:
+            config = self.merger.this_tree.branch.get_config()
+            # Until bzr provides a better policy for caching the config, we
+            # just add the part we're interested in to the params to avoid
+            # reading the config files repeatedly (bazaar.conf, location.conf,
+            # branch.conf).
+            config_key = self.name_prefix + '_merge_files'
+            affected_files = config.get_user_option_as_list(config_key)
+            if affected_files is None:
+                # If nothing was specified in the config, use the default.
+                affected_files = self.default_files
+            self.affected_files = affected_files
+        if affected_files:
+            filename = self.merger.this_tree.id2path(params.file_id)
+            if filename in affected_files:
+                return True
+        return False
+
+    def merge_contents(self, params):
+        """Merge the contents of a single file."""
+        # First, check whether this custom merge logic should be used.  We
+        # expect most files should not be merged by this handler.
+        if (
+            # OTHER is a straight winner, rely on default merge.
+            params.winner == 'other' or
+            # THIS and OTHER aren't both files.
+            not params.is_file_merge() or
+            # The filename isn't listed in the 'NAME_merge_files' config
+            # option.
+            not self.filename_matches_config(params)):
+            return 'not_applicable', None
+        return self.merge_text(self, params)
+
+    def merge_text(self, params):
+        """Merge the byte contents of a single file.
+
+        This is called after checking that the merge should be performed in
+        merge_contents, and it should behave as per
+        ``bzrlib.merge.AbstractPerFileMerger.merge_contents``.
+        """
+        raise NotImplementedError(self.merge_text)
+
+
+class MergeHookParams(object):
+    """Object holding parameters passed to merge_file_content hooks.
+
+    There are some fields hooks can access:
+
+    :ivar file_id: the file ID of the file being merged
+    :ivar trans_id: the transform ID for the merge of this file
+    :ivar this_kind: kind of file_id in 'this' tree
+    :ivar other_kind: kind of file_id in 'other' tree
+    :ivar winner: one of 'this', 'other', 'conflict'
+    """
+
+    def __init__(self, merger, file_id, trans_id, this_kind, other_kind,
+            winner):
+        self._merger = merger
+        self.file_id = file_id
+        self.trans_id = trans_id
+        self.this_kind = this_kind
+        self.other_kind = other_kind
+        self.winner = winner
+
+    def is_file_merge(self):
+        """True if this_kind and other_kind are both 'file'."""
+        return self.this_kind == 'file' and self.other_kind == 'file'
+
+    @decorators.cachedproperty
+    def base_lines(self):
+        """The lines of the 'base' version of the file."""
+        return self._merger.get_lines(self._merger.base_tree, self.file_id)
+
+    @decorators.cachedproperty
+    def this_lines(self):
+        """The lines of the 'this' version of the file."""
+        return self._merger.get_lines(self._merger.this_tree, self.file_id)
+
+    @decorators.cachedproperty
+    def other_lines(self):
+        """The lines of the 'other' version of the file."""
+        return self._merger.get_lines(self._merger.other_tree, self.file_id)
+
+
 class Merger(object):
+
+    hooks = MergeHooks()
+
     def __init__(self, this_branch, other_tree=None, base_tree=None,
                  this_tree=None, pb=None, change_reporter=None,
                  recurse='down', revision_graph=None):
@@ -432,7 +588,7 @@
                   'other_tree': self.other_tree,
                   'interesting_ids': self.interesting_ids,
                   'interesting_files': self.interesting_files,
-                  'pp': self.pp,
+                  'pp': self.pp, 'this_branch': self.this_branch,
                   'do_merge': False}
         if self.merge_type.requires_base:
             kwargs['base_tree'] = self.base_tree
@@ -542,13 +698,14 @@
                  interesting_ids=None, reprocess=False, show_base=False,
                  pb=progress.DummyProgress(), pp=None, change_reporter=None,
                  interesting_files=None, do_merge=True,
-                 cherrypick=False, lca_trees=None):
+                 cherrypick=False, lca_trees=None, this_branch=None):
         """Initialize the merger object and perform the merge.
 
         :param working_tree: The working tree to apply the merge to
         :param this_tree: The local tree in the merge operation
         :param base_tree: The common tree in the merge operation
         :param other_tree: The other tree to merge changes from
+        :param this_branch: The branch associated with this_tree
         :param interesting_ids: The file_ids of files that should be
             participate in the merge.  May not be combined with
             interesting_files.
@@ -577,6 +734,7 @@
         self.this_tree = working_tree
         self.base_tree = base_tree
         self.other_tree = other_tree
+        self.this_branch = this_branch
         self._raw_conflicts = []
         self.cooked_conflicts = []
         self.reprocess = reprocess
@@ -643,12 +801,15 @@
             resolver = self._lca_multi_way
         child_pb = ui.ui_factory.nested_progress_bar()
         try:
+            factories = Merger.hooks['merge_file_content']
+            hooks = [factory(self) for factory in factories] + [self]
+            self.active_hooks = [hook for hook in hooks if hook is not None]
             for num, (file_id, changed, parents3, names3,
                       executable3) in enumerate(entries):
                 child_pb.update('Preparing file merge', num, len(entries))
                 self._merge_names(file_id, parents3, names3, resolver=resolver)
                 if changed:
-                    file_status = self.merge_contents(file_id)
+                    file_status = self._do_merge_contents(file_id)
                 else:
                     file_status = 'unmodified'
                 self._merge_executable(file_id,
@@ -892,7 +1053,7 @@
             self.tt.final_kind(other_root)
         except errors.NoSuchFile:
             return
-        if self.other_tree.inventory.root.file_id in self.this_tree.inventory:
+        if self.this_tree.has_id(self.other_tree.inventory.root.file_id):
             # the other tree's root is a non-root in the current tree
             return
         self.reparent_children(self.other_tree.inventory.root, self.tt.root)
@@ -940,7 +1101,7 @@
     @staticmethod
     def executable(tree, file_id):
         """Determine the executability of a file-id (used as a key method)."""
-        if file_id not in tree:
+        if not tree.has_id(file_id):
             return None
         if tree.kind(file_id) != "file":
             return False
@@ -949,7 +1110,7 @@
     @staticmethod
     def kind(tree, file_id):
         """Determine the kind of a file-id (used as a key method)."""
-        if file_id not in tree:
+        if not tree.has_id(file_id):
             return None
         return tree.kind(file_id)
 
@@ -1038,7 +1199,7 @@
 
     def merge_names(self, file_id):
         def get_entry(tree):
-            if file_id in tree.inventory:
+            if tree.has_id(file_id):
                 return tree.inventory[file_id]
             else:
                 return None
@@ -1093,7 +1254,7 @@
             self.tt.adjust_path(names[self.winner_idx[name_winner]],
                                 parent_trans_id, trans_id)
 
-    def merge_contents(self, file_id):
+    def _do_merge_contents(self, file_id):
         """Performs a merge on file_id contents."""
         def contents_pair(tree):
             if file_id not in tree:
@@ -1107,18 +1268,6 @@
                 contents = None
             return kind, contents
 
-        def contents_conflict():
-            trans_id = self.tt.trans_id_file_id(file_id)
-            name = self.tt.final_name(trans_id)
-            parent_id = self.tt.final_parent(trans_id)
-            if file_id in self.this_tree.inventory:
-                self.tt.unversion_file(trans_id)
-                if file_id in self.this_tree:
-                    self.tt.delete_contents(trans_id)
-            file_group = self._dump_conflicts(name, parent_id, file_id,
-                                              set_version=True)
-            self._raw_conflicts.append(('contents conflict', file_group))
-
         # See SPOT run.  run, SPOT, run.
         # So we're not QUITE repeating ourselves; we do tricky things with
         # file kind...
@@ -1140,63 +1289,115 @@
         if winner == 'this':
             # No interesting changes introduced by OTHER
             return "unmodified"
+        # We have a hypothetical conflict, but if we have files, then we
+        # can try to merge the content
         trans_id = self.tt.trans_id_file_id(file_id)
-        if winner == 'other':
+        params = MergeHookParams(self, file_id, trans_id, this_pair[0],
+            other_pair[0], winner)
+        hooks = self.active_hooks
+        hook_status = 'not_applicable'
+        for hook in hooks:
+            hook_status, lines = hook.merge_contents(params)
+            if hook_status != 'not_applicable':
+                # Don't try any more hooks, this one applies.
+                break
+        result = "modified"
+        if hook_status == 'not_applicable':
+            # This is a contents conflict, because none of the available
+            # functions could merge it.
+            result = None
+            name = self.tt.final_name(trans_id)
+            parent_id = self.tt.final_parent(trans_id)
+            if self.this_tree.has_id(file_id):
+                self.tt.unversion_file(trans_id)
+            file_group = self._dump_conflicts(name, parent_id, file_id,
+                                              set_version=True)
+            self._raw_conflicts.append(('contents conflict', file_group))
+        elif hook_status == 'success':
+            self.tt.create_file(lines, trans_id)
+        elif hook_status == 'conflicted':
+            # XXX: perhaps the hook should be able to provide
+            # the BASE/THIS/OTHER files?
+            self.tt.create_file(lines, trans_id)
+            self._raw_conflicts.append(('text conflict', trans_id))
+            name = self.tt.final_name(trans_id)
+            parent_id = self.tt.final_parent(trans_id)
+            self._dump_conflicts(name, parent_id, file_id)
+        elif hook_status == 'delete':
+            self.tt.unversion_file(trans_id)
+            result = "deleted"
+        elif hook_status == 'done':
+            # The hook function did whatever it needs to do directly, no
+            # further action needed here.
+            pass
+        else:
+            raise AssertionError('unknown hook_status: %r' % (hook_status,))
+        if not self.this_tree.has_id(file_id) and result == "modified":
+            self.tt.version_file(file_id, trans_id)
+        # The merge has been performed, so the old contents should not be
+        # retained.
+        try:
+            self.tt.delete_contents(trans_id)
+        except errors.NoSuchFile:
+            pass
+        return result
+
+    def _default_other_winner_merge(self, merge_hook_params):
+        """Replace this contents with other."""
+        file_id = merge_hook_params.file_id
+        trans_id = merge_hook_params.trans_id
+        file_in_this = self.this_tree.has_id(file_id)
+        if self.other_tree.has_id(file_id):
+            # OTHER changed the file
+            wt = self.this_tree
+            if wt.supports_content_filtering():
+                # We get the path from the working tree if it exists.
+                # That fails though when OTHER is adding a file, so
+                # we fall back to the other tree to find the path if
+                # it doesn't exist locally.
+                try:
+                    filter_tree_path = wt.id2path(file_id)
+                except errors.NoSuchId:
+                    filter_tree_path = self.other_tree.id2path(file_id)
+            else:
+                # Skip the id2path lookup for older formats
+                filter_tree_path = None
+            transform.create_from_tree(self.tt, trans_id,
+                             self.other_tree, file_id,
+                             filter_tree_path=filter_tree_path)
+            return 'done', None
+        elif file_in_this:
+            # OTHER deleted the file
+            return 'delete', None
+        else:
+            raise AssertionError(
+                'winner is OTHER, but file_id %r not in THIS or OTHER tree'
+                % (file_id,))
+
+    def merge_contents(self, merge_hook_params):
+        """Fallback merge logic after user installed hooks."""
+        # This function is used in merge hooks as the fallback instance.
+        # Perhaps making this function and the functions it calls be a 
+        # a separate class would be better.
+        if merge_hook_params.winner == 'other':
             # OTHER is a straight winner, so replace this contents with other
-            file_in_this = file_id in self.this_tree
-            if file_in_this:
-                # Remove any existing contents
-                self.tt.delete_contents(trans_id)
-            if file_id in self.other_tree:
-                # OTHER changed the file
-                wt = self.this_tree
-                if wt.supports_content_filtering():
-                    # We get the path from the working tree if it exists.
-                    # That fails though when OTHER is adding a file, so
-                    # we fall back to the other tree to find the path if
-                    # it doesn't exist locally.
-                    try:
-                        filter_tree_path = wt.id2path(file_id)
-                    except errors.NoSuchId:
-                        filter_tree_path = self.other_tree.id2path(file_id)
-                else:
-                    # Skip the id2path lookup for older formats
-                    filter_tree_path = None
-                transform.create_from_tree(self.tt, trans_id,
-                                 self.other_tree, file_id,
-                                 filter_tree_path=filter_tree_path)
-                if not file_in_this:
-                    self.tt.version_file(file_id, trans_id)
-                return "modified"
-            elif file_in_this:
-                # OTHER deleted the file
-                self.tt.unversion_file(trans_id)
-                return "deleted"
+            return self._default_other_winner_merge(merge_hook_params)
+        elif merge_hook_params.is_file_merge():
+            # THIS and OTHER are both files, so text merge.  Either
+            # BASE is a file, or both converted to files, so at least we
+            # have agreement that output should be a file.
+            try:
+                self.text_merge(merge_hook_params.file_id,
+                    merge_hook_params.trans_id)
+            except errors.BinaryFile:
+                return 'not_applicable', None
+            return 'done', None
         else:
-            # We have a hypothetical conflict, but if we have files, then we
-            # can try to merge the content
-            if this_pair[0] == 'file' and other_pair[0] == 'file':
-                # THIS and OTHER are both files, so text merge.  Either
-                # BASE is a file, or both converted to files, so at least we
-                # have agreement that output should be a file.
-                try:
-                    self.text_merge(file_id, trans_id)
-                except errors.BinaryFile:
-                    return contents_conflict()
-                if file_id not in self.this_tree:
-                    self.tt.version_file(file_id, trans_id)
-                try:
-                    self.tt.tree_kind(trans_id)
-                    self.tt.delete_contents(trans_id)
-                except errors.NoSuchFile:
-                    pass
-                return "modified"
-            else:
-                return contents_conflict()
+            return 'not_applicable', None
 
     def get_lines(self, tree, file_id):
         """Return the lines in a file, or an empty list."""
-        if file_id in tree:
+        if tree.has_id(file_id):
             return tree.get_file(file_id).readlines()
         else:
             return []
@@ -1205,7 +1406,7 @@
         """Perform a three-way text merge on a file_id"""
         # it's possible that we got here with base as a different type.
         # if so, we just want two-way text conflicts.
-        if file_id in self.base_tree and \
+        if self.base_tree.has_id(file_id) and \
             self.base_tree.kind(file_id) == "file":
             base_lines = self.get_lines(self.base_tree, file_id)
         else:
@@ -1274,7 +1475,7 @@
         versioned = False
         file_group = []
         for suffix, tree, lines in data:
-            if file_id in tree:
+            if tree.has_id(file_id):
                 trans_id = self._conflict_file(name, parent_id, tree, file_id,
                                                suffix, lines, filter_tree_path)
                 file_group.append(trans_id)
@@ -1324,11 +1525,11 @@
         if winner == "this":
             executability = this_executable
         else:
-            if file_id in self.other_tree:
+            if self.other_tree.has_id(file_id):
                 executability = other_executable
-            elif file_id in self.this_tree:
+            elif self.this_tree.has_id(file_id):
                 executability = this_executable
-            elif file_id in self.base_tree:
+            elif self.base_tree_has_id(file_id):
                 executability = base_executable
         if executability is not None:
             trans_id = self.tt.trans_id_file_id(file_id)

=== modified file 'bzrlib/plugins/launchpad/lp_registration.py'
--- bzrlib/plugins/launchpad/lp_registration.py	2009-12-09 09:20:42 +0000
+++ bzrlib/plugins/launchpad/lp_registration.py	2010-01-29 10:36:23 +0000
@@ -81,7 +81,7 @@
 class LaunchpadService(object):
     """A service to talk to Launchpad via XMLRPC.
 
-    See http://bazaar-vcs.org/Specs/LaunchpadRpc for the methods we can call.
+    See http://wiki.bazaar.canonical.com/Specs/LaunchpadRpc for the methods we can call.
     """
 
     LAUNCHPAD_DOMAINS = {

=== modified file 'bzrlib/plugins/launchpad/test_lp_api.py'
--- bzrlib/plugins/launchpad/test_lp_api.py	2009-12-17 04:35:06 +0000
+++ bzrlib/plugins/launchpad/test_lp_api.py	2010-01-25 17:48:22 +0000
@@ -39,9 +39,7 @@
 
     def patch(self, obj, name, value):
         """Temporarily set the 'name' attribute of 'obj' to 'value'."""
-        real_value = getattr(obj, name)
-        setattr(obj, name, value)
-        self.addCleanup(setattr, obj, name, real_value)
+        self.overrideAttr(obj, name, value)
 
     def test_get_launchpadlib_version(self):
         # parse_launchpadlib_version returns a tuple of a version number of

=== modified file 'bzrlib/plugins/launchpad/test_lp_directory.py'
--- bzrlib/plugins/launchpad/test_lp_directory.py	2010-01-07 03:03:01 +0000
+++ bzrlib/plugins/launchpad/test_lp_directory.py	2010-01-25 15:55:48 +0000
@@ -216,7 +216,7 @@
         directories.remove('lp:')
         directories.register('lp:', FooService, 'Map lp URLs to local urls')
         self.addCleanup(_register_directory)
-        self.addCleanup(lambda: directories.remove('lp:'))
+        self.addCleanup(directories.remove, 'lp:')
         transport = get_transport('lp:///apt')
         branch = Branch.open_from_transport(transport)
         self.assertEqual(target_branch.base, branch.base)

=== added directory 'bzrlib/plugins/news_merge'
=== added file 'bzrlib/plugins/news_merge/README'
--- bzrlib/plugins/news_merge/README	1970-01-01 00:00:00 +0000
+++ bzrlib/plugins/news_merge/README	2010-01-20 16:05:28 +0000
@@ -0,0 +1,7 @@
+A plugin for merging bzr's NEWS file.
+
+This plugin is activated via configuration variables, see 'bzr help news_merge'.
+
+This hook can resolve conflicts where both sides add entries at the same place.
+If it encounters a more difficult conflict it gives up and bzr will fallback to
+the default merge algorithm.

=== added file 'bzrlib/plugins/news_merge/__init__.py'
--- bzrlib/plugins/news_merge/__init__.py	1970-01-01 00:00:00 +0000
+++ bzrlib/plugins/news_merge/__init__.py	2010-01-28 17:27:16 +0000
@@ -0,0 +1,66 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Merge hook for bzr's NEWS file.
+
+To enable this plugin, add a section to your branch.conf or location.conf
+like::
+
+    [/home/user/code/bzr]
+    news_merge_files = NEWS
+    news_merge_files:policy = recurse
+
+The news_merge_files config option takes a list of file paths, separated by
+commas.
+
+Limitations:
+
+* if there's a conflict in more than just bullet points, this doesn't yet know
+  how to resolve that, so bzr will fallback to the default line-based merge.
+"""
+
+# Since we are a built-in plugin we share the bzrlib version
+from bzrlib import version_info
+
+# Put most of the code in a separate module that we lazy-import to keep the
+# overhead of this plugin as minimal as possible.
+from bzrlib.lazy_import import lazy_import
+lazy_import(globals(), """
+from bzrlib.plugins.news_merge import news_merge as _mod_news_merge
+""")
+
+from bzrlib.merge import Merger
+
+
+def news_merge_hook(merger):
+    """Merger.merge_file_content hook for bzr-format NEWS files."""
+    return _mod_news_merge.NewsMerger(merger)
+
+
+def install_hook():
+    Merger.hooks.install_named_hook(
+        'merge_file_content', news_merge_hook, 'NEWS file merge')
+install_hook()
+
+
+def load_tests(basic_tests, module, loader):
+    testmod_names = [
+        'tests',
+        ]
+    basic_tests.addTest(loader.loadTestsFromModuleNames(
+            ["%s.%s" % (__name__, tmn) for tmn in testmod_names]))
+    return basic_tests
+

=== added file 'bzrlib/plugins/news_merge/news_merge.py'
--- bzrlib/plugins/news_merge/news_merge.py	1970-01-01 00:00:00 +0000
+++ bzrlib/plugins/news_merge/news_merge.py	2010-01-28 18:05:44 +0000
@@ -0,0 +1,94 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Merge logic for news_merge plugin."""
+
+
+from bzrlib.plugins.news_merge.parser import simple_parse
+from bzrlib import merge, merge3
+
+
+magic_marker = '|NEWS-MERGE-MAGIC-MARKER|'
+
+
+class NewsMerger(merge.ConfigurableFileMerger):
+    """Merge bzr NEWS files."""
+
+    name_prefix = "news"
+
+    def merge_text(self, params):
+        """Perform a simple 3-way merge of a bzr NEWS file.
+        
+        Each section of a bzr NEWS file is essentially an ordered set of bullet
+        points, so we can simply take a set of bullet points, determine which
+        bullets to add and which to remove, sort, and reserialize.
+        """
+        # Transform the different versions of the NEWS file into a bunch of
+        # text lines where each line matches one part of the overall
+        # structure, e.g. a heading or bullet.
+        def munge(lines):
+            return list(blocks_to_fakelines(simple_parse(''.join(lines))))
+        this_lines = munge(params.this_lines)
+        other_lines = munge(params.other_lines)
+        base_lines = munge(params.base_lines)
+        m3 = merge3.Merge3(base_lines, this_lines, other_lines)
+        result_lines = []
+        for group in m3.merge_groups():
+            if group[0] == 'conflict':
+                _, base, a, b = group
+                # Are all the conflicting lines bullets?  If so, we can merge
+                # this.
+                for line_set in [base, a, b]:
+                    for line in line_set:
+                        if not line.startswith('bullet'):
+                            # Something else :(
+                            # Maybe the default merge can cope.
+                            return 'not_applicable', None
+                # Calculate additions and deletions.
+                new_in_a = set(a).difference(base)
+                new_in_b = set(b).difference(base)
+                all_new = new_in_a.union(new_in_b)
+                deleted_in_a = set(base).difference(a)
+                deleted_in_b = set(base).difference(b)
+                # Combine into the final set of bullet points.
+                final = all_new.difference(deleted_in_a).difference(
+                    deleted_in_b)
+                # Sort, and emit.
+                final = sorted(final, key=sort_key)
+                result_lines.extend(final)
+            else:
+                result_lines.extend(group[1])
+        # Transform the merged elements back into real blocks of lines.
+        return 'success', list(fakelines_to_blocks(result_lines))
+
+
+def blocks_to_fakelines(blocks):
+    for kind, text in blocks:
+        yield '%s%s%s' % (kind, magic_marker, text)
+
+
+def fakelines_to_blocks(fakelines):
+    fakelines = list(fakelines)
+    # Strip out the magic_marker, and reinstate the \n\n between blocks
+    for fakeline in fakelines[:-1]:
+        yield fakeline.split(magic_marker, 1)[1] + '\n\n'
+    # The final block doesn't have a trailing \n\n.
+    for fakeline in fakelines[-1:]:
+        yield fakeline.split(magic_marker, 1)[1]
+
+
+def sort_key(s):
+    return s.replace('`', '').lower()

=== added file 'bzrlib/plugins/news_merge/parser.py'
--- bzrlib/plugins/news_merge/parser.py	1970-01-01 00:00:00 +0000
+++ bzrlib/plugins/news_merge/parser.py	2010-01-18 07:00:11 +0000
@@ -0,0 +1,62 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Simple parser for bzr's NEWS file.
+
+Simple as this is, it's a bit over-powered for news_merge's needs, which only
+cares about 'bullet' and 'everything else'.
+
+This module can be run as a standalone Python program; pass it a filename and
+it will print the parsed form of a file (a series of 2-tuples, see
+simple_parse's docstring).
+"""
+
+
+def simple_parse(content):
+    """Returns blocks, where each block is a 2-tuple (kind, text).
+    
+    :kind: one of 'heading', 'release', 'section', 'empty' or 'text'.
+    :text: a str, including newlines.
+    """
+    blocks = content.split('\n\n')
+    for block in blocks:
+        if block.startswith('###'):
+            # First line is ###...: Top heading
+            yield 'heading', block
+            continue
+        last_line = block.rsplit('\n', 1)[-1]
+        if last_line.startswith('###'):
+            # last line is ###...: 2nd-level heading
+            yield 'release', block
+        elif last_line.startswith('***'):
+            # last line is ***...: 3rd-level heading
+            yield 'section', block
+        elif block.startswith('* '):
+            # bullet
+            yield 'bullet', block
+        elif block.strip() == '':
+            # empty
+            yield 'empty', block
+        else:
+            # plain text
+            yield 'text', block
+
+
+if __name__ == '__main__':
+    import sys
+    content = open(sys.argv[1], 'rb').read()
+    for result in simple_parse(content):
+        print result

=== added directory 'bzrlib/plugins/news_merge/tests'
=== added file 'bzrlib/plugins/news_merge/tests/__init__.py'
--- bzrlib/plugins/news_merge/tests/__init__.py	1970-01-01 00:00:00 +0000
+++ bzrlib/plugins/news_merge/tests/__init__.py	2010-01-20 16:05:28 +0000
@@ -0,0 +1,23 @@
+# Copyright (C) 2010 by Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+def load_tests(basic_tests, module, loader):
+    testmod_names = [
+        'test_news_merge',
+        ]
+    basic_tests.addTest(loader.loadTestsFromModuleNames(
+            ["%s.%s" % (__name__, tmn) for tmn in testmod_names]))
+    return basic_tests

=== added file 'bzrlib/plugins/news_merge/tests/test_news_merge.py'
--- bzrlib/plugins/news_merge/tests/test_news_merge.py	1970-01-01 00:00:00 +0000
+++ bzrlib/plugins/news_merge/tests/test_news_merge.py	2010-01-29 08:28:47 +0000
@@ -0,0 +1,27 @@
+# Copyright (C) 2010 by Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+# FIXME: This is totally incomplete but I'm only the patch pilot :-)
+# -- vila 100120
+# Note that the single test from this file is now in
+# test_merge.TestConfigurableFileMerger -- rbc 20100129.
+
+from bzrlib import (
+    option,
+    tests,
+    )
+from bzrlib.merge import Merger
+from bzrlib.plugins import news_merge

=== modified file 'bzrlib/remote.py'
--- bzrlib/remote.py	2010-01-11 05:58:22 +0000
+++ bzrlib/remote.py	2010-02-01 11:39:02 +0000
@@ -114,6 +114,9 @@
 
         self._probe_bzrdir()
 
+    def __repr__(self):
+        return '%s(%r)' % (self.__class__.__name__, self._client)
+
     def _probe_bzrdir(self):
         medium = self._client._medium
         path = self._path_for_remote_call(self._client)
@@ -1494,13 +1497,13 @@
         return self._real_repository.get_signature_text(revision_id)
 
     @needs_read_lock
-    def get_inventory_xml(self, revision_id):
+    def _get_inventory_xml(self, revision_id):
         self._ensure_real()
-        return self._real_repository.get_inventory_xml(revision_id)
+        return self._real_repository._get_inventory_xml(revision_id)
 
-    def deserialise_inventory(self, revision_id, xml):
+    def _deserialise_inventory(self, revision_id, xml):
         self._ensure_real()
-        return self._real_repository.deserialise_inventory(revision_id, xml)
+        return self._real_repository._deserialise_inventory(revision_id, xml)
 
     def reconcile(self, other=None, thorough=False):
         self._ensure_real()

=== modified file 'bzrlib/repofmt/groupcompress_repo.py'
--- bzrlib/repofmt/groupcompress_repo.py	2010-01-04 02:25:11 +0000
+++ bzrlib/repofmt/groupcompress_repo.py	2010-02-01 11:39:02 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -705,10 +705,11 @@
                 self._remove_pack_from_memory(pack)
         # record the newly available packs and stop advertising the old
         # packs
-        result = self._save_pack_names(clear_obsolete_packs=True)
-        # Move the old packs out of the way now they are no longer referenced.
-        for revision_count, packs in pack_operations:
-            self._obsolete_packs(packs)
+        to_be_obsoleted = []
+        for _, packs in pack_operations:
+            to_be_obsoleted.extend(packs)
+        result = self._save_pack_names(clear_obsolete_packs=True,
+                                       obsolete_packs=to_be_obsoleted)
         return result
 
 
@@ -881,7 +882,7 @@
             if basis_tree is not None:
                 basis_tree.unlock()
 
-    def deserialise_inventory(self, revision_id, bytes):
+    def _deserialise_inventory(self, revision_id, bytes):
         return inventory.CHKInventory.deserialise(self.chk_bytes, bytes,
             (revision_id,))
 
@@ -903,7 +904,7 @@
     def _iter_inventory_xmls(self, revision_ids, ordering):
         # Without a native 'xml' inventory, this method doesn't make sense.
         # However older working trees, and older bundles want it - so we supply
-        # it allowing get_inventory_xml to work. Bundles currently use the
+        # it allowing _get_inventory_xml to work. Bundles currently use the
         # serializer directly; this also isn't ideal, but there isn't an xml
         # iteration interface offered at all for repositories. We could make
         # _iter_inventory_xmls be part of the contract, even if kept private.

=== modified file 'bzrlib/repofmt/pack_repo.py'
--- bzrlib/repofmt/pack_repo.py	2010-01-04 06:56:46 +0000
+++ bzrlib/repofmt/pack_repo.py	2010-01-21 21:13:09 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -1545,10 +1545,11 @@
                 self._remove_pack_from_memory(pack)
         # record the newly available packs and stop advertising the old
         # packs
-        result = self._save_pack_names(clear_obsolete_packs=True)
-        # Move the old packs out of the way now they are no longer referenced.
-        for revision_count, packs in pack_operations:
-            self._obsolete_packs(packs)
+        to_be_obsoleted = []
+        for _, packs in pack_operations:
+            to_be_obsoleted.extend(packs)
+        result = self._save_pack_names(clear_obsolete_packs=True,
+                                       obsolete_packs=to_be_obsoleted)
         return result
 
     def _flush_new_pack(self):
@@ -1788,8 +1789,13 @@
         :param return: None.
         """
         for pack in packs:
-            pack.pack_transport.rename(pack.file_name(),
-                '../obsolete_packs/' + pack.file_name())
+            try:
+                pack.pack_transport.rename(pack.file_name(),
+                    '../obsolete_packs/' + pack.file_name())
+            except (errors.PathError, errors.TransportError), e:
+                # TODO: Should these be warnings or mutters?
+                mutter("couldn't rename obsolete pack, skipping it:\n%s"
+                       % (e,))
             # TODO: Probably needs to know all possible indices for this pack
             # - or maybe list the directory and move all indices matching this
             # name whether we recognize it or not?
@@ -1797,8 +1803,12 @@
             if self.chk_index is not None:
                 suffixes.append('.cix')
             for suffix in suffixes:
-                self._index_transport.rename(pack.name + suffix,
-                    '../obsolete_packs/' + pack.name + suffix)
+                try:
+                    self._index_transport.rename(pack.name + suffix,
+                        '../obsolete_packs/' + pack.name + suffix)
+                except (errors.PathError, errors.TransportError), e:
+                    mutter("couldn't rename obsolete index, skipping it:\n%s"
+                           % (e,))
 
     def pack_distribution(self, total_revisions):
         """Generate a list of the number of revisions to put in each pack.
@@ -1876,6 +1886,7 @@
         disk_nodes = set()
         for index, key, value in self._iter_disk_pack_index():
             disk_nodes.add((key, value))
+        orig_disk_nodes = set(disk_nodes)
 
         # do a two-way diff against our original content
         current_nodes = set()
@@ -1894,7 +1905,7 @@
         disk_nodes.difference_update(deleted_nodes)
         disk_nodes.update(new_nodes)
 
-        return disk_nodes, deleted_nodes, new_nodes
+        return disk_nodes, deleted_nodes, new_nodes, orig_disk_nodes
 
     def _syncronize_pack_names_from_disk_nodes(self, disk_nodes):
         """Given the correct set of pack files, update our saved info.
@@ -1940,7 +1951,7 @@
                 added.append(name)
         return removed, added, modified
 
-    def _save_pack_names(self, clear_obsolete_packs=False):
+    def _save_pack_names(self, clear_obsolete_packs=False, obsolete_packs=None):
         """Save the list of packs.
 
         This will take out the mutex around the pack names list for the
@@ -1950,12 +1961,16 @@
 
         :param clear_obsolete_packs: If True, clear out the contents of the
             obsolete_packs directory.
+        :param obsolete_packs: Packs that are obsolete once the new pack-names
+            file has been written.
         :return: A list of the names saved that were not previously on disk.
         """
+        already_obsolete = []
         self.lock_names()
         try:
             builder = self._index_builder_class()
-            disk_nodes, deleted_nodes, new_nodes = self._diff_pack_names()
+            (disk_nodes, deleted_nodes, new_nodes,
+             orig_disk_nodes) = self._diff_pack_names()
             # TODO: handle same-name, index-size-changes here -
             # e.g. use the value from disk, not ours, *unless* we're the one
             # changing it.
@@ -1963,14 +1978,25 @@
                 builder.add_node(key, value)
             self.transport.put_file('pack-names', builder.finish(),
                 mode=self.repo.bzrdir._get_file_mode())
-            # move the baseline forward
             self._packs_at_load = disk_nodes
             if clear_obsolete_packs:
-                self._clear_obsolete_packs()
+                to_preserve = None
+                if obsolete_packs:
+                    to_preserve = set([o.name for o in obsolete_packs])
+                already_obsolete = self._clear_obsolete_packs(to_preserve)
         finally:
             self._unlock_names()
         # synchronise the memory packs list with what we just wrote:
         self._syncronize_pack_names_from_disk_nodes(disk_nodes)
+        if obsolete_packs:
+            # TODO: We could add one more condition here. "if o.name not in
+            #       orig_disk_nodes and o != the new_pack we haven't written to
+            #       disk yet. However, the new pack object is not easily
+            #       accessible here (it would have to be passed through the
+            #       autopacking code, etc.)
+            obsolete_packs = [o for o in obsolete_packs
+                              if o.name not in already_obsolete]
+            self._obsolete_packs(obsolete_packs)
         return [new_node[0][0] for new_node in new_nodes]
 
     def reload_pack_names(self):
@@ -1991,8 +2017,12 @@
         if first_read:
             return True
         # out the new value.
-        disk_nodes, _, _ = self._diff_pack_names()
-        self._packs_at_load = disk_nodes
+        (disk_nodes, deleted_nodes, new_nodes,
+         orig_disk_nodes) = self._diff_pack_names()
+        # _packs_at_load is meant to be the explicit list of names in
+        # 'pack-names' at then start. As such, it should not contain any
+        # pending names that haven't been written out yet.
+        self._packs_at_load = orig_disk_nodes
         (removed, added,
          modified) = self._syncronize_pack_names_from_disk_nodes(disk_nodes)
         if removed or added or modified:
@@ -2007,15 +2037,28 @@
             raise
         raise errors.RetryAutopack(self.repo, False, sys.exc_info())
 
-    def _clear_obsolete_packs(self):
+    def _clear_obsolete_packs(self, preserve=None):
         """Delete everything from the obsolete-packs directory.
+
+        :return: A list of pack identifiers (the filename without '.pack') that
+            were found in obsolete_packs.
         """
+        found = []
         obsolete_pack_transport = self.transport.clone('obsolete_packs')
+        if preserve is None:
+            preserve = set()
         for filename in obsolete_pack_transport.list_dir('.'):
+            name, ext = osutils.splitext(filename)
+            if ext == '.pack':
+                found.append(name)
+            if name in preserve:
+                continue
             try:
                 obsolete_pack_transport.delete(filename)
             except (errors.PathError, errors.TransportError), e:
-                warning("couldn't delete obsolete pack, skipping it:\n%s" % (e,))
+                warning("couldn't delete obsolete pack, skipping it:\n%s"
+                        % (e,))
+        return found
 
     def _start_write_group(self):
         # Do not permit preparation for writing if we're not in a 'write lock'.

=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2010-01-15 07:00:49 +0000
+++ bzrlib/repository.py	2010-02-01 11:40:56 +0000
@@ -1240,7 +1240,7 @@
         """Check a single text from this repository."""
         if kind == 'inventories':
             rev_id = record.key[0]
-            inv = self.deserialise_inventory(rev_id,
+            inv = self._deserialise_inventory(rev_id,
                 record.get_bytes_as('fulltext'))
             if last_object is not None:
                 delta = inv._make_delta(last_object)
@@ -2388,7 +2388,7 @@
         """single-document based inventory iteration."""
         inv_xmls = self._iter_inventory_xmls(revision_ids, ordering)
         for text, revision_id in inv_xmls:
-            yield self.deserialise_inventory(revision_id, text)
+            yield self._deserialise_inventory(revision_id, text)
 
     def _iter_inventory_xmls(self, revision_ids, ordering):
         if ordering is None:
@@ -2426,7 +2426,7 @@
                         next_key = None
                         break
 
-    def deserialise_inventory(self, revision_id, xml):
+    def _deserialise_inventory(self, revision_id, xml):
         """Transform the xml into an inventory object.
 
         :param revision_id: The expected revision id of the inventory.
@@ -2440,7 +2440,7 @@
                 result.revision_id, revision_id))
         return result
 
-    def serialise_inventory(self, inv):
+    def _serialise_inventory(self, inv):
         return self._serializer.write_inventory_to_string(inv)
 
     def _serialise_inventory_to_lines(self, inv):
@@ -2450,8 +2450,8 @@
         return self._serializer.format_num
 
     @needs_read_lock
-    def get_inventory_xml(self, revision_id):
-        """Get inventory XML as a file object."""
+    def _get_inventory_xml(self, revision_id):
+        """Get serialized inventory as a string."""
         texts = self._iter_inventory_xmls([revision_id], 'unordered')
         try:
             text, revision_id = texts.next()
@@ -2459,12 +2459,6 @@
             raise errors.HistoryMissing(self, 'inventory', revision_id)
         return text
 
-    @needs_read_lock
-    def get_inventory_sha1(self, revision_id):
-        """Return the sha1 hash of the inventory entry
-        """
-        return self.get_revision(revision_id).inventory_sha1
-
     def get_rev_id_for_revno(self, revno, known_pair):
         """Return the revision id of a revno, given a later (revno, revid)
         pair in the same history.

=== modified file 'bzrlib/revisiontree.py'
--- bzrlib/revisiontree.py	2009-10-15 02:19:43 +0000
+++ bzrlib/revisiontree.py	2010-01-20 23:21:35 +0000
@@ -103,7 +103,10 @@
 
     def get_file_mtime(self, file_id, path=None):
         ie = self._inventory[file_id]
-        revision = self._repository.get_revision(ie.revision)
+        try:
+            revision = self._repository.get_revision(ie.revision)
+        except errors.NoSuchRevision:
+            raise errors.FileTimestampUnavailable(self.id2path(file_id))
         return revision.timestamp
 
     def is_executable(self, file_id, path=None):

=== modified file 'bzrlib/smart/client.py'
--- bzrlib/smart/client.py	2009-03-23 14:59:43 +0000
+++ bzrlib/smart/client.py	2010-01-15 06:55:33 +0000
@@ -36,6 +36,9 @@
         else:
             self._headers = dict(headers)
 
+    def __repr__(self):
+        return '%s(%r)' % (self.__class__.__name__, self._medium)
+
     def _send_request(self, protocol_version, method, args, body=None,
                       readv_body=None, body_stream=None):
         encoder, response_handler = self._construct_protocol(

=== modified file 'bzrlib/smart/medium.py'
--- bzrlib/smart/medium.py	2009-12-21 17:00:29 +0000
+++ bzrlib/smart/medium.py	2010-01-15 07:26:46 +0000
@@ -749,6 +749,9 @@
         self._password = password
         self._port = port
         self._username = username
+        # for the benefit of progress making a short description of this
+        # transport
+        self._scheme = 'bzr+ssh'
         # SmartClientStreamMedium stores the repr of this object in its
         # _DebugCounter so we have to store all the values used in our repr
         # method before calling the super init.
@@ -758,17 +761,18 @@
         self._vendor = vendor
         self._write_to = None
         self._bzr_remote_path = bzr_remote_path
-        # for the benefit of progress making a short description of this
-        # transport
-        self._scheme = 'bzr+ssh'
 
     def __repr__(self):
-        return "%s(connected=%r, username=%r, host=%r, port=%r)" % (
+        if self._port is None:
+            maybe_port = ''
+        else:
+            maybe_port = ':%s' % self._port
+        return "%s(%s://%s@%s%s/)" % (
             self.__class__.__name__,
-            self._connected,
+            self._scheme,
             self._username,
             self._host,
-            self._port)
+            maybe_port)
 
     def _accept_bytes(self, bytes):
         """See SmartClientStreamMedium.accept_bytes."""

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2010-01-16 10:06:21 +0000
+++ bzrlib/tests/__init__.py	2010-02-03 07:16:18 +0000
@@ -126,6 +126,11 @@
 
 default_transport = LocalURLServer
 
+
+_unitialized_attr = object()
+"""A sentinel needed to act as a default value in a method signature."""
+
+
 # Subunit result codes, defined here to prevent a hard dependency on subunit.
 SUBUNIT_SEEK_SET = 0
 SUBUNIT_SEEK_CUR = 1
@@ -237,6 +242,9 @@
                 '%d non-main threads were left active in the end.\n'
                 % (TestCase._active_threads - 1))
 
+    def getDescription(self, test):
+        return test.id()
+
     def _extractBenchmarkTime(self, testCase, details=None):
         """Add a benchmark time for the current test case."""
         if details and 'benchtime' in details:
@@ -847,12 +855,12 @@
         Tests that want to use debug flags can just set them in the
         debug_flags set during setup/teardown.
         """
-        self._preserved_debug_flags = set(debug.debug_flags)
+        # Start with a copy of the current debug flags we can safely modify.
+        self.overrideAttr(debug, 'debug_flags', set(debug.debug_flags))
         if 'allow_debug' not in selftest_debug_flags:
             debug.debug_flags.clear()
         if 'disable_lock_checks' not in selftest_debug_flags:
             debug.debug_flags.add('strict_locks')
-        self.addCleanup(self._restore_debug_flags)
 
     def _clear_hooks(self):
         # prevent hooks affecting tests
@@ -879,11 +887,7 @@
     def _silenceUI(self):
         """Turn off UI for duration of test"""
         # by default the UI is off; tests can turn it on if they want it.
-        saved = ui.ui_factory
-        def _restore():
-            ui.ui_factory = saved
-        ui.ui_factory = ui.SilentUIFactory()
-        self.addCleanup(_restore)
+        self.overrideAttr(ui, 'ui_factory', ui.SilentUIFactory())
 
     def _check_locks(self):
         """Check that all lock take/release actions have been paired."""
@@ -918,7 +922,7 @@
             self._lock_check_thorough = False
         else:
             self._lock_check_thorough = True
-            
+
         self.addCleanup(self._check_locks)
         _mod_lock.Lock.hooks.install_named_hook('lock_acquired',
                                                 self._lock_acquired, None)
@@ -1476,6 +1480,25 @@
         """
         self._cleanups.append((callable, args, kwargs))
 
+    def overrideAttr(self, obj, attr_name, new=_unitialized_attr):
+        """Overrides an object attribute restoring it after the test.
+
+        :param obj: The object that will be mutated.
+
+        :param attr_name: The attribute name we want to preserve/override in
+            the object.
+
+        :param new: The optional value we want to set the attribute to.
+
+        :returns: The actual attr value.
+        """
+        value = getattr(obj, attr_name)
+        # The actual value is captured by the call below
+        self.addCleanup(setattr, obj, attr_name, value)
+        if new is not _unitialized_attr:
+            setattr(obj, attr_name, new)
+        return value
+
     def _cleanEnvironment(self):
         new_env = {
             'BZR_HOME': None, # Don't inherit BZR_HOME to all the tests.
@@ -1527,10 +1550,6 @@
         """Set an environment variable, and reset it when finished."""
         self.__old_env[name] = osutils.set_or_unset_env(name, newvalue)
 
-    def _restore_debug_flags(self):
-        debug.debug_flags.clear()
-        debug.debug_flags.update(self._preserved_debug_flags)
-
     def _restoreEnvironment(self):
         for name, value in self.__old_env.iteritems():
             osutils.set_or_unset_env(name, value)
@@ -2034,11 +2053,7 @@
 
         Tests that expect to provoke LockContention errors should call this.
         """
-        orig_timeout = bzrlib.lockdir._DEFAULT_TIMEOUT_SECONDS
-        def resetTimeout():
-            bzrlib.lockdir._DEFAULT_TIMEOUT_SECONDS = orig_timeout
-        self.addCleanup(resetTimeout)
-        bzrlib.lockdir._DEFAULT_TIMEOUT_SECONDS = 0
+        self.overrideAttr(bzrlib.lockdir, '_DEFAULT_TIMEOUT_SECONDS', 0)
 
     def make_utf8_encoded_stringio(self, encoding_type=None):
         """Return a StringIOWrapper instance, that will encode Unicode
@@ -2058,9 +2073,7 @@
         request_handlers = request.request_handlers
         orig_method = request_handlers.get(verb)
         request_handlers.remove(verb)
-        def restoreVerb():
-            request_handlers.register(verb, orig_method)
-        self.addCleanup(restoreVerb)
+        self.addCleanup(request_handlers.register, verb, orig_method)
 
 
 class CapturedCall(object):
@@ -2373,10 +2386,7 @@
     def setUp(self):
         super(TestCaseWithMemoryTransport, self).setUp()
         self._make_test_root()
-        _currentdir = os.getcwdu()
-        def _leaveDirectory():
-            os.chdir(_currentdir)
-        self.addCleanup(_leaveDirectory)
+        self.addCleanup(os.chdir, os.getcwdu())
         self.makeAndChdirToTestDir()
         self.overrideEnvironmentForTesting()
         self.__readonly_server = None
@@ -3749,6 +3759,7 @@
     return [
         'bzrlib',
         'bzrlib.branchbuilder',
+        'bzrlib.decorators',
         'bzrlib.export',
         'bzrlib.inventory',
         'bzrlib.iterablefile',

=== modified file 'bzrlib/tests/blackbox/test_commit.py'
--- bzrlib/tests/blackbox/test_commit.py	2009-12-07 10:38:09 +0000
+++ bzrlib/tests/blackbox/test_commit.py	2010-01-25 17:48:22 +0000
@@ -668,21 +668,17 @@
 
     def test_commit_hook_template(self):
         # Test that commit template hooks work
-        def restoreDefaults():
-            msgeditor.hooks['commit_message_template'] = []
-            osutils.set_or_unset_env('BZR_EDITOR', default_editor)
         if sys.platform == "win32":
             f = file('fed.bat', 'w')
             f.write('@rem dummy fed')
             f.close()
-            default_editor = osutils.set_or_unset_env('BZR_EDITOR', "fed.bat")
+            osutils.set_or_unset_env('BZR_EDITOR', "fed.bat")
         else:
             f = file('fed.sh', 'wb')
             f.write('#!/bin/sh\n')
             f.close()
             os.chmod('fed.sh', 0755)
-            default_editor = osutils.set_or_unset_env('BZR_EDITOR', "./fed.sh")
-        self.addCleanup(restoreDefaults)
+            osutils.set_or_unset_env('BZR_EDITOR', "./fed.sh")
         msgeditor.hooks.install_named_hook("commit_message_template",
                 lambda commit_obj, msg: "save me some typing\n", None)
         tree = self.make_branch_and_tree('tree')

=== modified file 'bzrlib/tests/blackbox/test_info.py'
--- bzrlib/tests/blackbox/test_info.py	2009-09-17 11:54:41 +0000
+++ bzrlib/tests/blackbox/test_info.py	2010-01-20 23:28:35 +0000
@@ -37,7 +37,7 @@
 
     def setUp(self):
         ExternalBase.setUp(self)
-        self._repo_strings = "2a or development-subtree"
+        self._repo_strings = "2a"
 
     def test_info_non_existing(self):
         self.vfs_transport_factory = MemoryServer

=== modified file 'bzrlib/tests/blackbox/test_log.py'
--- bzrlib/tests/blackbox/test_log.py	2009-11-01 03:45:20 +0000
+++ bzrlib/tests/blackbox/test_log.py	2010-01-25 17:48:22 +0000
@@ -17,22 +17,23 @@
 
 """Black-box tests for bzr log."""
 
+from itertools import izip
 import os
 import re
 
 from bzrlib import (
+    branchbuilder,
+    log,
     osutils,
     tests,
     )
-from bzrlib.tests import test_log
-
-
-class TestLog(tests.TestCaseWithTransport):
-
-    def setUp(self):
-        super(TestLog, self).setUp()
-        self.timezone = 0 # UTC
-        self.timestamp = 1132617600 # Mon 2005-11-22 00:00:00 +0000
+from bzrlib.tests import (
+    script,
+    test_log,
+    )
+
+
+class TestLog(tests.TestCaseWithTransport, test_log.TestLogMixin):
 
     def make_minimal_branch(self, path='.', format=None):
         tree = self.make_branch_and_tree(path, format=format)
@@ -63,174 +64,207 @@
         tree.commit(message='merge')
         return tree
 
-    def assertRevnos(self, log, must_have=(), must_not_have=()):
-        """Check if revnos are in or not in the log output"""
-        for revno in must_have:
-            self.assertTrue(('revno: %s\n' % revno) in log,
-                'Does not contain expected revno %s' % revno)
-        for revno in must_not_have:
-            self.assertFalse(('revno: %s\n' % revno) in log,
-                'Contains unexpected revno %s' % revno)
-
-    def commit_options(self):
-        """Use some mostly fixed values for commits to simplify tests.
-
-        Tests can use this function to get some commit attributes. The time
-        stamp is incremented at each commit.
-        """
-        self.timestamp += 1 # 1 second between each commit
-        return dict(committer='Lorem Ipsum <joe@foo.com>',
-                 timezone=self.timezone,
-                 timestamp=self.timestamp,
-                 )
-
-    def check_log(self, expected, args, working_dir='level0'):
-        out, err = self.run_bzr(['log', '--timezone', 'utc'] + args,
-                                working_dir=working_dir)
-        self.assertEqual('', err)
-        self.assertEqualDiff(expected, test_log.normalize_log(out))
-
-
-class TestLogRevSpecs(TestLog):
+
+class TestLogWithLogCatcher(TestLog):
+
+    def setUp(self):
+        super(TestLogWithLogCatcher, self).setUp()
+        # Capture log formatter creations
+        class MyLogFormatter(test_log.LogCatcher):
+
+            def __new__(klass, *args, **kwargs):
+                self.log_catcher = test_log.LogCatcher(*args, **kwargs)
+                # Always return our own log formatter
+                return self.log_catcher
+
+        def getme(branch):
+                # Always return our own log formatter class hijacking the
+                # default behavior (which requires setting up a config
+                # variable)
+            return MyLogFormatter
+        self.overrideAttr(log.log_formatter_registry, 'get_default', getme)
+
+    def get_captured_revisions(self):
+        return self.log_catcher.revisions
+
+    def assertLogRevnos(self, args, expected_revnos, working_dir='.'):
+        self.run_bzr(['log'] + args, working_dir=working_dir)
+        self.assertEqual(expected_revnos,
+                         [r.revno for r in self.get_captured_revisions()])
+
+    def assertLogRevnosAndDepths(self, args, expected_revnos_and_depths,
+                                working_dir='.'):
+        self.run_bzr(['log'] + args, working_dir=working_dir)
+        self.assertEqual(expected_revnos_and_depths,
+                         [(r.revno, r.merge_depth)
+                           for r in self.get_captured_revisions()])
+
+
+class TestLogRevSpecs(TestLogWithLogCatcher):
+
+    def test_log_no_revspec(self):
+        self.make_linear_branch()
+        self.assertLogRevnos([], ['3', '2', '1'])
 
     def test_log_null_end_revspec(self):
         self.make_linear_branch()
-        log = self.run_bzr(['log'])[0]
-        self.assertTrue('revno: 1\n' in log)
-        self.assertTrue('revno: 2\n' in log)
-        self.assertTrue('revno: 3\n' in log)
-        self.assertTrue('message:\n  message1\n' in log)
-        self.assertTrue('message:\n  message2\n' in log)
-        self.assertTrue('message:\n  message3\n' in log)
-
-        full_log = self.run_bzr(['log'])[0]
-        log = self.run_bzr("log -r 1..")[0]
-        self.assertEqualDiff(log, full_log)
+        self.assertLogRevnos(['-r1..'], ['3', '2', '1'])
 
     def test_log_null_begin_revspec(self):
         self.make_linear_branch()
-        full_log = self.run_bzr(['log'])[0]
-        log = self.run_bzr("log -r ..3")[0]
-        self.assertEqualDiff(full_log, log)
+        self.assertLogRevnos(['-r..3'], ['3', '2', '1'])
 
     def test_log_null_both_revspecs(self):
         self.make_linear_branch()
-        full_log = self.run_bzr(['log'])[0]
-        log = self.run_bzr("log -r ..")[0]
-        self.assertEqualDiff(full_log, log)
-
-    def test_log_zero_revspec(self):
-        self.make_minimal_branch()
-        self.run_bzr_error(['bzr: ERROR: Logging revision 0 is invalid.'],
-                           ['log', '-r0'])
-
-    def test_log_zero_begin_revspec(self):
-        self.make_linear_branch()
-        self.run_bzr_error(['bzr: ERROR: Logging revision 0 is invalid.'],
-                           ['log', '-r0..2'])
-
-    def test_log_zero_end_revspec(self):
-        self.make_linear_branch()
-        self.run_bzr_error(['bzr: ERROR: Logging revision 0 is invalid.'],
-                           ['log', '-r-2..0'])
+        self.assertLogRevnos(['-r..'], ['3', '2', '1'])
 
     def test_log_negative_begin_revspec_full_log(self):
         self.make_linear_branch()
-        full_log = self.run_bzr(['log'])[0]
-        log = self.run_bzr("log -r -3..")[0]
-        self.assertEqualDiff(full_log, log)
+        self.assertLogRevnos(['-r-3..'], ['3', '2', '1'])
 
     def test_log_negative_both_revspec_full_log(self):
         self.make_linear_branch()
-        full_log = self.run_bzr(['log'])[0]
-        log = self.run_bzr("log -r -3..-1")[0]
-        self.assertEqualDiff(full_log, log)
+        self.assertLogRevnos(['-r-3..-1'], ['3', '2', '1'])
 
     def test_log_negative_both_revspec_partial(self):
         self.make_linear_branch()
-        log = self.run_bzr("log -r -3..-2")[0]
-        self.assertTrue('revno: 1\n' in log)
-        self.assertTrue('revno: 2\n' in log)
-        self.assertTrue('revno: 3\n' not in log)
+        self.assertLogRevnos(['-r-3..-2'], ['2', '1'])
 
     def test_log_negative_begin_revspec(self):
         self.make_linear_branch()
-        log = self.run_bzr("log -r -2..")[0]
-        self.assertTrue('revno: 1\n' not in log)
-        self.assertTrue('revno: 2\n' in log)
-        self.assertTrue('revno: 3\n' in log)
+        self.assertLogRevnos(['-r-2..'], ['3', '2'])
 
     def test_log_positive_revspecs(self):
         self.make_linear_branch()
-        full_log = self.run_bzr(['log'])[0]
-        log = self.run_bzr("log -r 1..3")[0]
-        self.assertEqualDiff(full_log, log)
+        self.assertLogRevnos(['-r1..3'], ['3', '2', '1'])
 
     def test_log_dotted_revspecs(self):
         self.make_merged_branch()
-        log = self.run_bzr("log -n0 -r 1..1.1.1")[0]
-        self.assertRevnos(log, (1, '1.1.1'), (2, 3, '1.1.2', 4))
-
-    def test_log_reversed_revspecs(self):
-        self.make_linear_branch()
-        self.run_bzr_error(('bzr: ERROR: Start revision must be older than '
-                            'the end revision.\n',),
-                           ['log', '-r3..1'])
-
-    def test_log_reversed_dotted_revspecs(self):
-        self.make_merged_branch()
-        self.run_bzr_error(('bzr: ERROR: Start revision not found in '
-                            'left-hand history of end revision.\n',),
-                           "log -r 1.1.1..1")
+        self.assertLogRevnos(['-n0', '-r1..1.1.1'], ['1.1.1', '1'])
+
+    def test_log_limit(self):
+        tree = self.make_branch_and_tree('.')
+        # We want more commits than our batch size starts at
+        for pos in range(10):
+            tree.commit("%s" % pos)
+        self.assertLogRevnos(['--limit', '2'], ['10', '9'])
+
+    def test_log_limit_short(self):
+        self.make_linear_branch()
+        self.assertLogRevnos(['-l', '2'], ['3', '2'])
+
+    def test_log_change_revno(self):
+        self.make_linear_branch()
+        self.assertLogRevnos(['-c1'], ['1'])
+
+
+class TestBug474807(TestLogWithLogCatcher):
+
+    def setUp(self):
+        super(TestBug474807, self).setUp()
+        # FIXME: Using a MemoryTree would be even better here (but until we
+        # stop calling run_bzr, there is no point) --vila 100118.
+        builder = branchbuilder.BranchBuilder(self.get_transport())
+        builder.start_series()
+        # mainline
+        builder.build_snapshot('1', None, [
+            ('add', ('', 'root-id', 'directory', ''))])
+        builder.build_snapshot('2', ['1'], [])
+        # branch
+        builder.build_snapshot('1.1.1', ['1'], [])
+        # merge branch into mainline
+        builder.build_snapshot('3', ['2', '1.1.1'], [])
+        # new commits in branch
+        builder.build_snapshot('1.1.2', ['1.1.1'], [])
+        builder.build_snapshot('1.1.3', ['1.1.2'], [])
+        # merge branch into mainline
+        builder.build_snapshot('4', ['3', '1.1.3'], [])
+        # merge mainline into branch
+        builder.build_snapshot('1.1.4', ['1.1.3', '4'], [])
+        # merge branch into mainline
+        builder.build_snapshot('5', ['4', '1.1.4'], [])
+        builder.finish_series()
+
+    def test_n0(self):
+        self.assertLogRevnos(['-n0', '-r1.1.1..1.1.4'],
+                             ['1.1.4', '4', '1.1.3', '1.1.2', '3', '1.1.1'])
+    def test_n0_forward(self):
+        self.assertLogRevnos(['-n0', '-r1.1.1..1.1.4', '--forward'],
+                             ['3', '1.1.1', '4', '1.1.2', '1.1.3', '1.1.4'])
+
+    def test_n1(self):
+        # starting from 1.1.4 we follow the left-hand ancestry
+        self.assertLogRevnos(['-n1', '-r1.1.1..1.1.4'],
+                             ['1.1.4', '1.1.3', '1.1.2', '1.1.1'])
+
+    def test_n1_forward(self):
+        self.assertLogRevnos(['-n1', '-r1.1.1..1.1.4', '--forward'],
+                             ['1.1.1', '1.1.2', '1.1.3', '1.1.4'])
+
+
+class TestLogRevSpecsWithPaths(TestLogWithLogCatcher):
+
+    def test_log_revno_n_path_wrong_namespace(self):
+        self.make_linear_branch('branch1')
+        self.make_linear_branch('branch2')
+        # There is no guarantee that a path exist between two arbitrary
+        # revisions.
+        self.run_bzr("log -r revno:2:branch1..revno:3:branch2", retcode=3)
+        # But may be it's worth trying though ? -- vila 100115
+
+    def test_log_revno_n_path_correct_order(self):
+        self.make_linear_branch('branch2')
+        self.assertLogRevnos(['-rrevno:1:branch2..revno:3:branch2'],
+                             ['3', '2','1'])
 
     def test_log_revno_n_path(self):
-        self.make_linear_branch('branch1')
         self.make_linear_branch('branch2')
-        # Swapped revisions
-        self.run_bzr("log -r revno:2:branch1..revno:3:branch2", retcode=3)[0]
-        # Correct order
-        log = self.run_bzr("log -r revno:1:branch2..revno:3:branch2")[0]
-        full_log = self.run_bzr(['log'], working_dir='branch2')[0]
-        self.assertEqualDiff(full_log, log)
-        log = self.run_bzr("log -r revno:1:branch2")[0]
-        self.assertTrue('revno: 1\n' in log)
-        self.assertTrue('revno: 2\n' not in log)
-        self.assertTrue('branch nick: branch2\n' in log)
-        self.assertTrue('branch nick: branch1\n' not in log)
+        self.assertLogRevnos(['-rrevno:1:branch2'],
+                             ['1'])
+        rev_props = self.log_catcher.revisions[0].rev.properties
+        self.assertEqual('branch2', rev_props['branch-nick'])
+
+
+class TestLogErrors(TestLog):
+
+    def test_log_zero_revspec(self):
+        self.make_minimal_branch()
+        self.run_bzr_error(['bzr: ERROR: Logging revision 0 is invalid.'],
+                           ['log', '-r0'])
+
+    def test_log_zero_begin_revspec(self):
+        self.make_linear_branch()
+        self.run_bzr_error(['bzr: ERROR: Logging revision 0 is invalid.'],
+                           ['log', '-r0..2'])
+
+    def test_log_zero_end_revspec(self):
+        self.make_linear_branch()
+        self.run_bzr_error(['bzr: ERROR: Logging revision 0 is invalid.'],
+                           ['log', '-r-2..0'])
 
     def test_log_nonexistent_revno(self):
         self.make_minimal_branch()
-        (out, err) = self.run_bzr_error(
-            ["bzr: ERROR: Requested revision: '1234' "
-             "does not exist in branch:"],
-            ['log', '-r1234'])
+        self.run_bzr_error(["bzr: ERROR: Requested revision: '1234' "
+                            "does not exist in branch:"],
+                           ['log', '-r1234'])
 
     def test_log_nonexistent_dotted_revno(self):
         self.make_minimal_branch()
-        (out, err) = self.run_bzr_error(
-            ["bzr: ERROR: Requested revision: '123.123' "
-             "does not exist in branch:"],
-            ['log',  '-r123.123'])
-
-    def test_log_change_revno(self):
-        self.make_linear_branch()
-        expected_log = self.run_bzr("log -r 1")[0]
-        log = self.run_bzr("log -c 1")[0]
-        self.assertEqualDiff(expected_log, log)
+        self.run_bzr_error(["bzr: ERROR: Requested revision: '123.123' "
+                            "does not exist in branch:"],
+                           ['log',  '-r123.123'])
 
     def test_log_change_nonexistent_revno(self):
         self.make_minimal_branch()
-        (out, err) = self.run_bzr_error(
-            ["bzr: ERROR: Requested revision: '1234' "
-             "does not exist in branch:"],
-            ['log',  '-c1234'])
+        self.run_bzr_error(["bzr: ERROR: Requested revision: '1234' "
+                            "does not exist in branch:"],
+                           ['log',  '-c1234'])
 
     def test_log_change_nonexistent_dotted_revno(self):
         self.make_minimal_branch()
-        (out, err) = self.run_bzr_error(
-            ["bzr: ERROR: Requested revision: '123.123' "
-             "does not exist in branch:"],
-            ['log', '-c123.123'])
+        self.run_bzr_error(["bzr: ERROR: Requested revision: '123.123' "
+                            "does not exist in branch:"],
+                           ['log', '-c123.123'])
 
     def test_log_change_single_revno_only(self):
         self.make_minimal_branch()
@@ -252,6 +286,40 @@
                               'Path unknown at end or start of revision range: '
                               'does-not-exist')
 
+    def test_log_reversed_revspecs(self):
+        self.make_linear_branch()
+        self.run_bzr_error(('bzr: ERROR: Start revision must be older than '
+                            'the end revision.\n',),
+                           ['log', '-r3..1'])
+
+    def test_log_reversed_dotted_revspecs(self):
+        self.make_merged_branch()
+        self.run_bzr_error(('bzr: ERROR: Start revision not found in '
+                            'left-hand history of end revision.\n',),
+                           "log -r 1.1.1..1")
+
+    def test_log_bad_message_re(self):
+        """Bad --message argument gives a sensible message
+        
+        See https://bugs.launchpad.net/bzr/+bug/251352
+        """
+        self.make_minimal_branch()
+        out, err = self.run_bzr(['log', '-m', '*'], retcode=3)
+        self.assertEqual("bzr: ERROR: Invalid regular expression"
+            " in log message filter"
+            ": '*'"
+            ": nothing to repeat\n", err)
+        self.assertEqual('', out)
+
+    def test_log_unsupported_timezone(self):
+        self.make_linear_branch()
+        self.run_bzr_error(['bzr: ERROR: Unsupported timezone format "foo", '
+                            'options are "utc", "original", "local".'],
+                           ['log', '--timezone', 'foo'])
+
+
+class TestLogTags(TestLog):
+
     def test_log_with_tags(self):
         tree = self.make_linear_branch(format='dirstate-tags')
         branch = tree.branch
@@ -282,52 +350,6 @@
         log = self.run_bzr("log -n0 -r3.1.1", working_dir='branch2')[0]
         self.assertContainsRe(log, r'tags: tag1')
 
-    def test_log_limit(self):
-        tree = self.make_branch_and_tree('.')
-        # We want more commits than our batch size starts at
-        for pos in range(10):
-            tree.commit("%s" % pos)
-        log = self.run_bzr("log --limit 2")[0]
-        self.assertNotContainsRe(log, r'revno: 1\n')
-        self.assertNotContainsRe(log, r'revno: 2\n')
-        self.assertNotContainsRe(log, r'revno: 3\n')
-        self.assertNotContainsRe(log, r'revno: 4\n')
-        self.assertNotContainsRe(log, r'revno: 5\n')
-        self.assertNotContainsRe(log, r'revno: 6\n')
-        self.assertNotContainsRe(log, r'revno: 7\n')
-        self.assertNotContainsRe(log, r'revno: 8\n')
-        self.assertContainsRe(log, r'revno: 9\n')
-        self.assertContainsRe(log, r'revno: 10\n')
-
-    def test_log_limit_short(self):
-        self.make_linear_branch()
-        log = self.run_bzr("log -l 2")[0]
-        self.assertNotContainsRe(log, r'revno: 1\n')
-        self.assertContainsRe(log, r'revno: 2\n')
-        self.assertContainsRe(log, r'revno: 3\n')
-
-    def test_log_bad_message_re(self):
-        """Bad --message argument gives a sensible message
-        
-        See https://bugs.launchpad.net/bzr/+bug/251352
-        """
-        self.make_minimal_branch()
-        out, err = self.run_bzr(['log', '-m', '*'], retcode=3)
-        self.assertEqual("bzr: ERROR: Invalid regular expression"
-            " in log message filter"
-            ": '*'"
-            ": nothing to repeat\n", err)
-        self.assertEqual('', out)
-
-
-class TestLogTimeZone(TestLog):
-
-    def test_log_unsupported_timezone(self):
-        self.make_linear_branch()
-        self.run_bzr_error(['bzr: ERROR: Unsupported timezone format "foo", '
-                            'options are "utc", "original", "local".'],
-                           ['log', '--timezone', 'foo'])
-
 
 class TestLogVerbose(TestLog):
 
@@ -364,7 +386,7 @@
         self.assertUseLongDeltaFormat(['log', '--long', '-vv'])
 
 
-class TestLogMerges(TestLog):
+class TestLogMerges(TestLogWithLogCatcher):
 
     def setUp(self):
         super(TestLogMerges, self).setUp()
@@ -372,101 +394,40 @@
 
     def make_branches_with_merges(self):
         level0 = self.make_branch_and_tree('level0')
-        level0.commit(message='in branch level0', **self.commit_options())
-
+        self.wt_commit(level0, 'in branch level0')
         level1 = level0.bzrdir.sprout('level1').open_workingtree()
-        level1.commit(message='in branch level1', **self.commit_options())
-
+        self.wt_commit(level1, 'in branch level1')
         level2 = level1.bzrdir.sprout('level2').open_workingtree()
-        level2.commit(message='in branch level2', **self.commit_options())
-
+        self.wt_commit(level2, 'in branch level2')
         level1.merge_from_branch(level2.branch)
-        level1.commit(message='merge branch level2', **self.commit_options())
-
+        self.wt_commit(level1, 'merge branch level2')
         level0.merge_from_branch(level1.branch)
-        level0.commit(message='merge branch level1', **self.commit_options())
+        self.wt_commit(level0, 'merge branch level1')
 
     def test_merges_are_indented_by_level(self):
-        expected = """\
-------------------------------------------------------------
-revno: 2 [merge]
-committer: Lorem Ipsum <test@example.com>
-branch nick: level0
-timestamp: Just now
-message:
-  merge branch level1
-    ------------------------------------------------------------
-    revno: 1.1.2 [merge]
-    committer: Lorem Ipsum <test@example.com>
-    branch nick: level1
-    timestamp: Just now
-    message:
-      merge branch level2
-        ------------------------------------------------------------
-        revno: 1.2.1
-        committer: Lorem Ipsum <test@example.com>
-        branch nick: level2
-        timestamp: Just now
-        message:
-          in branch level2
-    ------------------------------------------------------------
-    revno: 1.1.1
-    committer: Lorem Ipsum <test@example.com>
-    branch nick: level1
-    timestamp: Just now
-    message:
-      in branch level1
-------------------------------------------------------------
-revno: 1
-committer: Lorem Ipsum <test@example.com>
-branch nick: level0
-timestamp: Just now
-message:
-  in branch level0
-"""
-        self.check_log(expected, ['-n0'])
+        self.run_bzr(['log', '-n0'], working_dir='level0')
+        revnos_and_depth = [(r.revno, r.merge_depth)
+                            for r in self.get_captured_revisions()]
+        self.assertEqual([('2', 0), ('1.1.2', 1), ('1.2.1', 2), ('1.1.1', 1),
+                          ('1', 0)],
+                         [(r.revno, r.merge_depth)
+                            for r in self.get_captured_revisions()])
 
     def test_force_merge_revisions_off(self):
-        expected = """\
-------------------------------------------------------------
-revno: 2 [merge]
-committer: Lorem Ipsum <test@example.com>
-branch nick: level0
-timestamp: Just now
-message:
-  merge branch level1
-------------------------------------------------------------
-revno: 1
-committer: Lorem Ipsum <test@example.com>
-branch nick: level0
-timestamp: Just now
-message:
-  in branch level0
-"""
-        self.check_log(expected, ['--long', '-n1'])
+        self.assertLogRevnos(['-n1'], ['2', '1'], working_dir='level0')
 
     def test_force_merge_revisions_on(self):
-        expected = """\
-    2 Lorem Ipsum\t2005-11-22 [merge]
-      merge branch level1
-
-          1.1.2 Lorem Ipsum\t2005-11-22 [merge]
-                merge branch level2
-
-              1.2.1 Lorem Ipsum\t2005-11-22
-                    in branch level2
-
-          1.1.1 Lorem Ipsum\t2005-11-22
-                in branch level1
-
-    1 Lorem Ipsum\t2005-11-22
-      in branch level0
-
-"""
-        self.check_log(expected, ['--short', '-n0'])
+        self.assertLogRevnos(['-n0'], ['2', '1.1.2', '1.2.1', '1.1.1', '1'],
+                             working_dir='level0')
 
     def test_include_merges(self):
         # Confirm --include-merges gives the same output as -n0
+        self.assertLogRevnos(['--include-merges'],
+                             ['2', '1.1.2', '1.2.1', '1.1.1', '1'],
+                             working_dir='level0')
+        self.assertLogRevnos(['--include-merges'],
+                             ['2', '1.1.2', '1.2.1', '1.1.1', '1'],
+                             working_dir='level0')
         out_im, err_im = self.run_bzr('log --include-merges',
                                       working_dir='level0')
         out_n0, err_n0 = self.run_bzr('log -n0', working_dir='level0')
@@ -475,84 +436,34 @@
         self.assertEqual(out_im, out_n0)
 
     def test_force_merge_revisions_N(self):
-        expected = """\
-    2 Lorem Ipsum\t2005-11-22 [merge]
-      merge branch level1
-
-          1.1.2 Lorem Ipsum\t2005-11-22 [merge]
-                merge branch level2
-
-          1.1.1 Lorem Ipsum\t2005-11-22
-                in branch level1
-
-    1 Lorem Ipsum\t2005-11-22
-      in branch level0
-
-"""
-        self.check_log(expected, ['--short', '-n2'])
+        self.assertLogRevnos(['-n2'],
+                             ['2', '1.1.2', '1.1.1', '1'],
+                             working_dir='level0')
 
     def test_merges_single_merge_rev(self):
-        expected = """\
-------------------------------------------------------------
-revno: 1.1.2 [merge]
-committer: Lorem Ipsum <test@example.com>
-branch nick: level1
-timestamp: Just now
-message:
-  merge branch level2
-    ------------------------------------------------------------
-    revno: 1.2.1
-    committer: Lorem Ipsum <test@example.com>
-    branch nick: level2
-    timestamp: Just now
-    message:
-      in branch level2
-"""
-        self.check_log(expected, ['-n0', '-r1.1.2'])
+        self.assertLogRevnosAndDepths(['-n0', '-r1.1.2'],
+                                      [('1.1.2', 0), ('1.2.1', 1)],
+                                      working_dir='level0')
 
     def test_merges_partial_range(self):
-        expected = """\
-------------------------------------------------------------
-revno: 1.1.2 [merge]
-committer: Lorem Ipsum <test@example.com>
-branch nick: level1
-timestamp: Just now
-message:
-  merge branch level2
-    ------------------------------------------------------------
-    revno: 1.2.1
-    committer: Lorem Ipsum <test@example.com>
-    branch nick: level2
-    timestamp: Just now
-    message:
-      in branch level2
-------------------------------------------------------------
-revno: 1.1.1
-committer: Lorem Ipsum <test@example.com>
-branch nick: level1
-timestamp: Just now
-message:
-  in branch level1
-"""
-        self.check_log(expected, ['-n0', '-r1.1.1..1.1.2'])
+        self.assertLogRevnosAndDepths(
+                ['-n0', '-r1.1.1..1.1.2'],
+                [('1.1.2', 0), ('1.2.1', 1), ('1.1.1', 0)],
+                working_dir='level0')
 
     def test_merges_partial_range_ignore_before_lower_bound(self):
         """Dont show revisions before the lower bound's merged revs"""
-        expected = """\
-    2 Lorem Ipsum\t2005-11-22 [merge]
-      merge branch level1
-
-          1.1.2 Lorem Ipsum\t2005-11-22 [merge]
-                merge branch level2
-
-              1.2.1 Lorem Ipsum\t2005-11-22
-                    in branch level2
-
-"""
-        self.check_log(expected, ['--short', '-n0', '-r1.1.2..2'])
-
-
-class TestLogDiff(TestLog):
+        self.assertLogRevnosAndDepths(
+                ['-n0', '-r1.1.2..2'],
+                [('2', 0), ('1.1.2', 1), ('1.2.1', 2)],
+                working_dir='level0')
+
+
+class TestLogDiff(TestLogWithLogCatcher):
+
+    # FIXME: We need specific tests for each LogFormatter about how the diffs
+    # are displayed: --long indent them by depth, --short use a fixed
+    # indent and --line does't display them. -- vila 10019
 
     def setUp(self):
         super(TestLogDiff, self).setUp()
@@ -563,143 +474,90 @@
         self.build_tree(['level0/file1', 'level0/file2'])
         level0.add('file1')
         level0.add('file2')
-        level0.commit(message='in branch level0', **self.commit_options())
+        self.wt_commit(level0, 'in branch level0')
 
         level1 = level0.bzrdir.sprout('level1').open_workingtree()
         self.build_tree_contents([('level1/file2', 'hello\n')])
-        level1.commit(message='in branch level1', **self.commit_options())
+        self.wt_commit(level1, 'in branch level1')
         level0.merge_from_branch(level1.branch)
-        level0.commit(message='merge branch level1', **self.commit_options())
+        self.wt_commit(level0, 'merge branch level1')
 
-    def test_log_show_diff_long_with_merges(self):
-        out,err = self.run_bzr('log -p -n0')
-        self.assertEqual('', err)
-        log = test_log.normalize_log(out)
-        expected = """\
-------------------------------------------------------------
-revno: 2 [merge]
-committer: Lorem Ipsum <test@example.com>
-branch nick: level0
-timestamp: Just now
-message:
-  merge branch level1
-diff:
-=== modified file 'file2'
---- file2\t2005-11-22 00:00:01 +0000
-+++ file2\t2005-11-22 00:00:02 +0000
-@@ -1,1 +1,1 @@
--contents of level0/file2
-+hello
-    ------------------------------------------------------------
-    revno: 1.1.1
-    committer: Lorem Ipsum <test@example.com>
-    branch nick: level1
-    timestamp: Just now
-    message:
-      in branch level1
-    diff:
-    === modified file 'file2'
-    --- file2\t2005-11-22 00:00:01 +0000
-    +++ file2\t2005-11-22 00:00:02 +0000
-    @@ -1,1 +1,1 @@
-    -contents of level0/file2
-    +hello
-------------------------------------------------------------
-revno: 1
-committer: Lorem Ipsum <test@example.com>
-branch nick: level0
-timestamp: Just now
-message:
-  in branch level0
-diff:
-=== added file 'file1'
+    def _diff_file1_revno1(self):
+        return """=== added file 'file1'
 --- file1\t1970-01-01 00:00:00 +0000
-+++ file1\t2005-11-22 00:00:01 +0000
++++ file1\t2005-11-22 00:00:00 +0000
 @@ -0,0 +1,1 @@
 +contents of level0/file1
 
-=== added file 'file2'
+"""
+
+    def _diff_file2_revno2(self):
+        return """=== modified file 'file2'
+--- file2\t2005-11-22 00:00:00 +0000
++++ file2\t2005-11-22 00:00:01 +0000
+@@ -1,1 +1,1 @@
+-contents of level0/file2
++hello
+
+"""
+
+    def _diff_file2_revno1_1_1(self):
+        return """=== modified file 'file2'
+--- file2\t2005-11-22 00:00:00 +0000
++++ file2\t2005-11-22 00:00:01 +0000
+@@ -1,1 +1,1 @@
+-contents of level0/file2
++hello
+
+"""
+
+    def _diff_file2_revno1(self):
+        return """=== added file 'file2'
 --- file2\t1970-01-01 00:00:00 +0000
-+++ file2\t2005-11-22 00:00:01 +0000
++++ file2\t2005-11-22 00:00:00 +0000
 @@ -0,0 +1,1 @@
 +contents of level0/file2
-"""
-        self.check_log(expected, ['-p', '-n0'])
-
-    def test_log_show_diff_short(self):
-        expected = """\
-    2 Lorem Ipsum\t2005-11-22 [merge]
-      merge branch level1
-      === modified file 'file2'
-      --- file2\t2005-11-22 00:00:01 +0000
-      +++ file2\t2005-11-22 00:00:02 +0000
-      @@ -1,1 +1,1 @@
-      -contents of level0/file2
-      +hello
-
-    1 Lorem Ipsum\t2005-11-22
-      in branch level0
-      === added file 'file1'
-      --- file1\t1970-01-01 00:00:00 +0000
-      +++ file1\t2005-11-22 00:00:01 +0000
-      @@ -0,0 +1,1 @@
-      +contents of level0/file1
-\x20\x20\x20\x20\x20\x20
-      === added file 'file2'
-      --- file2\t1970-01-01 00:00:00 +0000
-      +++ file2\t2005-11-22 00:00:01 +0000
-      @@ -0,0 +1,1 @@
-      +contents of level0/file2
-
-Use --include-merges or -n0 to see merged revisions.
-"""
-        self.check_log(expected, ['-p', '--short'])
-
-    def test_log_show_diff_line(self):
-        # Not supported by this formatter so expect plain output
-        expected = """\
-2: Lorem Ipsum 2005-11-22 [merge] merge branch level1
-1: Lorem Ipsum 2005-11-22 in branch level0
-"""
-        self.check_log(expected, ['-p', '--line'])
-
-    def test_log_show_diff_file1(self):
-        """Only the diffs for the given file are to be shown"""
-        expected = """\
-    1 Lorem Ipsum\t2005-11-22
-      in branch level0
-      === added file 'file1'
-      --- file1\t1970-01-01 00:00:00 +0000
-      +++ file1\t2005-11-22 00:00:01 +0000
-      @@ -0,0 +1,1 @@
-      +contents of level0/file1
-
-"""
-        self.check_log(expected, ['-p', '--short', 'file1'])
-
-    def test_log_show_diff_file2(self):
-        """Only the diffs for the given file are to be shown"""
-        expected = """\
-    2 Lorem Ipsum\t2005-11-22 [merge]
-      merge branch level1
-      === modified file 'file2'
-      --- file2\t2005-11-22 00:00:01 +0000
-      +++ file2\t2005-11-22 00:00:02 +0000
-      @@ -1,1 +1,1 @@
-      -contents of level0/file2
-      +hello
-
-    1 Lorem Ipsum\t2005-11-22
-      in branch level0
-      === added file 'file2'
-      --- file2\t1970-01-01 00:00:00 +0000
-      +++ file2\t2005-11-22 00:00:01 +0000
-      @@ -0,0 +1,1 @@
-      +contents of level0/file2
-
-Use --include-merges or -n0 to see merged revisions.
-"""
-        self.check_log(expected, ['-p', '--short', 'file2'])
+
+"""
+
+    def assertLogRevnosAndDiff(self, args, expected,
+                            working_dir='.'):
+        self.run_bzr(['log', '-p'] + args, working_dir=working_dir)
+        expected_revnos_and_depths = [
+            (revno, depth) for revno, depth, diff in expected]
+        # Check the revnos and depths first to make debugging easier
+        self.assertEqual(expected_revnos_and_depths,
+                         [(r.revno, r.merge_depth)
+                           for r in self.get_captured_revisions()])
+        # Now check the diffs, adding the revno  in case of failure
+        fmt = 'In revno %s\n%s'
+        for expected_rev, actual_rev in izip(expected,
+                                             self.get_captured_revisions()):
+            revno, depth, expected_diff = expected_rev
+            actual_diff = actual_rev.diff
+            self.assertEqualDiff(fmt % (revno, expected_diff),
+                                 fmt % (revno, actual_diff))
+
+    def test_log_diff_with_merges(self):
+        self.assertLogRevnosAndDiff(
+            ['-n0'],
+            [('2', 0, self._diff_file2_revno2()),
+             ('1.1.1', 1, self._diff_file2_revno1_1_1()),
+             ('1', 0, self._diff_file1_revno1()
+              + self._diff_file2_revno1())],
+            working_dir='level0')
+
+
+    def test_log_diff_file1(self):
+        self.assertLogRevnosAndDiff(['-n0', 'file1'],
+                                    [('1', 0, self._diff_file1_revno1())],
+                                    working_dir='level0')
+
+    def test_log_diff_file2(self):
+        self.assertLogRevnosAndDiff(['-n1', 'file2'],
+                                    [('2', 0, self._diff_file2_revno2()),
+                                     ('1', 0, self._diff_file2_revno1())],
+                                    working_dir='level0')
 
 
 class TestLogUnicodeDiff(TestLog):
@@ -748,15 +606,12 @@
 
     def setUp(self):
         super(TestLogEncodings, self).setUp()
-        self.user_encoding = osutils._cached_user_encoding
-        def restore():
-            osutils._cached_user_encoding = self.user_encoding
-        self.addCleanup(restore)
+        self.overrideAttr(osutils, '_cached_user_encoding')
 
     def create_branch(self):
         bzr = self.run_bzr
         bzr('init')
-        open('a', 'wb').write('some stuff\n')
+        self.build_tree_contents([('a', 'some stuff\n')])
         bzr('add a')
         bzr(['commit', '-m', self._message])
 
@@ -825,7 +680,7 @@
         self.assertEquals(-1, stdout.find(test_in_cp1251))
 
 
-class TestLogFile(tests.TestCaseWithTransport):
+class TestLogFile(TestLogWithLogCatcher):
 
     def test_log_local_branch_file(self):
         """We should be able to log files in local treeless branches"""
@@ -860,51 +715,29 @@
             tree.commit('remove file1')
         os.chdir('parent')
 
-    def test_log_file(self):
-        """The log for a particular file should only list revs for that file"""
-        self.prepare_tree()
-        log = self.run_bzr('log -n0 file1')[0]
-        self.assertContainsRe(log, 'revno: 1\n')
-        self.assertNotContainsRe(log, 'revno: 2\n')
-        self.assertNotContainsRe(log, 'revno: 3\n')
-        self.assertNotContainsRe(log, 'revno: 3.1.1\n')
-        self.assertNotContainsRe(log, 'revno: 4 ')
-        log = self.run_bzr('log -n0 file2')[0]
-        self.assertNotContainsRe(log, 'revno: 1\n')
-        self.assertContainsRe(log, 'revno: 2\n')
-        self.assertNotContainsRe(log, 'revno: 3\n')
-        self.assertContainsRe(log, 'revno: 3.1.1\n')
-        self.assertContainsRe(log, 'revno: 4 ')
-        log = self.run_bzr('log -n0 file3')[0]
-        self.assertNotContainsRe(log, 'revno: 1\n')
-        self.assertNotContainsRe(log, 'revno: 2\n')
-        self.assertContainsRe(log, 'revno: 3\n')
-        self.assertNotContainsRe(log, 'revno: 3.1.1\n')
-        self.assertNotContainsRe(log, 'revno: 4 ')
-        log = self.run_bzr('log -n0 -r3.1.1 file2')[0]
-        self.assertNotContainsRe(log, 'revno: 1\n')
-        self.assertNotContainsRe(log, 'revno: 2\n')
-        self.assertNotContainsRe(log, 'revno: 3\n')
-        self.assertContainsRe(log, 'revno: 3.1.1\n')
-        self.assertNotContainsRe(log, 'revno: 4 ')
-        log = self.run_bzr('log -n0 -r4 file2')[0]
-        self.assertNotContainsRe(log, 'revno: 1\n')
-        self.assertNotContainsRe(log, 'revno: 2\n')
-        self.assertNotContainsRe(log, 'revno: 3\n')
-        self.assertContainsRe(log, 'revno: 3.1.1\n')
-        self.assertContainsRe(log, 'revno: 4 ')
-        log = self.run_bzr('log -n0 -r3.. file2')[0]
-        self.assertNotContainsRe(log, 'revno: 1\n')
-        self.assertNotContainsRe(log, 'revno: 2\n')
-        self.assertNotContainsRe(log, 'revno: 3\n')
-        self.assertContainsRe(log, 'revno: 3.1.1\n')
-        self.assertContainsRe(log, 'revno: 4 ')
-        log = self.run_bzr('log -n0 -r..3 file2')[0]
-        self.assertNotContainsRe(log, 'revno: 1\n')
-        self.assertContainsRe(log, 'revno: 2\n')
-        self.assertNotContainsRe(log, 'revno: 3\n')
-        self.assertNotContainsRe(log, 'revno: 3.1.1\n')
-        self.assertNotContainsRe(log, 'revno: 4 ')
+    # FIXME: It would be good to parametrize the following tests against all
+    # formatters. But the revisions selection is not *currently* part of the
+    # LogFormatter contract, so using LogCatcher is sufficient -- vila 100118
+    def test_log_file1(self):
+        self.prepare_tree()
+        self.assertLogRevnos(['-n0', 'file1'], ['1'])
+
+    def test_log_file2(self):
+        self.prepare_tree()
+        # file2 full history
+        self.assertLogRevnos(['-n0', 'file2'], ['4', '3.1.1', '2'])
+        # file2 in a merge revision
+        self.assertLogRevnos(['-n0', '-r3.1.1', 'file2'], ['3.1.1'])
+        # file2 in a mainline revision
+        self.assertLogRevnos(['-n0', '-r4', 'file2'], ['4', '3.1.1'])
+        # file2 since a revision
+        self.assertLogRevnos(['-n0', '-r3..', 'file2'], ['4', '3.1.1'])
+        # file2 up to a revision
+        self.assertLogRevnos(['-n0', '-r..3', 'file2'], ['2'])
+
+    def test_log_file3(self):
+        self.prepare_tree()
+        self.assertLogRevnos(['-n0', 'file3'], ['3'])
 
     def test_log_file_historical_missing(self):
         # Check logging a deleted file gives an error if the
@@ -918,25 +751,13 @@
         # Check logging a deleted file is ok if the file existed
         # at the end the revision range
         self.prepare_tree(complex=True)
-        log, err = self.run_bzr('log -n0 -r..4 file2')
-        self.assertEquals('', err)
-        self.assertNotContainsRe(log, 'revno: 1\n')
-        self.assertContainsRe(log, 'revno: 2\n')
-        self.assertNotContainsRe(log, 'revno: 3\n')
-        self.assertContainsRe(log, 'revno: 3.1.1\n')
-        self.assertContainsRe(log, 'revno: 4 ')
+        self.assertLogRevnos(['-n0', '-r..4', 'file2'], ['4', '3.1.1', '2'])
 
     def test_log_file_historical_start(self):
         # Check logging a deleted file is ok if the file existed
         # at the start of the revision range
         self.prepare_tree(complex=True)
-        log, err = self.run_bzr('log file1')
-        self.assertEquals('', err)
-        self.assertContainsRe(log, 'revno: 1\n')
-        self.assertNotContainsRe(log, 'revno: 2\n')
-        self.assertNotContainsRe(log, 'revno: 3\n')
-        self.assertNotContainsRe(log, 'revno: 3.1.1\n')
-        self.assertNotContainsRe(log, 'revno: 4 ')
+        self.assertLogRevnos(['file1'], ['1'])
 
     def test_log_file_renamed(self):
         """File matched against revision range, not current tree."""
@@ -948,79 +769,10 @@
         self.assertContainsRe(err, err_msg)
 
         # Check we can see a renamed file if we give the right end revision
-        log, err = self.run_bzr('log -r..4 file3')
-        self.assertEquals('', err)
-        self.assertNotContainsRe(log, 'revno: 1\n')
-        self.assertNotContainsRe(log, 'revno: 2\n')
-        self.assertContainsRe(log, 'revno: 3\n')
-        self.assertNotContainsRe(log, 'revno: 3.1.1\n')
-        self.assertNotContainsRe(log, 'revno: 4 ')
-
-    def test_line_log_file(self):
-        """The line log for a file should only list relevant mainline revs"""
-        # Note: this also implicitly  covers the short logging case.
-        # We test using --line in preference to --short because matching
-        # revnos in the output of --line is more reliable.
-        self.prepare_tree()
-
-        # full history of file1
-        log = self.run_bzr('log --line file1')[0]
-        self.assertContainsRe(log, '^1:', re.MULTILINE)
-        self.assertNotContainsRe(log, '^2:', re.MULTILINE)
-        self.assertNotContainsRe(log, '^3:', re.MULTILINE)
-        self.assertNotContainsRe(log, '^3.1.1:', re.MULTILINE)
-        self.assertNotContainsRe(log, '^4:', re.MULTILINE)
-
-        # full history of file2
-        log = self.run_bzr('log --line file2')[0]
-        self.assertNotContainsRe(log, '^1:', re.MULTILINE)
-        self.assertContainsRe(log, '^2:', re.MULTILINE)
-        self.assertNotContainsRe(log, '^3:', re.MULTILINE)
-        self.assertNotContainsRe(log, '^3.1.1:', re.MULTILINE)
-        self.assertContainsRe(log, '^4:', re.MULTILINE)
-
-        # full history of file3
-        log = self.run_bzr('log --line file3')[0]
-        self.assertNotContainsRe(log, '^1:', re.MULTILINE)
-        self.assertNotContainsRe(log, '^2:', re.MULTILINE)
-        self.assertContainsRe(log, '^3:', re.MULTILINE)
-        self.assertNotContainsRe(log, '^3.1.1:', re.MULTILINE)
-        self.assertNotContainsRe(log, '^4:', re.MULTILINE)
-
-        # file in a merge revision
-        log = self.run_bzr('log --line -r3.1.1 file2')[0]
-        self.assertNotContainsRe(log, '^1:', re.MULTILINE)
-        self.assertNotContainsRe(log, '^2:', re.MULTILINE)
-        self.assertNotContainsRe(log, '^3:', re.MULTILINE)
-        self.assertContainsRe(log, '^3.1.1:', re.MULTILINE)
-        self.assertNotContainsRe(log, '^4:', re.MULTILINE)
-
-        # file in a mainline revision
-        log = self.run_bzr('log --line -r4 file2')[0]
-        self.assertNotContainsRe(log, '^1:', re.MULTILINE)
-        self.assertNotContainsRe(log, '^2:', re.MULTILINE)
-        self.assertNotContainsRe(log, '^3:', re.MULTILINE)
-        self.assertNotContainsRe(log, '^3.1.1:', re.MULTILINE)
-        self.assertContainsRe(log, '^4:', re.MULTILINE)
-
-        # file since a revision
-        log = self.run_bzr('log --line -r3.. file2')[0]
-        self.assertNotContainsRe(log, '^1:', re.MULTILINE)
-        self.assertNotContainsRe(log, '^2:', re.MULTILINE)
-        self.assertNotContainsRe(log, '^3:', re.MULTILINE)
-        self.assertNotContainsRe(log, '^3.1.1:', re.MULTILINE)
-        self.assertContainsRe(log, '^4:', re.MULTILINE)
-
-        # file up to a revision
-        log = self.run_bzr('log --line -r..3 file2')[0]
-        self.assertNotContainsRe(log, '^1:', re.MULTILINE)
-        self.assertContainsRe(log, '^2:', re.MULTILINE)
-        self.assertNotContainsRe(log, '^3:', re.MULTILINE)
-        self.assertNotContainsRe(log, '^3.1.1:', re.MULTILINE)
-        self.assertNotContainsRe(log, '^4:', re.MULTILINE)
-
-
-class TestLogMultiple(tests.TestCaseWithTransport):
+        self.assertLogRevnos(['-r..4', 'file3'], ['3'])
+
+
+class TestLogMultiple(TestLogWithLogCatcher):
 
     def prepare_tree(self):
         tree = self.make_branch_and_tree('parent')
@@ -1049,42 +801,35 @@
         tree.commit(message='merge child branch')
         os.chdir('parent')
 
-    def assertRevnos(self, paths_str, expected_revnos):
-        # confirm the revision numbers in log --line output are those expected
-        out, err = self.run_bzr('log --line -n0 %s' % (paths_str,))
-        self.assertEqual('', err)
-        revnos = [s.split(':', 1)[0].lstrip() for s in out.splitlines()]
-        self.assertEqual(expected_revnos, revnos)
-
     def test_log_files(self):
         """The log for multiple file should only list revs for those files"""
         self.prepare_tree()
-        self.assertRevnos('file1 file2 dir1/dir2/file3',
-            ['6', '5.1.1', '3', '2', '1'])
+        self.assertLogRevnos(['file1', 'file2', 'dir1/dir2/file3'],
+                             ['6', '5.1.1', '3', '2', '1'])
 
     def test_log_directory(self):
         """The log for a directory should show all nested files."""
         self.prepare_tree()
-        self.assertRevnos('dir1', ['5', '3'])
+        self.assertLogRevnos(['dir1'], ['5', '3'])
 
     def test_log_nested_directory(self):
         """The log for a directory should show all nested files."""
         self.prepare_tree()
-        self.assertRevnos('dir1/dir2', ['3'])
+        self.assertLogRevnos(['dir1/dir2'], ['3'])
 
     def test_log_in_nested_directory(self):
         """The log for a directory should show all nested files."""
         self.prepare_tree()
         os.chdir("dir1")
-        self.assertRevnos('.', ['5', '3'])
+        self.assertLogRevnos(['.'], ['5', '3'])
 
     def test_log_files_and_directories(self):
         """Logging files and directories together should be fine."""
         self.prepare_tree()
-        self.assertRevnos('file4 dir1/dir2', ['4', '3'])
+        self.assertLogRevnos(['file4', 'dir1/dir2'], ['4', '3'])
 
     def test_log_files_and_dirs_in_nested_directory(self):
         """The log for a directory should show all nested files."""
         self.prepare_tree()
         os.chdir("dir1")
-        self.assertRevnos('dir2 file5', ['5', '3'])
+        self.assertLogRevnos(['dir2', 'file5'], ['5', '3'])

=== modified file 'bzrlib/tests/blackbox/test_non_ascii.py'
--- bzrlib/tests/blackbox/test_non_ascii.py	2010-01-06 05:06:56 +0000
+++ bzrlib/tests/blackbox/test_non_ascii.py	2010-01-25 17:48:22 +0000
@@ -40,9 +40,7 @@
         super(TestNonAscii, self).setUp()
         self._check_can_encode_paths()
 
-        self.addCleanup(setattr, osutils, "_cached_user_encoding",
-            osutils._cached_user_encoding)
-        osutils._cached_user_encoding = self.encoding
+        self.overrideAttr(osutils, '_cached_user_encoding', self.encoding)
         email = self.info['committer'] + ' <joe@foo.com>'
         os.environ['BZR_EMAIL'] = email.encode(osutils.get_user_encoding())
         self.create_base()

=== modified file 'bzrlib/tests/blackbox/test_outside_wt.py'
--- bzrlib/tests/blackbox/test_outside_wt.py	2009-09-19 16:14:10 +0000
+++ bzrlib/tests/blackbox/test_outside_wt.py	2010-01-25 15:55:48 +0000
@@ -36,7 +36,7 @@
         tmp_dir = osutils.realpath(osutils.mkdtemp())
         # We expect a read-to-root attempt to occur.
         self.permit_url('file:///')
-        self.addCleanup(lambda: osutils.rmtree(tmp_dir))
+        self.addCleanup(osutils.rmtree, tmp_dir)
         out, err = self.run_bzr('log', retcode=3, working_dir=tmp_dir)
         self.assertEqual(u'bzr: ERROR: Not a branch: "%s/".\n'
                          % (tmp_dir,),
@@ -57,7 +57,7 @@
         # false and may cause test failures).
         # Watch out for tricky test dir (on OSX /tmp -> /private/tmp)
         tmp_dir = osutils.realpath(osutils.mkdtemp())
-        self.addCleanup(lambda: osutils.rmtree(tmp_dir))
+        self.addCleanup(osutils.rmtree, tmp_dir)
         # We expect a read-to-root attempt to occur.
         self.permit_url('file:///')
         expected_error = u'bzr: ERROR: Not a branch: "%s/branch2/".\n' % tmp_dir

=== modified file 'bzrlib/tests/blackbox/test_pull.py'
--- bzrlib/tests/blackbox/test_pull.py	2010-01-15 03:34:28 +0000
+++ bzrlib/tests/blackbox/test_pull.py	2010-01-25 15:55:48 +0000
@@ -343,7 +343,7 @@
             def look_up(self, name, url):
                 return 'source'
         directories.register('foo:', FooService, 'Testing directory service')
-        self.addCleanup(lambda: directories.remove('foo:'))
+        self.addCleanup(directories.remove, 'foo:')
         self.run_bzr('pull foo:bar -d target')
         self.assertEqual(source_last, target.last_revision())
 

=== modified file 'bzrlib/tests/blackbox/test_re_sign.py'
--- bzrlib/tests/blackbox/test_re_sign.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/blackbox/test_re_sign.py	2010-01-25 17:48:22 +0000
@@ -21,13 +21,15 @@
 
 import os
 
-import bzrlib.gpg
+from bzrlib import (
+    gpg,
+    tests,
+    )
 from bzrlib.bzrdir import BzrDir
 from bzrlib.testament import Testament
-from bzrlib.tests import TestCaseInTempDir
-
-
-class ReSign(TestCaseInTempDir):
+
+
+class ReSign(tests.TestCaseInTempDir):
 
     def monkey_patch_gpg(self):
         """Monkey patch the gpg signing strategy to be a loopback.
@@ -35,15 +37,8 @@
         This also registers the cleanup, so that we will revert to
         the original gpg strategy when done.
         """
-        self._oldstrategy = bzrlib.gpg.GPGStrategy
-
         # monkey patch gpg signing mechanism
-        bzrlib.gpg.GPGStrategy = bzrlib.gpg.LoopbackGPGStrategy
-
-        self.addCleanup(self._fix_gpg_strategy)
-
-    def _fix_gpg_strategy(self):
-        bzrlib.gpg.GPGStrategy = self._oldstrategy
+        self.overrideAttr(gpg, 'GPGStrategy', gpg.LoopbackGPGStrategy)
 
     def setup_tree(self):
         wt = BzrDir.create_standalone_workingtree('.')

=== modified file 'bzrlib/tests/blackbox/test_reconcile.py'
--- bzrlib/tests/blackbox/test_reconcile.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/blackbox/test_reconcile.py	2010-01-25 17:48:22 +0000
@@ -17,27 +17,15 @@
 """Black box tests for the reconcile command."""
 
 
-import bzrlib
-import bzrlib.bzrdir as bzrdir
-from bzrlib.inventory import Inventory
-import bzrlib.repository as repository
-from bzrlib.tests import TestCaseWithTransport
-from bzrlib.tests import TestUIFactory
-from bzrlib.transport import get_transport
-import bzrlib.ui as ui
-
-
-class TrivialTest(TestCaseWithTransport):
-
-    def setUp(self):
-        super(TrivialTest, self).setUp()
-        self.old_format = bzrdir.BzrDirFormat.get_default_format()
-        self.old_ui_factory = ui.ui_factory
-        self.addCleanup(self.restoreDefaults)
-        ui.ui_factory = TestUIFactory()
-
-    def restoreDefaults(self):
-        ui.ui_factory = self.old_ui_factory
+from bzrlib import (
+    bzrdir,
+    inventory,
+    repository,
+    tests,
+    )
+
+
+class TrivialTest(tests.TestCaseWithTransport):
 
     def test_trivial_reconcile(self):
         t = bzrdir.BzrDir.create_standalone_workingtree('.')
@@ -60,7 +48,7 @@
         t = bzrdir.BzrDir.create_standalone_workingtree('.')
         # an empty inventory with no revision will trigger reconciliation.
         repo = t.branch.repository
-        inv = Inventory(revision_id='missing')
+        inv = inventory.Inventory(revision_id='missing')
         inv.root.revision='missing'
         repo.lock_write()
         repo.start_write_group()

=== modified file 'bzrlib/tests/blackbox/test_sign_my_commits.py'
--- bzrlib/tests/blackbox/test_sign_my_commits.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/blackbox/test_sign_my_commits.py	2010-01-25 17:48:22 +0000
@@ -19,13 +19,15 @@
 
 import os
 
-import bzrlib.gpg
+from bzrlib import (
+    gpg,
+    tests,
+    )
 from bzrlib.testament import Testament
-from bzrlib.tests import TestCaseWithTransport
 from bzrlib.workingtree import WorkingTree
 
 
-class SignMyCommits(TestCaseWithTransport):
+class SignMyCommits(tests.TestCaseWithTransport):
 
     def monkey_patch_gpg(self):
         """Monkey patch the gpg signing strategy to be a loopback.
@@ -33,15 +35,8 @@
         This also registers the cleanup, so that we will revert to
         the original gpg strategy when done.
         """
-        self._oldstrategy = bzrlib.gpg.GPGStrategy
-
         # monkey patch gpg signing mechanism
-        bzrlib.gpg.GPGStrategy = bzrlib.gpg.LoopbackGPGStrategy
-
-        self.addCleanup(self._fix_gpg_strategy)
-
-    def _fix_gpg_strategy(self):
-        bzrlib.gpg.GPGStrategy = self._oldstrategy
+        self.overrideAttr(gpg, 'GPGStrategy', gpg.LoopbackGPGStrategy)
 
     def setup_tree(self, location='.'):
         wt = self.make_branch_and_tree(location)

=== modified file 'bzrlib/tests/blackbox/test_upgrade.py'
--- bzrlib/tests/blackbox/test_upgrade.py	2009-08-21 02:10:06 +0000
+++ bzrlib/tests/blackbox/test_upgrade.py	2010-01-25 17:48:22 +0000
@@ -16,17 +16,13 @@
 
 """Black box tests for the upgrade ui."""
 
-import os
-
 from bzrlib import (
     bzrdir,
     repository,
-    ui,
     )
 from bzrlib.tests import (
     TestCaseInTempDir,
     TestCaseWithTransport,
-    TestUIFactory,
     )
 from bzrlib.tests.test_sftp_transport import TestCaseWithSFTPServer
 from bzrlib.transport import get_transport
@@ -39,14 +35,8 @@
 
     def setUp(self):
         super(TestWithUpgradableBranches, self).setUp()
-        self.old_format = bzrdir.BzrDirFormat.get_default_format()
-        self.old_ui_factory = ui.ui_factory
-        self.addCleanup(self.restoreDefaults)
-        ui.ui_factory = TestUIFactory()
-
-    def restoreDefaults(self):
-        ui.ui_factory = self.old_ui_factory
-        bzrdir.BzrDirFormat._set_default_format(self.old_format)
+        self.addCleanup(bzrdir.BzrDirFormat._set_default_format,
+                        bzrdir.BzrDirFormat.get_default_format())
 
     def make_current_format_branch_and_checkout(self):
         current_tree = self.make_branch_and_tree('current_format_branch',
@@ -158,16 +148,6 @@
 class SFTPTests(TestCaseWithSFTPServer):
     """Tests for upgrade over sftp."""
 
-    def setUp(self):
-        super(SFTPTests, self).setUp()
-        self.old_ui_factory = ui.ui_factory
-        self.addCleanup(self.restoreDefaults)
-
-        ui.ui_factory = TestUIFactory()
-
-    def restoreDefaults(self):
-        ui.ui_factory = self.old_ui_factory
-
     def test_upgrade_url(self):
         self.run_bzr('init --format=weave')
         t = get_transport(self.get_url())

=== modified file 'bzrlib/tests/commands/test_cat.py'
--- bzrlib/tests/commands/test_cat.py	2010-01-11 12:37:53 +0000
+++ bzrlib/tests/commands/test_cat.py	2010-01-25 17:48:22 +0000
@@ -25,15 +25,9 @@
 
     def setUp(self):
         super(TestCat, self).setUp()
-
-        def restore_stdout():
-            sys.stdout = self._stdout_orig
-
         # Redirect sys.stdout as this is what cat uses
         self.outf = StringIOWrapper()
-        self._stdout_orig = sys.stdout
-        sys.stdout = self.outf
-        self.addCleanup(restore_stdout)
+        self.overrideAttr(sys, 'stdout', self.outf)
 
     def test_cat(self):
         # FIXME: sftp raises ReadError instead of NoSuchFile when probing for

=== modified file 'bzrlib/tests/per_branch/test_break_lock.py'
--- bzrlib/tests/per_branch/test_break_lock.py	2009-07-17 10:38:41 +0000
+++ bzrlib/tests/per_branch/test_break_lock.py	2010-01-25 17:48:22 +0000
@@ -18,13 +18,12 @@
 
 from cStringIO import StringIO
 
-import bzrlib
-import bzrlib.errors as errors
+from  bzrlib import (
+    errors,
+    ui,
+    )
 from bzrlib.tests import TestCase, TestCaseWithTransport, TestNotApplicable
 from bzrlib.tests.per_branch.test_branch import TestCaseWithBranch
-from bzrlib.ui import (
-    CannedInputUIFactory,
-    )
 
 
 class TestBreakLock(TestCaseWithBranch):
@@ -33,14 +32,6 @@
         super(TestBreakLock, self).setUp()
         self.unused_branch = self.make_branch('branch')
         self.branch = self.unused_branch.bzrdir.open_branch()
-        # we want a UI factory that accepts canned input for the tests:
-        # while SilentUIFactory still accepts stdin, we need to customise
-        # ours
-        self.old_factory = bzrlib.ui.ui_factory
-        self.addCleanup(self.restoreFactory)
-
-    def restoreFactory(self):
-        bzrlib.ui.ui_factory = self.old_factory
 
     def test_unlocked(self):
         # break lock when nothing is locked should just return
@@ -61,7 +52,7 @@
         other_instance = self.branch.repository.bzrdir.open_repository()
         if not other_instance.get_physical_lock_status():
             raise TestNotApplicable("Repository does not lock persistently.")
-        bzrlib.ui.ui_factory = CannedInputUIFactory([True])
+        ui.ui_factory = ui.CannedInputUIFactory([True])
         try:
             self.unused_branch.break_lock()
         except NotImplementedError:
@@ -73,7 +64,7 @@
     def test_locked(self):
         # break_lock when locked should unlock the branch and repo
         self.branch.lock_write()
-        bzrlib.ui.ui_factory = CannedInputUIFactory([True, True])
+        ui.ui_factory = ui.CannedInputUIFactory([True, True])
         try:
             self.unused_branch.break_lock()
         except NotImplementedError:
@@ -92,7 +83,7 @@
             # this branch does not support binding.
             return
         master.lock_write()
-        bzrlib.ui.ui_factory = CannedInputUIFactory([True, True])
+        ui.ui_factory = ui.CannedInputUIFactory([True, True])
         try:
             self.unused_branch.break_lock()
         except NotImplementedError:

=== modified file 'bzrlib/tests/per_branch/test_push.py'
--- bzrlib/tests/per_branch/test_push.py	2010-01-15 05:11:41 +0000
+++ bzrlib/tests/per_branch/test_push.py	2010-01-25 17:48:22 +0000
@@ -275,15 +275,10 @@
     def disableOptimisticGetParentMap(self):
         # Tweak some class variables to stop remote get_parent_map calls asking
         # for or receiving more data than the caller asked for.
-        old_flag = SmartServerRepositoryGetParentMap.no_extra_results
-        inter_class = repository.InterRepository
-        old_batch_size = inter_class._walk_to_common_revisions_batch_size
-        inter_class._walk_to_common_revisions_batch_size = 1
-        SmartServerRepositoryGetParentMap.no_extra_results = True
-        def reset_values():
-            SmartServerRepositoryGetParentMap.no_extra_results = old_flag
-            inter_class._walk_to_common_revisions_batch_size = old_batch_size
-        self.addCleanup(reset_values)
+        self.overrideAttr(repository.InterRepository,
+                          '_walk_to_common_revisions_batch_size', 1)
+        self.overrideAttr(SmartServerRepositoryGetParentMap,
+                          'no_extra_results', True)
 
 
 class TestPushHook(TestCaseWithBranch):

=== modified file 'bzrlib/tests/per_bzrdir/test_bzrdir.py'
--- bzrlib/tests/per_bzrdir/test_bzrdir.py	2010-01-08 06:28:53 +0000
+++ bzrlib/tests/per_bzrdir/test_bzrdir.py	2010-01-25 17:48:22 +0000
@@ -1797,17 +1797,6 @@
 
 class TestBreakLock(TestCaseWithBzrDir):
 
-    def setUp(self):
-        super(TestBreakLock, self).setUp()
-        # we want a UI factory that accepts canned input for the tests:
-        # while SilentUIFactory still accepts stdin, we need to customise
-        # ours
-        self.old_factory = bzrlib.ui.ui_factory
-        self.addCleanup(self.restoreFactory)
-
-    def restoreFactory(self):
-        bzrlib.ui.ui_factory = self.old_factory
-
     def test_break_lock_empty(self):
         # break lock on an empty bzrdir should work silently.
         dir = self.make_bzrdir('.')

=== modified file 'bzrlib/tests/per_interbranch/test_push.py'
--- bzrlib/tests/per_interbranch/test_push.py	2009-08-20 04:09:58 +0000
+++ bzrlib/tests/per_interbranch/test_push.py	2010-01-25 17:48:22 +0000
@@ -255,7 +255,6 @@
         builder.build_snapshot('third', ['second'], [])
         builder.build_snapshot('fourth', ['third'], [])
         builder.finish_series()
-        local = builder.get_branch()
         local = branch.Branch.open(self.get_vfs_only_url('local'))
         # Initial push of three revisions
         remote_bzrdir = local.bzrdir.sprout(
@@ -281,15 +280,10 @@
     def disableOptimisticGetParentMap(self):
         # Tweak some class variables to stop remote get_parent_map calls asking
         # for or receiving more data than the caller asked for.
-        old_flag = SmartServerRepositoryGetParentMap.no_extra_results
-        inter_class = repository.InterRepository
-        old_batch_size = inter_class._walk_to_common_revisions_batch_size
-        inter_class._walk_to_common_revisions_batch_size = 1
-        SmartServerRepositoryGetParentMap.no_extra_results = True
-        def reset_values():
-            SmartServerRepositoryGetParentMap.no_extra_results = old_flag
-            inter_class._walk_to_common_revisions_batch_size = old_batch_size
-        self.addCleanup(reset_values)
+        self.overrideAttr(repository.InterRepository,
+                          '_walk_to_common_revisions_batch_size', 1)
+        self.overrideAttr(SmartServerRepositoryGetParentMap,
+                            'no_extra_results', True)
 
 
 class TestPushHook(TestCaseWithInterBranch):

=== modified file 'bzrlib/tests/per_interrepository/test_fetch.py'
--- bzrlib/tests/per_interrepository/test_fetch.py	2009-10-02 02:40:37 +0000
+++ bzrlib/tests/per_interrepository/test_fetch.py	2010-01-31 11:56:18 +0000
@@ -515,7 +515,7 @@
         from_tree.commit('foo', rev_id='foo-id')
         to_repo = self.make_to_repository('to')
         to_repo.fetch(from_tree.branch.repository)
-        recorded_inv_sha1 = to_repo.get_inventory_sha1('foo-id')
+        recorded_inv_sha1 = to_repo.get_revision('foo-id').inventory_sha1
         to_repo.lock_read()
         self.addCleanup(to_repo.unlock)
         stream = to_repo.inventories.get_record_stream([('foo-id',)],

=== modified file 'bzrlib/tests/per_merger.py'
--- bzrlib/tests/per_merger.py	2009-12-18 06:54:20 +0000
+++ bzrlib/tests/per_merger.py	2010-01-29 08:28:47 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,6 +18,7 @@
 
 import os
 
+from bzrlib.conflicts import TextConflict
 from bzrlib import (
     errors,
     merge as _mod_merge,
@@ -28,6 +29,7 @@
     multiply_tests,
     TestCaseWithTransport,
     )
+from bzrlib.tests.test_merge_core import MergeBuilder
 from bzrlib.transform import TreeTransform
 
 
@@ -140,7 +142,8 @@
         this_tree = branch.bzrdir.create_workingtree()
         this_tree.lock_write()
         self.addCleanup(this_tree.unlock)
-        other_tree = this_tree.bzrdir.sprout('other', 'OTHER-id').open_workingtree()
+        other_tree = this_tree.bzrdir.sprout('other',
+                                             'OTHER-id').open_workingtree()
         self.do_merge(this_tree, other_tree)
         if self.merge_type is _mod_merge.LCAMerger:
             self.expectFailure("lca merge doesn't track deleted lines",
@@ -172,7 +175,7 @@
         deletiondir = transform._deletiondir
         transform.finalize()
         return (limbodir, deletiondir)
-    
+
     def test_merge_with_existing_limbo(self):
         wt = self.make_branch_and_tree('this')
         (limbodir, deletiondir) =  self.get_limbodir_deletiondir(wt)
@@ -188,4 +191,213 @@
         self.assertRaises(errors.LockError, wt.unlock)
 
 
+class TestHookMergeFileContent(TestCaseWithTransport):
+    """Tests that the 'merge_file_content' hook is invoked."""
+
+    def setUp(self):
+        TestCaseWithTransport.setUp(self)
+        self.hook_log = []
+
+    def install_hook_inactive(self):
+        def inactive_factory(merger):
+            # This hook is never active
+            self.hook_log.append(('inactive',))
+            return None
+        _mod_merge.Merger.hooks.install_named_hook(
+            'merge_file_content', inactive_factory, 'test hook (inactive)')
+
+    def install_hook_noop(self):
+        test = self
+        class HookNA(_mod_merge.AbstractPerFileMerger):
+            def merge_contents(self, merge_params):
+                # This hook unconditionally does nothing.
+                test.hook_log.append(('no-op',))
+                return 'not_applicable', None
+        def hook_na_factory(merger):
+            return HookNA(merger)
+        _mod_merge.Merger.hooks.install_named_hook(
+            'merge_file_content', hook_na_factory, 'test hook (no-op)')
+
+    def install_hook_success(self):
+        test = self
+        class HookSuccess(_mod_merge.AbstractPerFileMerger):
+            def merge_contents(self, merge_params):
+                test.hook_log.append(('success',))
+                if merge_params.file_id == '1':
+                    return 'success', ['text-merged-by-hook']
+                return 'not_applicable', None
+        def hook_success_factory(merger):
+            return HookSuccess(merger)
+        _mod_merge.Merger.hooks.install_named_hook(
+            'merge_file_content', hook_success_factory, 'test hook (success)')
+
+    def install_hook_conflict(self):
+        test = self
+        class HookConflict(_mod_merge.AbstractPerFileMerger):
+            def merge_contents(self, merge_params):
+                test.hook_log.append(('conflict',))
+                if merge_params.file_id == '1':
+                    return ('conflicted',
+                        ['text-with-conflict-markers-from-hook'])
+                return 'not_applicable', None
+        def hook_conflict_factory(merger):
+            return HookConflict(merger)
+        _mod_merge.Merger.hooks.install_named_hook(
+            'merge_file_content', hook_conflict_factory, 'test hook (delete)')
+
+    def install_hook_delete(self):
+        test = self
+        class HookDelete(_mod_merge.AbstractPerFileMerger):
+            def merge_contents(self, merge_params):
+                test.hook_log.append(('delete',))
+                if merge_params.file_id == '1':
+                    return 'delete', None
+                return 'not_applicable', None
+        def hook_delete_factory(merger):
+            return HookDelete(merger)
+        _mod_merge.Merger.hooks.install_named_hook(
+            'merge_file_content', hook_delete_factory, 'test hook (delete)')
+
+    def install_hook_log_lines(self):
+        """Install a hook that saves the get_lines for the this, base and other
+        versions of the file.
+        """
+        test = self
+        class HookLogLines(_mod_merge.AbstractPerFileMerger):
+            def merge_contents(self, merge_params):
+                test.hook_log.append((
+                    'log_lines',
+                    merge_params.this_lines,
+                    merge_params.other_lines,
+                    merge_params.base_lines,
+                    ))
+                return 'not_applicable', None
+        def hook_log_lines_factory(merger):
+            return HookLogLines(merger)
+        _mod_merge.Merger.hooks.install_named_hook(
+            'merge_file_content', hook_log_lines_factory,
+            'test hook (log_lines)')
+
+    def make_merge_builder(self):
+        builder = MergeBuilder(self.test_base_dir)
+        self.addCleanup(builder.cleanup)
+        return builder
+
+    def create_file_needing_contents_merge(self, builder, file_id):
+        builder.add_file(file_id, builder.tree_root, "name1", "text1", True)
+        builder.change_contents(file_id, other="text4", this="text3")
+
+    def test_change_vs_change(self):
+        """Hook is used for (changed, changed)"""
+        self.install_hook_success()
+        builder = self.make_merge_builder()
+        builder.add_file("1", builder.tree_root, "name1", "text1", True)
+        builder.change_contents("1", other="text4", this="text3")
+        conflicts = builder.merge(self.merge_type)
+        self.assertEqual(conflicts, [])
+        self.assertEqual(
+            builder.this.get_file('1').read(), 'text-merged-by-hook')
+
+    def test_change_vs_deleted(self):
+        """Hook is used for (changed, deleted)"""
+        self.install_hook_success()
+        builder = self.make_merge_builder()
+        builder.add_file("1", builder.tree_root, "name1", "text1", True)
+        builder.change_contents("1", this="text2")
+        builder.remove_file("1", other=True)
+        conflicts = builder.merge(self.merge_type)
+        self.assertEqual(conflicts, [])
+        self.assertEqual(
+            builder.this.get_file('1').read(), 'text-merged-by-hook')
+
+    def test_result_can_be_delete(self):
+        """A hook's result can be the deletion of a file."""
+        self.install_hook_delete()
+        builder = self.make_merge_builder()
+        self.create_file_needing_contents_merge(builder, "1")
+        conflicts = builder.merge(self.merge_type)
+        self.assertEqual(conflicts, [])
+        self.assertRaises(errors.NoSuchId, builder.this.id2path, '1')
+        self.assertEqual([], list(builder.this.list_files()))
+
+    def test_result_can_be_conflict(self):
+        """A hook's result can be a conflict."""
+        self.install_hook_conflict()
+        builder = self.make_merge_builder()
+        self.create_file_needing_contents_merge(builder, "1")
+        conflicts = builder.merge(self.merge_type)
+        self.assertEqual(conflicts, [TextConflict('name1', file_id='1')])
+        # The hook still gets to set the file contents in this case, so that it
+        # can insert custom conflict markers.
+        self.assertEqual(
+            builder.this.get_file('1').read(),
+            'text-with-conflict-markers-from-hook')
+
+    def test_can_access_this_other_and_base_versions(self):
+        """The hook function can call params.merger.get_lines to access the
+        THIS/OTHER/BASE versions of the file.
+        """
+        self.install_hook_log_lines()
+        builder = self.make_merge_builder()
+        builder.add_file("1", builder.tree_root, "name1", "text1", True)
+        builder.change_contents("1", this="text2", other="text3")
+        conflicts = builder.merge(self.merge_type)
+        self.assertEqual(
+            [('log_lines', ['text2'], ['text3'], ['text1'])], self.hook_log)
+
+    def test_chain_when_not_active(self):
+        """When a hook function returns None, merging still works."""
+        self.install_hook_inactive()
+        self.install_hook_success()
+        builder = self.make_merge_builder()
+        self.create_file_needing_contents_merge(builder, "1")
+        conflicts = builder.merge(self.merge_type)
+        self.assertEqual(conflicts, [])
+        self.assertEqual(
+            builder.this.get_file('1').read(), 'text-merged-by-hook')
+        self.assertEqual([('inactive',), ('success',)], self.hook_log)
+
+    def test_chain_when_not_applicable(self):
+        """When a hook function returns not_applicable, the next function is
+        tried (when one exists).
+        """
+        self.install_hook_noop()
+        self.install_hook_success()
+        builder = self.make_merge_builder()
+        self.create_file_needing_contents_merge(builder, "1")
+        conflicts = builder.merge(self.merge_type)
+        self.assertEqual(conflicts, [])
+        self.assertEqual(
+            builder.this.get_file('1').read(), 'text-merged-by-hook')
+        self.assertEqual([('no-op',), ('success',)], self.hook_log)
+
+    def test_chain_stops_after_success(self):
+        """When a hook function returns success, no later functions are tried.
+        """
+        self.install_hook_success()
+        self.install_hook_noop()
+        builder = self.make_merge_builder()
+        self.create_file_needing_contents_merge(builder, "1")
+        conflicts = builder.merge(self.merge_type)
+        self.assertEqual([('success',)], self.hook_log)
+
+    def test_chain_stops_after_conflict(self):
+        """When a hook function returns conflict, no later functions are tried.
+        """
+        self.install_hook_conflict()
+        self.install_hook_noop()
+        builder = self.make_merge_builder()
+        self.create_file_needing_contents_merge(builder, "1")
+        conflicts = builder.merge(self.merge_type)
+        self.assertEqual([('conflict',)], self.hook_log)
+
+    def test_chain_stops_after_delete(self):
+        """When a hook function returns delete, no later functions are tried.
+        """
+        self.install_hook_delete()
+        self.install_hook_noop()
+        builder = self.make_merge_builder()
+        self.create_file_needing_contents_merge(builder, "1")
+        conflicts = builder.merge(self.merge_type)
+        self.assertEqual([('delete',)], self.hook_log)
 

=== modified file 'bzrlib/tests/per_pack_repository.py'
--- bzrlib/tests/per_pack_repository.py	2010-01-04 02:25:11 +0000
+++ bzrlib/tests/per_pack_repository.py	2010-01-25 17:48:22 +0000
@@ -590,10 +590,6 @@
     def prepare_for_break_lock(self):
         # Setup the global ui factory state so that a break-lock method call
         # will find usable input in the input stream.
-        old_factory = ui.ui_factory
-        def restoreFactory():
-            ui.ui_factory = old_factory
-        self.addCleanup(restoreFactory)
         ui.ui_factory = ui.CannedInputUIFactory([True])
 
     def test_break_lock_breaks_physical_lock(self):

=== modified file 'bzrlib/tests/per_repository/test_break_lock.py'
--- bzrlib/tests/per_repository/test_break_lock.py	2009-06-23 08:43:05 +0000
+++ bzrlib/tests/per_repository/test_break_lock.py	2010-01-25 17:48:22 +0000
@@ -18,14 +18,12 @@
 
 from cStringIO import StringIO
 
-import bzrlib
-import bzrlib.errors as errors
+from bzrlib import (
+    errors,
+    ui,
+    )
 from bzrlib.tests.per_repository.test_repository import TestCaseWithRepository
-from bzrlib.transport import get_transport
 from bzrlib.workingtree import WorkingTree
-from bzrlib.ui import (
-    CannedInputUIFactory,
-    )
 
 
 class TestBreakLock(TestCaseWithRepository):
@@ -34,15 +32,7 @@
         super(TestBreakLock, self).setUp()
         self.unused_repo = self.make_repository('.')
         self.repo = self.unused_repo.bzrdir.open_repository()
-        # we want a UI factory that accepts canned input for the tests:
-        # while SilentUIFactory still accepts stdin, we need to customise
-        # ours
-        self.old_factory = bzrlib.ui.ui_factory
-        self.addCleanup(self.restoreFactory)
-        bzrlib.ui.ui_factory = CannedInputUIFactory([True])
-
-    def restoreFactory(self):
-        bzrlib.ui.ui_factory = self.old_factory
+        ui.ui_factory = ui.CannedInputUIFactory([True])
 
     def test_unlocked(self):
         # break lock when nothing is locked should just return

=== modified file 'bzrlib/tests/per_repository_reference/test_break_lock.py'
--- bzrlib/tests/per_repository_reference/test_break_lock.py	2009-06-23 08:43:05 +0000
+++ bzrlib/tests/per_repository_reference/test_break_lock.py	2010-01-25 17:48:22 +0000
@@ -16,14 +16,13 @@
 
 """Tests for break_lock on a repository with external references."""
 
-import bzrlib.ui
-from bzrlib import errors
+from bzrlib import (
+    errors,
+    ui,
+    )
 from bzrlib.tests.per_repository_reference import (
     TestCaseWithExternalReferenceRepository,
     )
-from bzrlib.ui import (
-    CannedInputUIFactory,
-    )
 
 
 class TestBreakLock(TestCaseWithExternalReferenceRepository):
@@ -42,8 +41,6 @@
             # 'lock_write' has not taken a physical mutex out.
             repo.unlock()
             return
-        self.old_factory = bzrlib.ui.ui_factory
-        self.addCleanup(self.restoreFactory)
-        bzrlib.ui.ui_factory = CannedInputUIFactory([True])
+        ui.ui_factory = ui.CannedInputUIFactory([True])
         unused_repo.break_lock()
         self.assertRaises(errors.LockBroken, repo.unlock)

=== modified file 'bzrlib/tests/per_versionedfile.py'
--- bzrlib/tests/per_versionedfile.py	2009-10-26 06:44:40 +0000
+++ bzrlib/tests/per_versionedfile.py	2010-01-25 15:55:48 +0000
@@ -1470,7 +1470,7 @@
             transport.mkdir('.')
         files = self.factory(transport)
         if self.cleanup is not None:
-            self.addCleanup(lambda:self.cleanup(files))
+            self.addCleanup(self.cleanup, files)
         return files
 
     def get_simple_key(self, suffix):

=== modified file 'bzrlib/tests/per_workingtree/test_break_lock.py'
--- bzrlib/tests/per_workingtree/test_break_lock.py	2009-07-17 10:38:41 +0000
+++ bzrlib/tests/per_workingtree/test_break_lock.py	2010-01-25 17:48:22 +0000
@@ -18,8 +18,10 @@
 from cStringIO import StringIO
 import os
 
-import bzrlib
-import bzrlib.errors as errors
+from bzrlib import (
+    errors,
+    ui,
+    )
 from bzrlib.tests import TestNotApplicable
 from bzrlib.tests.per_workingtree import TestCaseWithWorkingTree
 
@@ -30,11 +32,6 @@
         super(TestBreakLock, self).setUp()
         self.unused_workingtree = self.make_branch_and_tree('.')
         self.workingtree = self.unused_workingtree.bzrdir.open_workingtree()
-        self.old_factory = bzrlib.ui.ui_factory
-        self.addCleanup(self.restoreFactory)
-
-    def restoreFactory(self):
-        bzrlib.ui.ui_factory = self.old_factory
 
     def test_unlocked(self):
         # break lock when nothing is locked should just return
@@ -48,14 +45,14 @@
         # if the workingtree isn't locked - and the easiest way
         # to see if that happened is to lock the repo.
         self.workingtree.branch.repository.lock_write()
-        bzrlib.ui.ui_factory = bzrlib.ui.CannedInputUIFactory([True])
+        ui.ui_factory = ui.CannedInputUIFactory([True])
         try:
             self.unused_workingtree.break_lock()
         except NotImplementedError:
             # workingtree does not support break_lock
             self.workingtree.branch.repository.unlock()
             return
-        if bzrlib.ui.ui_factory.responses == [True]:
+        if ui.ui_factory.responses == [True]:
             raise TestNotApplicable("repository does not physically lock.")
         self.assertRaises(errors.LockBroken,
             self.workingtree.branch.repository.unlock)
@@ -63,7 +60,7 @@
     def test_locked(self):
         # break_lock when locked should
         self.workingtree.lock_write()
-        bzrlib.ui.ui_factory = bzrlib.ui.CannedInputUIFactory([True, True, True])
+        ui.ui_factory = ui.CannedInputUIFactory([True, True, True])
         try:
             self.unused_workingtree.break_lock()
         except (NotImplementedError, errors.LockActive):

=== modified file 'bzrlib/tests/per_workingtree/test_commit.py'
--- bzrlib/tests/per_workingtree/test_commit.py	2009-09-07 23:14:05 +0000
+++ bzrlib/tests/per_workingtree/test_commit.py	2010-01-25 17:48:22 +0000
@@ -505,8 +505,9 @@
 
 class TestCommitProgress(TestCaseWithWorkingTree):
 
-    def restoreDefaults(self):
-        ui.ui_factory = self.old_ui_factory
+    def setUp(self):
+        super(TestCommitProgress, self).setUp()
+        ui.ui_factory = CapturingUIFactory()
 
     def test_commit_progress_steps(self):
         # during commit we one progress update for every entry in the
@@ -525,8 +526,6 @@
         f.close()
         # set a progress bar that captures the calls so we can see what is
         # emitted
-        self.old_ui_factory = ui.ui_factory
-        self.addCleanup(self.restoreDefaults)
         factory = CapturingUIFactory()
         ui.ui_factory = factory
         # TODO RBC 20060421 it would be nice to merge the reporter output
@@ -548,8 +547,6 @@
         tree = self.make_branch_and_tree('.')
         # set a progress bar that captures the calls so we can see what is
         # emitted
-        self.old_ui_factory = ui.ui_factory
-        self.addCleanup(self.restoreDefaults)
         factory = CapturingUIFactory()
         ui.ui_factory = factory
         def a_hook(_, _2, _3, _4, _5, _6):
@@ -573,8 +570,6 @@
         tree = self.make_branch_and_tree('.')
         # set a progress bar that captures the calls so we can see what is
         # emitted
-        self.old_ui_factory = ui.ui_factory
-        self.addCleanup(self.restoreDefaults)
         factory = CapturingUIFactory()
         ui.ui_factory = factory
         def a_hook(_, _2, _3, _4, _5, _6, _7, _8):
@@ -621,9 +616,6 @@
                 mutabletree.MutableTree))
             open(tree.abspath("newfile"), 'w').write("data")
             params.mutable_tree.add(["newfile"])
-        def restoreDefaults():
-            mutabletree.MutableTree.hooks['post_commit'] = []
-        self.addCleanup(restoreDefaults)
         tree = self.make_branch_and_tree('.')
         mutabletree.MutableTree.hooks.install_named_hook(
             'post_commit',

=== modified file 'bzrlib/tests/per_workingtree/test_content_filters.py'
--- bzrlib/tests/per_workingtree/test_content_filters.py	2009-10-28 23:34:13 +0000
+++ bzrlib/tests/per_workingtree/test_content_filters.py	2010-01-25 17:48:22 +0000
@@ -123,16 +123,12 @@
         # the easiest way currently given we don't have easy access to the
         # WorkingTree after it is created but before the filter stack is used
         # to populate content.
-        self.real_content_filter_stack = WorkingTree._content_filter_stack
-        def restore_real_content_filter_stack():
-            WorkingTree._content_filter_stack = self.real_content_filter_stack
-        self.addCleanup(restore_real_content_filter_stack)
-        def _content_filter_stack(tree, path=None, file_id=None):
+        def new_stack(tree, path=None, file_id=None):
             if path.endswith('.txt'):
                 return [ContentFilter(_swapcase, _swapcase)]
             else:
                 return []
-        WorkingTree._content_filter_stack = _content_filter_stack
+        self.overrideAttr(WorkingTree, '_content_filter_stack', new_stack)
 
     def assert_basis_content(self, expected_content, branch, file_id):
         # Note: We need to use try/finally here instead of addCleanup()

=== modified file 'bzrlib/tests/per_workingtree/test_eol_conversion.py'
--- bzrlib/tests/per_workingtree/test_eol_conversion.py	2009-07-10 07:14:02 +0000
+++ bzrlib/tests/per_workingtree/test_eol_conversion.py	2010-01-25 17:48:22 +0000
@@ -67,10 +67,8 @@
 
     def prepare_tree(self, content, eol=None):
         """Prepare a working tree and commit some content."""
-        def restore_real_rules_searcher():
-            WorkingTree._get_rules_searcher = self.real_rules_searcher
-        self.real_rules_searcher = WorkingTree._get_rules_searcher
-        self.addCleanup(restore_real_rules_searcher)
+        self.real_rules_searcher = self.overrideAttr(
+            WorkingTree, '_get_rules_searcher')
         self.patch_rules_searcher(eol)
         t = self.make_branch_and_tree('tree1')
         self.build_tree_contents([('tree1/file1', content)])

=== modified file 'bzrlib/tests/per_workingtree/test_is_ignored.py'
--- bzrlib/tests/per_workingtree/test_is_ignored.py	2009-07-10 07:14:02 +0000
+++ bzrlib/tests/per_workingtree/test_is_ignored.py	2010-01-01 21:26:25 +0000
@@ -31,11 +31,15 @@
             ('.bzrignore', './rootdir\n'
                            'randomfile*\n'
                            '*bar\n'
+                           '!bazbar\n'
                            '?foo\n'
                            '*.~*\n'
                            'dir1/*f1\n'
                            'dir1/?f2\n'
+                           'RE:dir2/.*\.wombat\n'
                            'path/from/ro?t\n'
+                           '**/piffle.py\n'
+                           '!b/piffle.py\n'
                            'unicode\xc2\xb5\n' # u'\xb5'.encode('utf8')
                            'dos\r\n'
                            '\n' # empty line
@@ -58,6 +62,12 @@
         self.assertEqual("path/from/ro?t", tree.is_ignored('path/from/root'))
         self.assertEqual("path/from/ro?t", tree.is_ignored('path/from/roat'))
         self.assertEqual(None, tree.is_ignored('roat'))
+        
+        self.assertEqual('**/piffle.py', tree.is_ignored('piffle.py'))
+        self.assertEqual('**/piffle.py', tree.is_ignored('a/piffle.py'))
+        self.assertEqual(None, tree.is_ignored('b/piffle.py')) # exclusion
+        self.assertEqual('**/piffle.py', tree.is_ignored('foo/bar/piffle.py'))
+        self.assertEqual(None, tree.is_ignored('p/iffle.py'))
 
         self.assertEqual(u'unicode\xb5', tree.is_ignored(u'unicode\xb5'))
         self.assertEqual(u'unicode\xb5', tree.is_ignored(u'subdir/unicode\xb5'))
@@ -72,6 +82,8 @@
         self.assertEqual('*bar', tree.is_ignored(r'foo\nbar'))
         self.assertEqual('*bar', tree.is_ignored('bar'))
         self.assertEqual('*bar', tree.is_ignored('.bar'))
+        
+        self.assertEqual(None, tree.is_ignored('bazbar')) # exclusion
 
         self.assertEqual('?foo', tree.is_ignored('afoo'))
         self.assertEqual('?foo', tree.is_ignored('.foo'))
@@ -84,6 +96,9 @@
 
         self.assertEqual('dir1/?f2', tree.is_ignored('dir1/ff2'))
         self.assertEqual('dir1/?f2', tree.is_ignored('dir1/.f2'))
+        
+        self.assertEqual('RE:dir2/.*\.wombat', tree.is_ignored('dir2/foo.wombat'))
+        self.assertEqual(None, tree.is_ignored('dir2/foo'))
 
         # Blank lines and comments should be ignored
         self.assertEqual(None, tree.is_ignored(''))

=== modified file 'bzrlib/tests/per_workingtree/test_readonly.py'
--- bzrlib/tests/per_workingtree/test_readonly.py	2009-07-10 07:14:02 +0000
+++ bzrlib/tests/per_workingtree/test_readonly.py	2010-01-25 15:55:48 +0000
@@ -60,13 +60,9 @@
 
     def set_dirs_readonly(self, basedir):
         """Set all directories readonly, and have it cleanup on test exit."""
+        self.addCleanup(self._set_all_dirs, basedir, readonly=False)
         self._set_all_dirs(basedir, readonly=True)
 
-        def cleanup():
-            self._set_all_dirs(basedir, readonly=False)
-
-        self.addCleanup(cleanup)
-
     def create_basic_tree(self):
         tree = self.make_branch_and_tree('tree')
         self.build_tree(['tree/a', 'tree/b/', 'tree/b/c'])

=== modified file 'bzrlib/tests/test__dirstate_helpers.py'
--- bzrlib/tests/test__dirstate_helpers.py	2010-01-05 07:22:59 +0000
+++ bzrlib/tests/test__dirstate_helpers.py	2010-01-25 17:48:22 +0000
@@ -831,11 +831,7 @@
 
     def setUp(self):
         super(TestUpdateEntry, self).setUp()
-        orig = dirstate.update_entry
-        def cleanup():
-            dirstate.update_entry = orig
-        self.addCleanup(cleanup)
-        dirstate.update_entry = self.update_entry
+        self.overrideAttr(dirstate, 'update_entry', self.update_entry)
 
     def get_state_with_a(self):
         """Create a DirState tracking a single object named 'a'"""
@@ -1278,11 +1274,7 @@
 
     def setUp(self):
         super(TestProcessEntry, self).setUp()
-        orig = dirstate._process_entry
-        def cleanup():
-            dirstate._process_entry = orig
-        self.addCleanup(cleanup)
-        dirstate._process_entry = self._process_entry
+        self.overrideAttr(dirstate, '_process_entry', self._process_entry)
 
     def assertChangedFileIds(self, expected, tree):
         tree.lock_read()
@@ -1297,8 +1289,6 @@
         # This is a direct test of bug #495023, it relies on osutils.is_inside
         # getting called in an inner function. Which makes it a bit brittle,
         # but at least it does reproduce the bug.
-        def is_inside_raises(*args, **kwargs):
-            raise RuntimeError('stop this')
         tree = self.make_branch_and_tree('tree')
         self.build_tree(['tree/file', 'tree/dir/', 'tree/dir/sub',
                          'tree/dir2/', 'tree/dir2/sub2'])
@@ -1307,9 +1297,9 @@
         tree.lock_read()
         self.addCleanup(tree.unlock)
         basis_tree = tree.basis_tree()
-        orig = osutils.is_inside
-        self.addCleanup(setattr, osutils, 'is_inside', orig)
-        osutils.is_inside = is_inside_raises
+        def is_inside_raises(*args, **kwargs):
+            raise RuntimeError('stop this')
+        self.overrideAttr(osutils, 'is_inside', is_inside_raises)
         self.assertListRaises(RuntimeError, tree.iter_changes, basis_tree)
 
     def test_simple_changes(self):

=== modified file 'bzrlib/tests/test_btree_index.py'
--- bzrlib/tests/test_btree_index.py	2009-12-22 15:50:40 +0000
+++ bzrlib/tests/test_btree_index.py	2010-01-25 17:48:22 +0000
@@ -59,11 +59,7 @@
 
     def setUp(self):
         TestCaseWithTransport.setUp(self)
-        self._original_header = btree_index._RESERVED_HEADER_BYTES
-        def restore():
-            btree_index._RESERVED_HEADER_BYTES = self._original_header
-        self.addCleanup(restore)
-        btree_index._RESERVED_HEADER_BYTES = 100
+        self.overrideAttr(btree_index, '_RESERVED_HEADER_BYTES', 100)
 
     def make_nodes(self, count, key_elements, reference_lists):
         """Generate count*key_elements sample nodes."""
@@ -103,10 +99,7 @@
 
     def shrink_page_size(self):
         """Shrink the default page size so that less fits in a page."""
-        old_page_size = btree_index._PAGE_SIZE
-        def cleanup():
-            btree_index._PAGE_SIZE = old_page_size
-        self.addCleanup(cleanup)
+        self.overrideAttr(btree_index, '_PAGE_SIZE')
         btree_index._PAGE_SIZE = 2048
 
 
@@ -1157,14 +1150,9 @@
 
 class TestBTreeNodes(BTreeTestCase):
 
-    def restore_parser(self):
-        btree_index._btree_serializer = self.saved_parser
-
     def setUp(self):
         BTreeTestCase.setUp(self)
-        self.saved_parser = btree_index._btree_serializer
-        self.addCleanup(self.restore_parser)
-        btree_index._btree_serializer = self.parse_btree
+        self.overrideAttr(btree_index, '_btree_serializer', self.parse_btree)
 
     def test_LeafNode_1_0(self):
         node_bytes = ("type=leaf\n"

=== modified file 'bzrlib/tests/test_bugtracker.py'
--- bzrlib/tests/test_bugtracker.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/test_bugtracker.py	2010-01-25 15:55:48 +0000
@@ -41,8 +41,7 @@
         self.tracker_type = TestGetBugURL.TransientTracker
         self.tracker_type.log = []
         bugtracker.tracker_registry.register('transient', self.tracker_type)
-        self.addCleanup(lambda:
-                        bugtracker.tracker_registry.remove('transient'))
+        self.addCleanup(bugtracker.tracker_registry.remove, 'transient')
 
     def test_get_bug_url_for_transient_tracker(self):
         branch = self.make_branch('some_branch')
@@ -194,7 +193,7 @@
         """If asked for a valid tag, return a tracker instance that can map bug
         IDs to <base_url>/<bug_area> + <bug_id>."""
         bugtracker.tracker_registry.register('some', self.tracker)
-        self.addCleanup(lambda: bugtracker.tracker_registry.remove('some'))
+        self.addCleanup(bugtracker.tracker_registry.remove, 'some')
 
         branch = self.make_branch('some_branch')
         config = branch.get_config()

=== modified file 'bzrlib/tests/test_bundle.py'
--- bzrlib/tests/test_bundle.py	2010-01-08 02:43:49 +0000
+++ bzrlib/tests/test_bundle.py	2010-01-31 12:05:38 +0000
@@ -1039,7 +1039,7 @@
         bundle = read_bundle(self.create_bundle_text('null:', 'rev2')[0])
         repo = self.make_repository('repo', format='dirstate-with-subtree')
         bundle.install_revisions(repo)
-        inv_text = repo.get_inventory_xml('rev2')
+        inv_text = repo._get_inventory_xml('rev2')
         self.assertNotContainsRe(inv_text, 'format="5"')
         self.assertContainsRe(inv_text, 'format="7"')
 
@@ -1065,8 +1065,8 @@
 
     def test_inv_hash_across_serializers(self):
         repo = self.make_repo_with_installed_revisions()
-        recorded_inv_sha1 = repo.get_inventory_sha1('rev2')
-        xml = repo.get_inventory_xml('rev2')
+        recorded_inv_sha1 = repo.get_revision('rev2').inventory_sha1
+        xml = repo._get_inventory_xml('rev2')
         self.assertEqual(osutils.sha_string(xml), recorded_inv_sha1)
 
     def test_across_models_incompatible(self):
@@ -1820,7 +1820,7 @@
             def look_up(self, name, url):
                 return 'source'
         directories.register('foo:', FooService, 'Testing directory service')
-        self.addCleanup(lambda: directories.remove('foo:'))
+        self.addCleanup(directories.remove, 'foo:')
         self.build_tree_contents([('./foo:bar', out.getvalue())])
         self.assertRaises(errors.NotABundle, read_mergeable_from_url,
                           'foo:bar')

=== modified file 'bzrlib/tests/test_chk_map.py'
--- bzrlib/tests/test_chk_map.py	2009-10-21 20:53:21 +0000
+++ bzrlib/tests/test_chk_map.py	2010-01-29 15:18:58 +0000
@@ -905,7 +905,7 @@
         # Unmapping the new node will check the existing nodes to see if they
         # would fit.
         # Clear the page cache so we ensure we have to read all the children
-        chk_map._page_cache.clear()
+        chk_map.clear_cache()
         chkmap.unmap(('aad',))
         self.assertIsInstance(chkmap._root_node._items['aaa'], LeafNode)
         self.assertIsInstance(chkmap._root_node._items['aab'], LeafNode)
@@ -945,12 +945,12 @@
         # Now clear the page cache, and only include 2 of the children in the
         # cache
         aab_key = chkmap._root_node._items['aab']
-        aab_bytes = chk_map._page_cache[aab_key]
+        aab_bytes = chk_map._get_cache()[aab_key]
         aac_key = chkmap._root_node._items['aac']
-        aac_bytes = chk_map._page_cache[aac_key]
-        chk_map._page_cache.clear()
-        chk_map._page_cache[aab_key] = aab_bytes
-        chk_map._page_cache[aac_key] = aac_bytes
+        aac_bytes = chk_map._get_cache()[aac_key]
+        chk_map.clear_cache()
+        chk_map._get_cache()[aab_key] = aab_bytes
+        chk_map._get_cache()[aac_key] = aac_bytes
 
         # Unmapping the new node will check the nodes from the page cache
         # first, and not have to read in 'aaa'

=== modified file 'bzrlib/tests/test_config.py'
--- bzrlib/tests/test_config.py	2009-12-22 23:09:50 +0000
+++ bzrlib/tests/test_config.py	2010-01-25 17:48:22 +0000
@@ -1670,11 +1670,8 @@
             'password ignored in section \[ssh with password\]')
 
     def test_uses_fallback_stores(self):
-        self._old_cs_registry = config.credential_store_registry
-        def restore():
-            config.credential_store_registry = self._old_cs_registry
-        self.addCleanup(restore)
-        config.credential_store_registry = config.CredentialStoreRegistry()
+        self.overrideAttr(config, 'credential_store_registry',
+                          config.CredentialStoreRegistry())
         store = StubCredentialStore()
         store.add_credentials("http", "example.com", "joe", "secret")
         config.credential_store_registry.register("stub", store, fallback=True)

=== modified file 'bzrlib/tests/test_directory_service.py'
--- bzrlib/tests/test_directory_service.py	2009-11-10 04:58:31 +0000
+++ bzrlib/tests/test_directory_service.py	2010-01-25 15:55:48 +0000
@@ -54,7 +54,7 @@
 
     def test_get_transport(self):
         directories.register('foo:', FooService, 'Map foo URLs to http urls')
-        self.addCleanup(lambda: directories.remove('foo:'))
+        self.addCleanup(directories.remove, 'foo:')
         self.assertEqual(FooService.base + 'bar/',
                          get_transport('foo:bar').base)
 

=== modified file 'bzrlib/tests/test_dirstate.py'
--- bzrlib/tests/test_dirstate.py	2010-01-12 20:51:58 +0000
+++ bzrlib/tests/test_dirstate.py	2010-01-25 17:48:22 +0000
@@ -64,14 +64,8 @@
     def setUp(self):
         tests.TestCaseWithTransport.setUp(self)
 
-        # Save platform specific info and reset it
-        cur_dir_reader = osutils._selected_dir_reader
-
-        def restore():
-            osutils._selected_dir_reader = cur_dir_reader
-        self.addCleanup(restore)
-
-        osutils._selected_dir_reader = self._dir_reader_class()
+        self.overrideAttr(osutils,
+                          '_selected_dir_reader', self._dir_reader_class())
 
     def create_empty_dirstate(self):
         """Return a locked but empty dirstate"""

=== modified file 'bzrlib/tests/test_errors.py'
--- bzrlib/tests/test_errors.py	2010-01-12 02:48:41 +0000
+++ bzrlib/tests/test_errors.py	2010-01-20 22:32:07 +0000
@@ -708,3 +708,8 @@
             socket.error(13, 'Permission denied'))
         self.assertContainsRe(str(e),
             r'Cannot bind address "example\.com:22":.*Permission denied')
+
+    def test_file_timestamp_unavailable(self):            
+        e = errors.FileTimestampUnavailable("/path/foo")
+        self.assertEquals("The filestamp for /path/foo is not available.",
+            str(e))

=== modified file 'bzrlib/tests/test_export.py'
--- bzrlib/tests/test_export.py	2009-07-29 13:46:55 +0000
+++ bzrlib/tests/test_export.py	2010-02-01 22:22:28 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,7 +15,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 import os
-
+import time
 
 from bzrlib import (
     errors,
@@ -62,3 +62,30 @@
         wt.commit('1')
         self.build_tree(['target/', 'target/foo'])
         self.assertRaises(errors.BzrError, export.export, wt, 'target', format="dir")
+
+    def test_dir_export_files_same_timestamp(self):
+        builder = self.make_branch_builder('source')
+        builder.start_series()
+        builder.build_snapshot(None, None, [
+            ('add', ('', 'root-id', 'directory', '')),
+            ('add', ('a', 'a-id', 'file', 'content\n'))])
+        builder.build_snapshot(None, None, [
+            ('add', ('b', 'b-id', 'file', 'content\n'))])
+        builder.finish_series()
+        b = builder.get_branch()
+        b.lock_read()
+        self.addCleanup(b.unlock)
+        tree = b.basis_tree()
+        orig_iter_files_bytes = tree.iter_files_bytes
+        # Make iter_files_bytes slower, so we provoke mtime skew
+        def iter_files_bytes(to_fetch):
+            for thing in orig_iter_files_bytes(to_fetch):
+                yield thing
+                time.sleep(1)
+        tree.iter_files_bytes = iter_files_bytes
+        export.export(tree, 'target', format='dir')
+        t = self.get_transport('target')
+        st_a = t.stat('a')
+        st_b = t.stat('b')
+        # All files must be given the same mtime.
+        self.assertEqual(st_a.st_mtime, st_b.st_mtime)

=== modified file 'bzrlib/tests/test_fetch.py'
--- bzrlib/tests/test_fetch.py	2009-07-10 06:46:10 +0000
+++ bzrlib/tests/test_fetch.py	2010-01-25 17:48:22 +0000
@@ -404,11 +404,7 @@
         source.inventories = versionedfile.RecordingVersionedFilesDecorator(
                         source.inventories)
         # XXX: This won't work in general, but for the dirstate format it does.
-        old_fetch_uses_deltas_setting = target._format._fetch_uses_deltas
-        def restore():
-            target._format._fetch_uses_deltas = old_fetch_uses_deltas_setting
-        self.addCleanup(restore)
-        target._format._fetch_uses_deltas = False
+        self.overrideAttr(target._format, '_fetch_uses_deltas', False)
         target.fetch(source, revision_id='rev-one')
         self.assertEqual(('get_record_stream', [('file-id', 'rev-one')],
                           target._format._fetch_order, True),

=== modified file 'bzrlib/tests/test_globbing.py'
--- bzrlib/tests/test_globbing.py	2009-11-11 21:38:02 +0000
+++ bzrlib/tests/test_globbing.py	2010-01-11 16:44:02 +0000
@@ -17,6 +17,7 @@
 
 from bzrlib.globbing import (
     Globster,
+    ExceptionGlobster,
     _OrderedGlobster,
     normalize_pattern
     )
@@ -307,6 +308,30 @@
             self.assertEqual(patterns[x],globster.match(filename))
         self.assertEqual(None,globster.match('foobar.300'))
 
+class TestExceptionGlobster(TestCase):
+
+    def test_exclusion_patterns(self):
+        """test that exception patterns are not matched"""
+        patterns = [ u'*', u'!./local', u'!./local/**/*', u'!RE:\.z.*',u'!!./.zcompdump' ]
+        globster = ExceptionGlobster(patterns)
+        self.assertEqual(u'*', globster.match('tmp/foo.txt'))
+        self.assertEqual(None, globster.match('local'))
+        self.assertEqual(None, globster.match('local/bin/wombat'))
+        self.assertEqual(None, globster.match('.zshrc'))
+        self.assertEqual(None, globster.match('.zfunctions/fiddle/flam'))
+        self.assertEqual(u'!!./.zcompdump', globster.match('.zcompdump'))
+
+    def test_exclusion_order(self):
+        """test that ordering of exclusion patterns does not matter"""
+        patterns = [ u'static/**/*.html', u'!static/**/versionable.html']
+        globster = ExceptionGlobster(patterns)
+        self.assertEqual(u'static/**/*.html', globster.match('static/foo.html'))
+        self.assertEqual(None, globster.match('static/versionable.html'))
+        self.assertEqual(None, globster.match('static/bar/versionable.html'))
+        globster = ExceptionGlobster(reversed(patterns))
+        self.assertEqual(u'static/**/*.html', globster.match('static/foo.html'))
+        self.assertEqual(None, globster.match('static/versionable.html'))
+        self.assertEqual(None, globster.match('static/bar/versionable.html'))
 
 class TestOrderedGlobster(TestCase):
 

=== modified file 'bzrlib/tests/test_http.py'
--- bzrlib/tests/test_http.py	2010-01-07 03:03:01 +0000
+++ bzrlib/tests/test_http.py	2010-01-29 10:36:23 +0000
@@ -391,10 +391,10 @@
         self.assertEqual('http://example.com', url)
         self.assertEqual(0, len(f.credentials))
         url = http.extract_auth(
-            'http://user:pass@www.bazaar-vcs.org/bzr/bzr.dev', f)
-        self.assertEqual('http://www.bazaar-vcs.org/bzr/bzr.dev', url)
+            'http://user:pass@example.com/bzr/bzr.dev', f)
+        self.assertEqual('http://example.com/bzr/bzr.dev', url)
         self.assertEqual(1, len(f.credentials))
-        self.assertEqual([None, 'www.bazaar-vcs.org', 'user', 'pass'],
+        self.assertEqual([None, 'example.com', 'user', 'pass'],
                          f.credentials[0])
 
 
@@ -452,26 +452,22 @@
         # Import the module locally now that we now it's available.
         pycurl = features.pycurl.module
 
-        version_info_orig = pycurl.version_info
-        def restore():
-            pycurl.version_info = version_info_orig
-        self.addCleanup(restore)
-
-        # Fake the pycurl version_info This was taken from a windows pycurl
-        # without SSL (thanks to bialix)
-        pycurl.version_info = lambda : (2,
-                                        '7.13.2',
-                                        462082,
-                                        'i386-pc-win32',
-                                        2576,
-                                        None,
-                                        0,
-                                        None,
-                                        ('ftp', 'gopher', 'telnet',
-                                         'dict', 'ldap', 'http', 'file'),
-                                        None,
-                                        0,
-                                        None)
+        self.overrideAttr(pycurl, 'version_info',
+                          # Fake the pycurl version_info This was taken from
+                          # a windows pycurl without SSL (thanks to bialix)
+                          lambda : (2,
+                                    '7.13.2',
+                                    462082,
+                                    'i386-pc-win32',
+                                    2576,
+                                    None,
+                                    0,
+                                    None,
+                                    ('ftp', 'gopher', 'telnet',
+                                     'dict', 'ldap', 'http', 'file'),
+                                    None,
+                                    0,
+                                    None))
         self.assertRaises(errors.DependencyNotPresent, self._transport,
                           'https://launchpad.net')
 
@@ -1364,11 +1360,7 @@
 
 
 def install_redirected_request(test):
-    test.original_class = _urllib2_wrappers.Request
-    def restore():
-        _urllib2_wrappers.Request = test.original_class
-    _urllib2_wrappers.Request = RedirectedRequest
-    test.addCleanup(restore)
+    test.overrideAttr(_urllib2_wrappers, 'Request', RedirectedRequest)
 
 
 class TestHTTPSilentRedirections(http_utils.TestCaseWithRedirectedWebserver):

=== modified file 'bzrlib/tests/test_ignores.py'
--- bzrlib/tests/test_ignores.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/test_ignores.py	2010-01-25 17:48:22 +0000
@@ -34,6 +34,8 @@
                 '\n' # empty line
                 '#comment\n'
                 ' xx \n' # whitespace
+                '!RE:^\.z.*\n'
+                '!!./.zcompdump\n'
                 ))
         self.assertEqual(set(['./rootdir',
                           'randomfile*',
@@ -41,6 +43,8 @@
                           u'unicode\xb5',
                           'dos',
                           ' xx ',
+                          '!RE:^\.z.*',
+                          '!!./.zcompdump',
                          ]), ignored)
 
     def test_parse_empty(self):
@@ -128,13 +132,9 @@
     def setUp(self):
         TestCase.setUp(self)
 
-        orig = ignores._runtime_ignores
-        def restore():
-            ignores._runtime_ignores = orig
-        self.addCleanup(restore)
         # For the purposes of these tests, we must have no
         # runtime ignores
-        ignores._runtime_ignores = set()
+        self.overrideAttr(ignores, '_runtime_ignores', set())
 
     def test_add(self):
         """Test that we can add an entry to the list."""

=== modified file 'bzrlib/tests/test_info.py'
--- bzrlib/tests/test_info.py	2009-04-08 16:33:19 +0000
+++ bzrlib/tests/test_info.py	2010-01-21 08:53:42 +0000
@@ -143,15 +143,11 @@
                 # We don't require that experimental formats support checkouts
                 # or describe correctly in the UI.
                 continue
+            if bzrdir.format_registry.get_info(key).hidden:
+                continue
             expected = None
-            if key in ('dirstate', 'dirstate-tags', 'dirstate-with-subtree',
-                'pack-0.92', 'pack-0.92-subtree', 'rich-root',
-                'rich-root-pack', '1.6', '1.6.1-rich-root',
-                '1.9', '1.9-rich-root'):
-                expected = '1.6 or 1.6.1-rich-root or ' \
-                    '1.9 or 1.9-rich-root or ' \
-                    'dirstate or dirstate-tags or pack-0.92 or'\
-                    ' rich-root or rich-root-pack'
+            if key in ('pack-0.92',):
+                expected = 'pack-0.92'
             elif key in ('knit', 'metaweave'):
                 expected = 'knit or metaweave'
             elif key in ('1.14', '1.14-rich-root'):
@@ -167,10 +163,10 @@
             expected = None
             if key in ('dirstate', 'knit'):
                 expected = 'dirstate or knit'
-            elif key in ('1.9', '1.14'):
-                expected = '1.14 or 1.9'
-            elif key in ('1.9-rich-root', '1.14-rich-root'):
-                expected = '1.14-rich-root or 1.9-rich-root'
+            elif key in ('1.14',):
+                expected = '1.14'
+            elif key in ('1.14-rich-root',):
+                expected = '1.14-rich-root'
             self.assertBranchDescription(key, expected)
 
     def test_describe_repo_format(self):
@@ -182,10 +178,10 @@
             expected = None
             if key in ('dirstate', 'knit', 'dirstate-tags'):
                 expected = 'dirstate or dirstate-tags or knit'
-            elif key in ('1.9', '1.14'):
-                expected = '1.14 or 1.9'
-            elif key in ('1.9-rich-root', '1.14-rich-root'):
-                expected = '1.14-rich-root or 1.9-rich-root'
+            elif key in ('1.14',):
+                expected = '1.14'
+            elif key in ('1.14-rich-root',):
+                expected = '1.14-rich-root'
             self.assertRepoDescription(key, expected)
 
         format = bzrdir.format_registry.make_bzrdir('metaweave')

=== modified file 'bzrlib/tests/test_knit.py'
--- bzrlib/tests/test_knit.py	2009-12-22 16:40:48 +0000
+++ bzrlib/tests/test_knit.py	2010-01-25 17:48:22 +0000
@@ -862,12 +862,8 @@
 
     def get_knit_index(self, transport, name, mode):
         mapper = ConstantMapper(name)
-        orig = knit._load_data
-        def reset():
-            knit._load_data = orig
-        self.addCleanup(reset)
         from bzrlib._knit_load_data_py import _load_data_py
-        knit._load_data = _load_data_py
+        self.overrideAttr(knit, '_load_data', _load_data_py)
         allow_writes = lambda: 'w' in mode
         return _KndxIndex(transport, mapper, lambda:None, allow_writes, lambda:True)
 
@@ -1302,14 +1298,11 @@
 
     def get_knit_index(self, transport, name, mode):
         mapper = ConstantMapper(name)
-        orig = knit._load_data
-        def reset():
-            knit._load_data = orig
-        self.addCleanup(reset)
         from bzrlib._knit_load_data_pyx import _load_data_c
-        knit._load_data = _load_data_c
+        self.overrideAttr(knit, '_load_data', _load_data_c)
         allow_writes = lambda: mode == 'w'
-        return _KndxIndex(transport, mapper, lambda:None, allow_writes, lambda:True)
+        return _KndxIndex(transport, mapper, lambda:None,
+                          allow_writes, lambda:True)
 
 
 class Test_KnitAnnotator(TestCaseWithMemoryTransport):

=== modified file 'bzrlib/tests/test_lazy_import.py'
--- bzrlib/tests/test_lazy_import.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/test_lazy_import.py	2010-01-25 15:55:48 +0000
@@ -452,17 +452,16 @@
         self.actions = []
         InstrumentedImportReplacer.use_actions(self.actions)
 
+        sys.path.append(base_path)
+        self.addCleanup(sys.path.remove, base_path)
+
         original_import = __import__
         def instrumented_import(mod, scope1, scope2, fromlist):
             self.actions.append(('import', mod, fromlist))
             return original_import(mod, scope1, scope2, fromlist)
-
         def cleanup():
-            if base_path in sys.path:
-                sys.path.remove(base_path)
             __builtins__['__import__'] = original_import
         self.addCleanup(cleanup)
-        sys.path.append(base_path)
         __builtins__['__import__'] = instrumented_import
 
     def create_modules(self):

=== modified file 'bzrlib/tests/test_log.py'
--- bzrlib/tests/test_log.py	2010-01-05 02:13:02 +0000
+++ bzrlib/tests/test_log.py	2010-01-22 11:22:50 +0000
@@ -23,11 +23,31 @@
     registry,
     revision,
     revisionspec,
+    symbol_versioning,
     tests,
     )
 
 
-class TestCaseForLogFormatter(tests.TestCaseWithTransport):
+class TestLogMixin(object):
+
+    def wt_commit(self, wt, message, **kwargs):
+        """Use some mostly fixed values for commits to simplify tests.
+
+        Tests can use this function to get some commit attributes. The time
+        stamp is incremented at each commit.
+        """
+        if getattr(self, 'timestamp', None) is None:
+            self.timestamp = 1132617600 # Mon 2005-11-22 00:00:00 +0000
+        else:
+            self.timestamp += 1 # 1 second between each commit
+        kwargs.setdefault('timestamp', self.timestamp)
+        kwargs.setdefault('timezone', 0) # UTC
+        kwargs.setdefault('committer', 'Joe Foo <joe@foo.com>')
+
+        return wt.commit(message, **kwargs)
+
+
+class TestCaseForLogFormatter(tests.TestCaseWithTransport, TestLogMixin):
 
     def setUp(self):
         super(TestCaseForLogFormatter, self).setUp()
@@ -41,8 +61,7 @@
         self.addCleanup(restore)
 
     def assertFormatterResult(self, result, branch, formatter_class,
-                              formatter_kwargs=None, show_log_kwargs=None,
-                              normalize=False):
+                              formatter_kwargs=None, show_log_kwargs=None):
         logfile = self.make_utf8_encoded_stringio()
         if formatter_kwargs is None:
             formatter_kwargs = {}
@@ -50,10 +69,7 @@
         if show_log_kwargs is None:
             show_log_kwargs = {}
         log.show_log(branch, formatter, **show_log_kwargs)
-        log_content = logfile.getvalue()
-        if normalize:
-            log_content = normalize_log(log_content)
-        self.assertEqualDiff(result, log_content)
+        self.assertEqualDiff(result, logfile.getvalue())
 
     def make_standard_commit(self, branch_nick, **kwargs):
         wt = self.make_branch_and_tree('.')
@@ -62,44 +78,44 @@
         self.build_tree(['a'])
         wt.add(['a'])
         wt.branch.nick = branch_nick
-        kwargs = dict(kwargs)
-        kwargs.setdefault('message', 'add a')
-        kwargs.setdefault('timestamp', 1132711707)
-        kwargs.setdefault('timezone', 36000)
         kwargs.setdefault('committer', 'Lorem Ipsum <test@example.com>')
         kwargs.setdefault('authors', ['John Doe <jdoe@example.com>'])
-        wt.commit(**kwargs)
+        self.wt_commit(wt, 'add a', **kwargs)
         return wt
 
+    def make_commits_with_trailing_newlines(self, wt):
+        """Helper method for LogFormatter tests"""
+        b = wt.branch
+        b.nick = 'test'
+        self.build_tree_contents([('a', 'hello moto\n')])
+        self.wt_commit(wt, 'simple log message', rev_id='a1')
+        self.build_tree_contents([('b', 'goodbye\n')])
+        wt.add('b')
+        self.wt_commit(wt, 'multiline\nlog\nmessage\n', rev_id='a2')
+
+        self.build_tree_contents([('c', 'just another manic monday\n')])
+        wt.add('c')
+        self.wt_commit(wt, 'single line with trailing newline\n', rev_id='a3')
+        return b
+
     def _prepare_tree_with_merges(self, with_tags=False):
         wt = self.make_branch_and_memory_tree('.')
         wt.lock_write()
         self.addCleanup(wt.unlock)
         wt.add('')
-        wt.commit('rev-1', rev_id='rev-1',
-                  timestamp=1132586655, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
-        wt.commit('rev-merged', rev_id='rev-2a',
-                  timestamp=1132586700, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
+        self.wt_commit(wt, 'rev-1', rev_id='rev-1')
+        self.wt_commit(wt, 'rev-merged', rev_id='rev-2a')
         wt.set_parent_ids(['rev-1', 'rev-2a'])
         wt.branch.set_last_revision_info(1, 'rev-1')
-        wt.commit('rev-2', rev_id='rev-2b',
-                  timestamp=1132586800, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
+        self.wt_commit(wt, 'rev-2', rev_id='rev-2b')
         if with_tags:
             branch = wt.branch
             branch.tags.set_tag('v0.2', 'rev-2b')
-            wt.commit('rev-3', rev_id='rev-3',
-                      timestamp=1132586900, timezone=36000,
-                      committer='Jane Foo <jane@foo.com>')
+            self.wt_commit(wt, 'rev-3', rev_id='rev-3')
             branch.tags.set_tag('v1.0rc1', 'rev-3')
             branch.tags.set_tag('v1.0', 'rev-3')
         return wt
 
-        
-
-
 class LogCatcher(log.LogFormatter):
     """Pull log messages into a list rather than displaying them.
 
@@ -108,10 +124,14 @@
     being dependent on the formatting.
     """
 
+    supports_merge_revisions = True
     supports_delta = True
+    supports_diff = True
+    preferred_levels = 0
 
-    def __init__(self):
-        super(LogCatcher, self).__init__(to_file=None)
+    def __init__(self, *args, **kwargs):
+        kwargs.update(dict(to_file=None))
+        super(LogCatcher, self).__init__(*args, **kwargs)
         self.revisions = []
 
     def log_revision(self, revision):
@@ -260,62 +280,21 @@
         self.checkDelta(logentry.delta, added=['file1', 'file2'])
 
 
-def make_commits_with_trailing_newlines(wt):
-    """Helper method for LogFormatter tests"""
-    b = wt.branch
-    b.nick='test'
-    open('a', 'wb').write('hello moto\n')
-    wt.add('a')
-    wt.commit('simple log message', rev_id='a1',
-              timestamp=1132586655.459960938, timezone=-6*3600,
-              committer='Joe Foo <joe@foo.com>')
-    open('b', 'wb').write('goodbye\n')
-    wt.add('b')
-    wt.commit('multiline\nlog\nmessage\n', rev_id='a2',
-              timestamp=1132586842.411175966, timezone=-6*3600,
-              committer='Joe Foo <joe@foo.com>',
-              authors=['Joe Bar <joe@bar.com>'])
-
-    open('c', 'wb').write('just another manic monday\n')
-    wt.add('c')
-    wt.commit('single line with trailing newline\n', rev_id='a3',
-              timestamp=1132587176.835228920, timezone=-6*3600,
-              committer = 'Joe Foo <joe@foo.com>')
-    return b
-
-
-def normalize_log(log):
-    """Replaces the variable lines of logs with fixed lines"""
-    author = 'author: Dolor Sit <test@example.com>'
-    committer = 'committer: Lorem Ipsum <test@example.com>'
-    lines = log.splitlines(True)
-    for idx,line in enumerate(lines):
-        stripped_line = line.lstrip()
-        indent = ' ' * (len(line) - len(stripped_line))
-        if stripped_line.startswith('author:'):
-            lines[idx] = indent + author + '\n'
-        elif stripped_line.startswith('committer:'):
-            lines[idx] = indent + committer + '\n'
-        elif stripped_line.startswith('timestamp:'):
-            lines[idx] = indent + 'timestamp: Just now\n'
-    return ''.join(lines)
-
-
 class TestShortLogFormatter(TestCaseForLogFormatter):
 
     def test_trailing_newlines(self):
         wt = self.make_branch_and_tree('.')
-        b = make_commits_with_trailing_newlines(wt)
+        b = self.make_commits_with_trailing_newlines(wt)
         self.assertFormatterResult("""\
-    3 Joe Foo\t2005-11-21
+    3 Joe Foo\t2005-11-22
       single line with trailing newline
 
-    2 Joe Bar\t2005-11-21
+    2 Joe Foo\t2005-11-22
       multiline
       log
       message
 
-    1 Joe Foo\t2005-11-21
+    1 Joe Foo\t2005-11-22
       simple log message
 
 """,
@@ -348,35 +327,17 @@
             formatter_kwargs=dict(show_advice=True))
 
     def test_short_log_with_merges_and_range(self):
-        wt = self.make_branch_and_memory_tree('.')
-        wt.lock_write()
-        self.addCleanup(wt.unlock)
-        wt.add('')
-        wt.commit('rev-1', rev_id='rev-1',
-                  timestamp=1132586655, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
-        wt.commit('rev-merged', rev_id='rev-2a',
-                  timestamp=1132586700, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
-        wt.branch.set_last_revision_info(1, 'rev-1')
-        wt.set_parent_ids(['rev-1', 'rev-2a'])
-        wt.commit('rev-2b', rev_id='rev-2b',
-                  timestamp=1132586800, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
-        wt.commit('rev-3a', rev_id='rev-3a',
-                  timestamp=1132586800, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
+        wt = self._prepare_tree_with_merges()
+        self.wt_commit(wt, 'rev-3a', rev_id='rev-3a')
         wt.branch.set_last_revision_info(2, 'rev-2b')
         wt.set_parent_ids(['rev-2b', 'rev-3a'])
-        wt.commit('rev-3b', rev_id='rev-3b',
-                  timestamp=1132586800, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
+        self.wt_commit(wt, 'rev-3b', rev_id='rev-3b')
         self.assertFormatterResult("""\
     3 Joe Foo\t2005-11-22 [merge]
       rev-3b
 
     2 Joe Foo\t2005-11-22 [merge]
-      rev-2b
+      rev-2
 
 """,
             wt.branch, log.ShortLogFormatter,
@@ -385,7 +346,7 @@
     def test_short_log_with_tags(self):
         wt = self._prepare_tree_with_merges(with_tags=True)
         self.assertFormatterResult("""\
-    3 Jane Foo\t2005-11-22 {v1.0, v1.0rc1}
+    3 Joe Foo\t2005-11-22 {v1.0, v1.0rc1}
       rev-3
 
     2 Joe Foo\t2005-11-22 {v0.2} [merge]
@@ -398,21 +359,7 @@
             wt.branch, log.ShortLogFormatter)
 
     def test_short_log_single_merge_revision(self):
-        wt = self.make_branch_and_memory_tree('.')
-        wt.lock_write()
-        self.addCleanup(wt.unlock)
-        wt.add('')
-        wt.commit('rev-1', rev_id='rev-1',
-                  timestamp=1132586655, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
-        wt.commit('rev-merged', rev_id='rev-2a',
-                  timestamp=1132586700, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
-        wt.set_parent_ids(['rev-1', 'rev-2a'])
-        wt.branch.set_last_revision_info(1, 'rev-1')
-        wt.commit('rev-2', rev_id='rev-2b',
-                  timestamp=1132586800, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
+        wt = self._prepare_tree_with_merges()
         revspec = revisionspec.RevisionSpec.from_string('1.1.1')
         rev = revspec.in_history(wt.branch)
         self.assertFormatterResult("""\
@@ -427,21 +374,7 @@
 class TestShortLogFormatterWithMergeRevisions(TestCaseForLogFormatter):
 
     def test_short_merge_revs_log_with_merges(self):
-        wt = self.make_branch_and_memory_tree('.')
-        wt.lock_write()
-        self.addCleanup(wt.unlock)
-        wt.add('')
-        wt.commit('rev-1', rev_id='rev-1',
-                  timestamp=1132586655, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
-        wt.commit('rev-merged', rev_id='rev-2a',
-                  timestamp=1132586700, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
-        wt.set_parent_ids(['rev-1', 'rev-2a'])
-        wt.branch.set_last_revision_info(1, 'rev-1')
-        wt.commit('rev-2', rev_id='rev-2b',
-                  timestamp=1132586800, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
+        wt = self._prepare_tree_with_merges()
         # Note that the 1.1.1 indenting is in fact correct given that
         # the revision numbers are right justified within 5 characters
         # for mainline revnos and 9 characters for dotted revnos.
@@ -460,21 +393,7 @@
             formatter_kwargs=dict(levels=0))
 
     def test_short_merge_revs_log_single_merge_revision(self):
-        wt = self.make_branch_and_memory_tree('.')
-        wt.lock_write()
-        self.addCleanup(wt.unlock)
-        wt.add('')
-        wt.commit('rev-1', rev_id='rev-1',
-                  timestamp=1132586655, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
-        wt.commit('rev-merged', rev_id='rev-2a',
-                  timestamp=1132586700, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
-        wt.set_parent_ids(['rev-1', 'rev-2a'])
-        wt.branch.set_last_revision_info(1, 'rev-1')
-        wt.commit('rev-2', rev_id='rev-2b',
-                  timestamp=1132586800, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
+        wt = self._prepare_tree_with_merges()
         revspec = revisionspec.RevisionSpec.from_string('1.1.1')
         rev = revspec.in_history(wt.branch)
         self.assertFormatterResult("""\
@@ -500,7 +419,7 @@
 revno: 1
 committer: Lorem Ipsum <test@example.com>
 branch nick: test_verbose_log
-timestamp: Wed 2005-11-23 12:08:27 +1000
+timestamp: Tue 2005-11-22 00:00:00 +0000
 message:
   add a
 added:
@@ -511,79 +430,73 @@
 
     def test_merges_are_indented_by_level(self):
         wt = self.make_branch_and_tree('parent')
-        wt.commit('first post')
-        self.run_bzr('branch parent child')
-        self.run_bzr(['commit', '-m', 'branch 1', '--unchanged', 'child'])
-        self.run_bzr('branch child smallerchild')
-        self.run_bzr(['commit', '-m', 'branch 2', '--unchanged',
-            'smallerchild'])
-        os.chdir('child')
-        self.run_bzr('merge ../smallerchild')
-        self.run_bzr(['commit', '-m', 'merge branch 2'])
-        os.chdir('../parent')
-        self.run_bzr('merge ../child')
-        wt.commit('merge branch 1')
+        self.wt_commit(wt, 'first post')
+        child_wt = wt.bzrdir.sprout('child').open_workingtree()
+        self.wt_commit(child_wt, 'branch 1')
+        smallerchild_wt = wt.bzrdir.sprout('smallerchild').open_workingtree()
+        self.wt_commit(smallerchild_wt, 'branch 2')
+        child_wt.merge_from_branch(smallerchild_wt.branch)
+        self.wt_commit(child_wt, 'merge branch 2')
+        wt.merge_from_branch(child_wt.branch)
+        self.wt_commit(wt, 'merge branch 1')
         self.assertFormatterResult("""\
 ------------------------------------------------------------
 revno: 2 [merge]
-committer: Lorem Ipsum <test@example.com>
+committer: Joe Foo <joe@foo.com>
 branch nick: parent
-timestamp: Just now
+timestamp: Tue 2005-11-22 00:00:04 +0000
 message:
   merge branch 1
     ------------------------------------------------------------
     revno: 1.1.2 [merge]
-    committer: Lorem Ipsum <test@example.com>
+    committer: Joe Foo <joe@foo.com>
     branch nick: child
-    timestamp: Just now
+    timestamp: Tue 2005-11-22 00:00:03 +0000
     message:
       merge branch 2
         ------------------------------------------------------------
         revno: 1.2.1
-        committer: Lorem Ipsum <test@example.com>
+        committer: Joe Foo <joe@foo.com>
         branch nick: smallerchild
-        timestamp: Just now
+        timestamp: Tue 2005-11-22 00:00:02 +0000
         message:
           branch 2
     ------------------------------------------------------------
     revno: 1.1.1
-    committer: Lorem Ipsum <test@example.com>
+    committer: Joe Foo <joe@foo.com>
     branch nick: child
-    timestamp: Just now
+    timestamp: Tue 2005-11-22 00:00:01 +0000
     message:
       branch 1
 ------------------------------------------------------------
 revno: 1
-committer: Lorem Ipsum <test@example.com>
+committer: Joe Foo <joe@foo.com>
 branch nick: parent
-timestamp: Just now
+timestamp: Tue 2005-11-22 00:00:00 +0000
 message:
   first post
 """,
             wt.branch, log.LongLogFormatter,
             formatter_kwargs=dict(levels=0),
-            show_log_kwargs=dict(verbose=True),
-            normalize=True)
+            show_log_kwargs=dict(verbose=True))
 
     def test_verbose_merge_revisions_contain_deltas(self):
         wt = self.make_branch_and_tree('parent')
         self.build_tree(['parent/f1', 'parent/f2'])
         wt.add(['f1','f2'])
-        wt.commit('first post')
-        self.run_bzr('branch parent child')
+        self.wt_commit(wt, 'first post')
+        child_wt = wt.bzrdir.sprout('child').open_workingtree()
         os.unlink('child/f1')
-        file('child/f2', 'wb').write('hello\n')
-        self.run_bzr(['commit', '-m', 'removed f1 and modified f2',
-            'child'])
-        os.chdir('parent')
-        self.run_bzr('merge ../child')
-        wt.commit('merge branch 1')
+        self.build_tree_contents([('child/f2', 'hello\n')])
+        self.wt_commit(child_wt, 'removed f1 and modified f2')
+        wt.merge_from_branch(child_wt.branch)
+        self.wt_commit(wt, 'merge branch 1')
         self.assertFormatterResult("""\
 ------------------------------------------------------------
 revno: 2 [merge]
-committer: Lorem Ipsum <test@example.com>
+committer: Joe Foo <joe@foo.com>
 branch nick: parent
-timestamp: Just now
+timestamp: Tue 2005-11-22 00:00:02 +0000
 message:
   merge branch 1
 removed:
@@ -592,9 +505,9 @@
   f2
     ------------------------------------------------------------
     revno: 1.1.1
-    committer: Lorem Ipsum <test@example.com>
+    committer: Joe Foo <joe@foo.com>
     branch nick: child
-    timestamp: Just now
+    timestamp: Tue 2005-11-22 00:00:01 +0000
     message:
       removed f1 and modified f2
     removed:
@@ -603,9 +516,9 @@
       f2
 ------------------------------------------------------------
 revno: 1
-committer: Lorem Ipsum <test@example.com>
+committer: Joe Foo <joe@foo.com>
 branch nick: parent
-timestamp: Just now
+timestamp: Tue 2005-11-22 00:00:00 +0000
 message:
   first post
 added:
@@ -614,26 +527,24 @@
 """,
             wt.branch, log.LongLogFormatter,
             formatter_kwargs=dict(levels=0),
-            show_log_kwargs=dict(verbose=True),
-            normalize=True)
+            show_log_kwargs=dict(verbose=True))
 
     def test_trailing_newlines(self):
         wt = self.make_branch_and_tree('.')
-        b = make_commits_with_trailing_newlines(wt)
+        b = self.make_commits_with_trailing_newlines(wt)
         self.assertFormatterResult("""\
 ------------------------------------------------------------
 revno: 3
 committer: Joe Foo <joe@foo.com>
 branch nick: test
-timestamp: Mon 2005-11-21 09:32:56 -0600
+timestamp: Tue 2005-11-22 00:00:02 +0000
 message:
   single line with trailing newline
 ------------------------------------------------------------
 revno: 2
-author: Joe Bar <joe@bar.com>
 committer: Joe Foo <joe@foo.com>
 branch nick: test
-timestamp: Mon 2005-11-21 09:27:22 -0600
+timestamp: Tue 2005-11-22 00:00:01 +0000
 message:
   multiline
   log
@@ -642,7 +553,7 @@
 revno: 1
 committer: Joe Foo <joe@foo.com>
 branch nick: test
-timestamp: Mon 2005-11-21 09:24:15 -0600
+timestamp: Tue 2005-11-22 00:00:00 +0000
 message:
   simple log message
 """,
@@ -661,7 +572,7 @@
 author: John Doe <jdoe@example.com>, Jane Rey <jrey@example.com>
 committer: Lorem Ipsum <test@example.com>
 branch nick: test_author_log
-timestamp: Wed 2005-11-23 12:08:27 +1000
+timestamp: Tue 2005-11-22 00:00:00 +0000
 message:
   add a
 """,
@@ -686,7 +597,7 @@
 author: John Doe <jdoe@example.com>
 committer: Lorem Ipsum <test@example.com>
 branch nick: test_properties_in_log
-timestamp: Wed 2005-11-23 12:08:27 +1000
+timestamp: Tue 2005-11-22 00:00:00 +0000
 message:
   add a
 """,
@@ -704,7 +615,7 @@
             'trivial_custom_prop_handler',
             trivial_custom_prop_handler)
         self.assertFormatterResult("""\
-    1 John Doe\t2005-11-23
+    1 John Doe\t2005-11-22
       test_prop: test_value
       add a
 
@@ -761,7 +672,7 @@
 revno: 1
 committer: Lorem Ipsum <test@example.com>
 branch nick: test_long_verbose_log
-timestamp: Wed 2005-11-23 12:08:27 +1000
+timestamp: Tue 2005-11-22 00:00:00 +0000
 message:
   add a
 added:
@@ -775,19 +686,19 @@
         wt = self.make_branch_and_tree('parent')
         self.build_tree(['parent/f1', 'parent/f2'])
         wt.add(['f1','f2'])
-        wt.commit('first post')
+        self.wt_commit(wt, 'first post')
         child_wt = wt.bzrdir.sprout('child').open_workingtree()
         os.unlink('child/f1')
         self.build_tree_contents([('child/f2', 'hello\n')])
-        child_wt.commit('removed f1 and modified f2')
+        self.wt_commit(child_wt, 'removed f1 and modified f2')
         wt.merge_from_branch(child_wt.branch)
-        wt.commit('merge branch 1')
+        self.wt_commit(wt, 'merge branch 1')
         self.assertFormatterResult("""\
 ------------------------------------------------------------
 revno: 2 [merge]
-committer: Lorem Ipsum <test@example.com>
+committer: Joe Foo <joe@foo.com>
 branch nick: parent
-timestamp: Just now
+timestamp: Tue 2005-11-22 00:00:02 +0000
 message:
   merge branch 1
 removed:
@@ -796,9 +707,9 @@
   f2
 ------------------------------------------------------------
 revno: 1
-committer: Lorem Ipsum <test@example.com>
+committer: Joe Foo <joe@foo.com>
 branch nick: parent
-timestamp: Just now
+timestamp: Tue 2005-11-22 00:00:00 +0000
 message:
   first post
 added:
@@ -807,26 +718,24 @@
 """,
             wt.branch, log.LongLogFormatter,
             formatter_kwargs=dict(levels=1),
-            show_log_kwargs=dict(verbose=True),
-            normalize=True)
+            show_log_kwargs=dict(verbose=True))
 
     def test_long_trailing_newlines(self):
         wt = self.make_branch_and_tree('.')
-        b = make_commits_with_trailing_newlines(wt)
+        b = self.make_commits_with_trailing_newlines(wt)
         self.assertFormatterResult("""\
 ------------------------------------------------------------
 revno: 3
 committer: Joe Foo <joe@foo.com>
 branch nick: test
-timestamp: Mon 2005-11-21 09:32:56 -0600
+timestamp: Tue 2005-11-22 00:00:02 +0000
 message:
   single line with trailing newline
 ------------------------------------------------------------
 revno: 2
-author: Joe Bar <joe@bar.com>
 committer: Joe Foo <joe@foo.com>
 branch nick: test
-timestamp: Mon 2005-11-21 09:27:22 -0600
+timestamp: Tue 2005-11-22 00:00:01 +0000
 message:
   multiline
   log
@@ -835,7 +744,7 @@
 revno: 1
 committer: Joe Foo <joe@foo.com>
 branch nick: test
-timestamp: Mon 2005-11-21 09:24:15 -0600
+timestamp: Tue 2005-11-22 00:00:00 +0000
 message:
   simple log message
 """,
@@ -853,7 +762,7 @@
 author: John Doe <jdoe@example.com>
 committer: Lorem Ipsum <test@example.com>
 branch nick: test_author_log
-timestamp: Wed 2005-11-23 12:08:27 +1000
+timestamp: Tue 2005-11-22 00:00:00 +0000
 message:
   add a
 """,
@@ -878,7 +787,7 @@
 author: John Doe <jdoe@example.com>
 committer: Lorem Ipsum <test@example.com>
 branch nick: test_properties_in_log
-timestamp: Wed 2005-11-23 12:08:27 +1000
+timestamp: Tue 2005-11-22 00:00:00 +0000
 message:
   add a
 """,
@@ -897,17 +806,17 @@
                 committer='Line-Log-Formatter Tester <test@line.log>',
                 authors=[])
         self.assertFormatterResult("""\
-1: Line-Log-Formatte... 2005-11-23 add a
+1: Line-Log-Formatte... 2005-11-22 add a
 """,
             wt.branch, log.LineLogFormatter)
 
     def test_trailing_newlines(self):
         wt = self.make_branch_and_tree('.')
-        b = make_commits_with_trailing_newlines(wt)
+        b = self.make_commits_with_trailing_newlines(wt)
         self.assertFormatterResult("""\
-3: Joe Foo 2005-11-21 single line with trailing newline
-2: Joe Bar 2005-11-21 multiline
-1: Joe Foo 2005-11-21 simple log message
+3: Joe Foo 2005-11-22 single line with trailing newline
+2: Joe Foo 2005-11-22 multiline
+1: Joe Foo 2005-11-22 simple log message
 """,
             b, log.LineLogFormatter)
 
@@ -924,7 +833,7 @@
     def test_line_log_with_tags(self):
         wt = self._prepare_tree_with_merges(with_tags=True)
         self.assertFormatterResult("""\
-3: Jane Foo 2005-11-22 {v1.0, v1.0rc1} rev-3
+3: Joe Foo 2005-11-22 {v1.0, v1.0rc1} rev-3
 2: Joe Foo 2005-11-22 [merge] {v0.2} rev-2
 1: Joe Foo 2005-11-22 rev-1
 """,
@@ -942,26 +851,12 @@
                 committer='Line-Log-Formatter Tester <test@line.log>',
                 authors=[])
         self.assertFormatterResult("""\
-1: Line-Log-Formatte... 2005-11-23 add a
+1: Line-Log-Formatte... 2005-11-22 add a
 """,
             wt.branch, log.LineLogFormatter)
 
     def test_line_merge_revs_log_single_merge_revision(self):
-        wt = self.make_branch_and_memory_tree('.')
-        wt.lock_write()
-        self.addCleanup(wt.unlock)
-        wt.add('')
-        wt.commit('rev-1', rev_id='rev-1',
-                  timestamp=1132586655, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
-        wt.commit('rev-merged', rev_id='rev-2a',
-                  timestamp=1132586700, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
-        wt.set_parent_ids(['rev-1', 'rev-2a'])
-        wt.branch.set_last_revision_info(1, 'rev-1')
-        wt.commit('rev-2', rev_id='rev-2b',
-                  timestamp=1132586800, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
+        wt = self._prepare_tree_with_merges()
         revspec = revisionspec.RevisionSpec.from_string('1.1.1')
         rev = revspec.in_history(wt.branch)
         self.assertFormatterResult("""\
@@ -972,21 +867,7 @@
             show_log_kwargs=dict(start_revision=rev, end_revision=rev))
 
     def test_line_merge_revs_log_with_merges(self):
-        wt = self.make_branch_and_memory_tree('.')
-        wt.lock_write()
-        self.addCleanup(wt.unlock)
-        wt.add('')
-        wt.commit('rev-1', rev_id='rev-1',
-                  timestamp=1132586655, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
-        wt.commit('rev-merged', rev_id='rev-2a',
-                  timestamp=1132586700, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
-        wt.set_parent_ids(['rev-1', 'rev-2a'])
-        wt.branch.set_last_revision_info(1, 'rev-1')
-        wt.commit('rev-2', rev_id='rev-2b',
-                  timestamp=1132586800, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
+        wt = self._prepare_tree_with_merges()
         self.assertFormatterResult("""\
 2: Joe Foo 2005-11-22 [merge] rev-2
   1.1.1: Joe Foo 2005-11-22 rev-merged
@@ -996,14 +877,18 @@
             formatter_kwargs=dict(levels=0))
 
 
-class TestGetViewRevisions(tests.TestCaseWithTransport):
+class TestGetViewRevisions(tests.TestCaseWithTransport, TestLogMixin):
+
+    def _get_view_revisions(self, *args, **kwargs):
+        return self.applyDeprecated(symbol_versioning.deprecated_in((2, 2, 0)),
+                                    log.get_view_revisions, *args, **kwargs)
 
     def make_tree_with_commits(self):
         """Create a tree with well-known revision ids"""
         wt = self.make_branch_and_tree('tree1')
-        wt.commit('commit one', rev_id='1')
-        wt.commit('commit two', rev_id='2')
-        wt.commit('commit three', rev_id='3')
+        self.wt_commit(wt, 'commit one', rev_id='1')
+        self.wt_commit(wt, 'commit two', rev_id='2')
+        self.wt_commit(wt, 'commit three', rev_id='3')
         mainline_revs = [None, '1', '2', '3']
         rev_nos = {'1': 1, '2': 2, '3': 3}
         return mainline_revs, rev_nos, wt
@@ -1012,9 +897,9 @@
         """Create a tree with well-known revision ids and a merge"""
         mainline_revs, rev_nos, wt = self.make_tree_with_commits()
         tree2 = wt.bzrdir.sprout('tree2').open_workingtree()
-        tree2.commit('four-a', rev_id='4a')
+        self.wt_commit(tree2, 'four-a', rev_id='4a')
         wt.merge_from_branch(tree2.branch)
-        wt.commit('four-b', rev_id='4b')
+        self.wt_commit(wt, 'four-b', rev_id='4b')
         mainline_revs.append('4b')
         rev_nos['4b'] = 4
         # 4a: 3.1.1
@@ -1068,11 +953,11 @@
         mainline_revs, rev_nos, wt = self.make_tree_with_commits()
         wt.lock_read()
         self.addCleanup(wt.unlock)
-        revisions = list(log.get_view_revisions(
+        revisions = list(self._get_view_revisions(
                 mainline_revs, rev_nos, wt.branch, 'forward'))
         self.assertEqual([('1', '1', 0), ('2', '2', 0), ('3', '3', 0)],
                          revisions)
-        revisions2 = list(log.get_view_revisions(
+        revisions2 = list(self._get_view_revisions(
                 mainline_revs, rev_nos, wt.branch, 'forward',
                 include_merges=False))
         self.assertEqual(revisions, revisions2)
@@ -1082,11 +967,11 @@
         mainline_revs, rev_nos, wt = self.make_tree_with_commits()
         wt.lock_read()
         self.addCleanup(wt.unlock)
-        revisions = list(log.get_view_revisions(
+        revisions = list(self._get_view_revisions(
                 mainline_revs, rev_nos, wt.branch, 'reverse'))
         self.assertEqual([('3', '3', 0), ('2', '2', 0), ('1', '1', 0), ],
                          revisions)
-        revisions2 = list(log.get_view_revisions(
+        revisions2 = list(self._get_view_revisions(
                 mainline_revs, rev_nos, wt.branch, 'reverse',
                 include_merges=False))
         self.assertEqual(revisions, revisions2)
@@ -1096,12 +981,12 @@
         mainline_revs, rev_nos, wt = self.make_tree_with_merges()
         wt.lock_read()
         self.addCleanup(wt.unlock)
-        revisions = list(log.get_view_revisions(
+        revisions = list(self._get_view_revisions(
                 mainline_revs, rev_nos, wt.branch, 'forward'))
         self.assertEqual([('1', '1', 0), ('2', '2', 0), ('3', '3', 0),
                           ('4b', '4', 0), ('4a', '3.1.1', 1)],
                          revisions)
-        revisions = list(log.get_view_revisions(
+        revisions = list(self._get_view_revisions(
                 mainline_revs, rev_nos, wt.branch, 'forward',
                 include_merges=False))
         self.assertEqual([('1', '1', 0), ('2', '2', 0), ('3', '3', 0),
@@ -1113,12 +998,12 @@
         mainline_revs, rev_nos, wt = self.make_tree_with_merges()
         wt.lock_read()
         self.addCleanup(wt.unlock)
-        revisions = list(log.get_view_revisions(
+        revisions = list(self._get_view_revisions(
                 mainline_revs, rev_nos, wt.branch, 'reverse'))
         self.assertEqual([('4b', '4', 0), ('4a', '3.1.1', 1),
                           ('3', '3', 0), ('2', '2', 0), ('1', '1', 0)],
                          revisions)
-        revisions = list(log.get_view_revisions(
+        revisions = list(self._get_view_revisions(
                 mainline_revs, rev_nos, wt.branch, 'reverse',
                 include_merges=False))
         self.assertEqual([('4b', '4', 0), ('3', '3', 0), ('2', '2', 0),
@@ -1130,20 +1015,19 @@
         mainline_revs, rev_nos, b = self.make_branch_with_many_merges()
         b.lock_read()
         self.addCleanup(b.unlock)
-        revisions = list(log.get_view_revisions(
+        revisions = list(self._get_view_revisions(
                 mainline_revs, rev_nos, b, 'forward'))
         expected = [('1', '1', 0), ('2', '2', 0), ('3c', '3', 0),
                     ('3b', '2.2.1', 1), ('3a', '2.1.1', 2), ('4b', '4', 0),
                     ('4a', '2.2.2', 1)]
         self.assertEqual(expected, revisions)
-        revisions = list(log.get_view_revisions(
+        revisions = list(self._get_view_revisions(
                 mainline_revs, rev_nos, b, 'forward',
                 include_merges=False))
         self.assertEqual([('1', '1', 0), ('2', '2', 0), ('3c', '3', 0),
                           ('4b', '4', 0)],
                          revisions)
 
-
     def test_file_id_for_range(self):
         mainline_revs, rev_nos, b = self.make_branch_with_many_merges()
         b.lock_read()
@@ -1154,7 +1038,9 @@
             return revspec.in_history(branch)
 
         def view_revs(start_rev, end_rev, file_id, direction):
-            revs = log.calculate_view_revisions(
+            revs = self.applyDeprecated(
+                symbol_versioning.deprecated_in((2, 2, 0)),
+                log.calculate_view_revisions,
                 b,
                 start_rev, # start_revision
                 end_rev, # end_revision
@@ -1166,15 +1052,21 @@
 
         rev_3a = rev_from_rev_id('3a', b)
         rev_4b = rev_from_rev_id('4b', b)
-        self.assertEqual([('3c', '3', 0), ('3b', '2.2.1', 1), ('3a', '2.1.1', 2)],
+        self.assertEqual([('3c', '3', 0), ('3b', '2.2.1', 1),
+                          ('3a', '2.1.1', 2)],
                           view_revs(rev_3a, rev_4b, 'f-id', 'reverse'))
         # Note: 3c still appears before 3a here because of depth-based sorting
-        self.assertEqual([('3c', '3', 0), ('3b', '2.2.1', 1), ('3a', '2.1.1', 2)],
+        self.assertEqual([('3c', '3', 0), ('3b', '2.2.1', 1),
+                          ('3a', '2.1.1', 2)],
                           view_revs(rev_3a, rev_4b, 'f-id', 'forward'))
 
 
 class TestGetRevisionsTouchingFileID(tests.TestCaseWithTransport):
 
+    def get_view_revisions(self, *args):
+        return self.applyDeprecated(symbol_versioning.deprecated_in((2, 2, 0)),
+                                    log.get_view_revisions, *args)
+
     def create_tree_with_single_merge(self):
         """Create a branch with a moderate layout.
 
@@ -1198,6 +1090,11 @@
         #       use it. Since 'log' only uses the tree in a readonly
         #       fashion, it seems a shame to regenerate an identical
         #       tree for each test.
+        # TODO: vila 20100122 One way to address the shame above will be to
+        #       create a memory tree during test parametrization and give a
+        #       *copy* of this tree to each test. Copying a memory tree ought
+        #       to be cheap, at least cheaper than creating them with such
+        #       complex setups.
         tree = self.make_branch_and_tree('tree')
         tree.lock_write()
         self.addCleanup(tree.unlock)
@@ -1278,12 +1175,10 @@
         mainline = tree.branch.revision_history()
         mainline.insert(0, None)
         revnos = dict((rev, idx+1) for idx, rev in enumerate(mainline))
-        view_revs_iter = log.get_view_revisions(mainline, revnos, tree.branch,
-                                                'reverse', True)
+        view_revs_iter = self.get_view_revisions(
+            mainline, revnos, tree.branch, 'reverse', True)
         actual_revs = log._filter_revisions_touching_file_id(
-                            tree.branch,
-                            file_id,
-                            list(view_revs_iter))
+            tree.branch, file_id, list(view_revs_iter))
         self.assertEqual(revisions, [r for r, revno, depth in actual_revs])
 
     def test_file_id_f1(self):
@@ -1341,41 +1236,42 @@
 
 class TestLogFormatter(tests.TestCase):
 
+    def setUp(self):
+        super(TestLogFormatter, self).setUp()
+        self.rev = revision.Revision('a-id')
+        self.lf = log.LogFormatter(None)
+
     def test_short_committer(self):
-        rev = revision.Revision('a-id')
-        rev.committer = 'John Doe <jdoe@example.com>'
-        lf = log.LogFormatter(None)
-        self.assertEqual('John Doe', lf.short_committer(rev))
-        rev.committer = 'John Smith <jsmith@example.com>'
-        self.assertEqual('John Smith', lf.short_committer(rev))
-        rev.committer = 'John Smith'
-        self.assertEqual('John Smith', lf.short_committer(rev))
-        rev.committer = 'jsmith@example.com'
-        self.assertEqual('jsmith@example.com', lf.short_committer(rev))
-        rev.committer = '<jsmith@example.com>'
-        self.assertEqual('jsmith@example.com', lf.short_committer(rev))
-        rev.committer = 'John Smith jsmith@example.com'
-        self.assertEqual('John Smith', lf.short_committer(rev))
+        def assertCommitter(expected, committer):
+            self.rev.committer = committer
+            self.assertEqual(expected, self.lf.short_committer(self.rev))
+
+        assertCommitter('John Doe', 'John Doe <jdoe@example.com>')
+        assertCommitter('John Smith', 'John Smith <jsmith@example.com>')
+        assertCommitter('John Smith', 'John Smith')
+        assertCommitter('jsmith@example.com', 'jsmith@example.com')
+        assertCommitter('jsmith@example.com', '<jsmith@example.com>')
+        assertCommitter('John Smith', 'John Smith jsmith@example.com')
 
     def test_short_author(self):
-        rev = revision.Revision('a-id')
-        rev.committer = 'John Doe <jdoe@example.com>'
-        lf = log.LogFormatter(None)
-        self.assertEqual('John Doe', lf.short_author(rev))
-        rev.properties['author'] = 'John Smith <jsmith@example.com>'
-        self.assertEqual('John Smith', lf.short_author(rev))
-        rev.properties['author'] = 'John Smith'
-        self.assertEqual('John Smith', lf.short_author(rev))
-        rev.properties['author'] = 'jsmith@example.com'
-        self.assertEqual('jsmith@example.com', lf.short_author(rev))
-        rev.properties['author'] = '<jsmith@example.com>'
-        self.assertEqual('jsmith@example.com', lf.short_author(rev))
-        rev.properties['author'] = 'John Smith jsmith@example.com'
-        self.assertEqual('John Smith', lf.short_author(rev))
-        del rev.properties['author']
-        rev.properties['authors'] = ('John Smith <jsmith@example.com>\n'
-                'Jane Rey <jrey@example.com>')
-        self.assertEqual('John Smith', lf.short_author(rev))
+        def assertAuthor(expected, author):
+            self.rev.properties['author'] = author
+            self.assertEqual(expected, self.lf.short_author(self.rev))
+
+        assertAuthor('John Smith', 'John Smith <jsmith@example.com>')
+        assertAuthor('John Smith', 'John Smith')
+        assertAuthor('jsmith@example.com', 'jsmith@example.com')
+        assertAuthor('jsmith@example.com', '<jsmith@example.com>')
+        assertAuthor('John Smith', 'John Smith jsmith@example.com')
+
+    def test_short_author_from_committer(self):
+        self.rev.committer = 'John Doe <jdoe@example.com>'
+        self.assertEqual('John Doe', self.lf.short_author(self.rev))
+
+    def test_short_author_from_authors(self):
+        self.rev.properties['authors'] = ('John Smith <jsmith@example.com>\n'
+                                          'Jane Rey <jrey@example.com>')
+        self.assertEqual('John Smith', self.lf.short_author(self.rev))
 
 
 class TestReverseByDepth(tests.TestCase):
@@ -1530,7 +1426,7 @@
 
 
 
-class TestLogWithBugs(TestCaseForLogFormatter):
+class TestLogWithBugs(TestCaseForLogFormatter, TestLogMixin):
 
     def setUp(self):
         TestCaseForLogFormatter.setUp(self)
@@ -1543,17 +1439,13 @@
         tree = self.make_branch_and_tree(u'.')
         self.build_tree(['a', 'b'])
         tree.add('a')
-        tree.commit('simple log message', rev_id='a1',
-                    timestamp=1132586655.459960938, timezone=-6*3600,
-                    committer='Joe Foo <joe@foo.com>',
-                    revprops={'bugs': 'test://bug/id fixed'})
+        self.wt_commit(tree, 'simple log message', rev_id='a1',
+                       revprops={'bugs': 'test://bug/id fixed'})
         tree.add('b')
-        tree.commit('multiline\nlog\nmessage\n', rev_id='a2',
-                    timestamp=1132586842.411175966, timezone=-6*3600,
-                    committer='Joe Foo <joe@foo.com>',
-                    authors=['Joe Bar <joe@bar.com>'],
-                    revprops={'bugs': 'test://bug/id fixed\n'
-                                      'test://bug/2 fixed'})
+        self.wt_commit(tree, 'multiline\nlog\nmessage\n', rev_id='a2',
+                       authors=['Joe Bar <joe@bar.com>'],
+                       revprops={'bugs': 'test://bug/id fixed\n'
+                                 'test://bug/2 fixed'})
         return tree
 
 
@@ -1566,7 +1458,7 @@
 author: Joe Bar <joe@bar.com>
 committer: Joe Foo <joe@foo.com>
 branch nick: work
-timestamp: Mon 2005-11-21 09:27:22 -0600
+timestamp: Tue 2005-11-22 00:00:01 +0000
 message:
   multiline
   log
@@ -1576,7 +1468,7 @@
 fixes bug(s): test://bug/id
 committer: Joe Foo <joe@foo.com>
 branch nick: work
-timestamp: Mon 2005-11-21 09:24:15 -0600
+timestamp: Tue 2005-11-22 00:00:00 +0000
 message:
   simple log message
 """,
@@ -1585,13 +1477,13 @@
     def test_short_bugs(self):
         tree = self.make_commits_with_bugs()
         self.assertFormatterResult("""\
-    2 Joe Bar\t2005-11-21
+    2 Joe Bar\t2005-11-22
       fixes bug(s): test://bug/id test://bug/2
       multiline
       log
       message
 
-    1 Joe Foo\t2005-11-21
+    1 Joe Foo\t2005-11-22
       fixes bug(s): test://bug/id
       simple log message
 
@@ -1601,12 +1493,10 @@
     def test_wrong_bugs_property(self):
         tree = self.make_branch_and_tree(u'.')
         self.build_tree(['foo'])
-        tree.commit('simple log message', rev_id='a1',
-              timestamp=1132586655.459960938, timezone=-6*3600,
-              committer='Joe Foo <joe@foo.com>',
-              revprops={'bugs': 'test://bug/id invalid_value'})
+        self.wt_commit(tree, 'simple log message', rev_id='a1',
+                       revprops={'bugs': 'test://bug/id invalid_value'})
         self.assertFormatterResult("""\
-    1 Joe Foo\t2005-11-21
+    1 Joe Foo\t2005-11-22
       simple log message
 
 """,

=== modified file 'bzrlib/tests/test_merge.py'
--- bzrlib/tests/test_merge.py	2009-12-22 23:09:50 +0000
+++ bzrlib/tests/test_merge.py	2010-01-29 08:28:47 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -33,7 +33,11 @@
 from bzrlib.errors import UnrelatedBranches, NoCommits
 from bzrlib.merge import transform_tree, merge_inner, _PlanMerge
 from bzrlib.osutils import pathjoin, file_kind
-from bzrlib.tests import TestCaseWithTransport, TestCaseWithMemoryTransport
+from bzrlib.tests import (
+    TestCaseWithMemoryTransport,
+    TestCaseWithTransport,
+    test_merge_core,
+    )
 from bzrlib.workingtree import WorkingTree
 
 
@@ -2833,3 +2837,28 @@
             'bval', ['lca1val', 'lca2val', 'lca2val'], 'oval', 'tval')
         self.assertLCAMultiWay('conflict',
             'bval', ['lca1val', 'lca2val', 'lca3val'], 'oval', 'tval')
+
+
+class TestConfigurableFileMerger(tests.TestCaseWithTransport):
+
+    def test_affected_files_cached(self):
+        """Ensures that the config variable is cached"""
+        class SimplePlan(_mod_merge.ConfigurableFileMerger):
+            name_prefix = "foo"
+            default_files = ["my default"]
+            def merge_text(self, params):
+                return ('not applicable', None)
+        def factory(merger):
+            result = SimplePlan(merger)
+            self.assertEqual(None, result.affected_files)
+            self.merger = result
+            return result
+        _mod_merge.Merger.hooks.install_named_hook('merge_file_content',
+            factory, 'test factory')
+        builder = test_merge_core.MergeBuilder(self.test_base_dir)
+        self.addCleanup(builder.cleanup)
+        builder.add_file('NEWS', builder.tree_root, 'name1', 'text1', True)
+        builder.change_contents('NEWS', other='text4', this='text3')
+        conflicts = builder.merge()
+        # The hook should set the variable
+        self.assertEqual(["my default"], self.merger.affected_files)

=== modified file 'bzrlib/tests/test_msgeditor.py'
--- bzrlib/tests/test_msgeditor.py	2009-11-17 23:05:04 +0000
+++ bzrlib/tests/test_msgeditor.py	2010-01-25 17:48:22 +0000
@@ -360,9 +360,6 @@
             msgeditor.generate_commit_message_template(commit_obj))
 
     def test_generate_commit_message_template_hook(self):
-        def restoreDefaults():
-            msgeditor.hooks['commit_message_template'] = []
-        self.addCleanup(restoreDefaults)
         msgeditor.hooks.install_named_hook("commit_message_template",
                 lambda commit_obj, msg: "save me some typing\n", None)
         commit_obj = commit.Commit()

=== modified file 'bzrlib/tests/test_osutils.py'
--- bzrlib/tests/test_osutils.py	2010-01-06 22:17:10 +0000
+++ bzrlib/tests/test_osutils.py	2010-01-25 17:48:22 +0000
@@ -1135,14 +1135,9 @@
             dirblock[:] = new_dirblock
 
     def _save_platform_info(self):
-        cur_winver = win32utils.winver
-        cur_fs_enc = osutils._fs_enc
-        cur_dir_reader = osutils._selected_dir_reader
-        def restore():
-            win32utils.winver = cur_winver
-            osutils._fs_enc = cur_fs_enc
-            osutils._selected_dir_reader = cur_dir_reader
-        self.addCleanup(restore)
+        self.overrideAttr(win32utils, 'winver')
+        self.overrideAttr(osutils, '_fs_enc')
+        self.overrideAttr(osutils, '_selected_dir_reader')
 
     def assertDirReaderIs(self, expected):
         """Assert the right implementation for _walkdirs_utf8 is chosen."""
@@ -1581,7 +1576,6 @@
         def cleanup():
             if 'BZR_TEST_ENV_VAR' in os.environ:
                 del os.environ['BZR_TEST_ENV_VAR']
-
         self.addCleanup(cleanup)
 
     def test_set(self):
@@ -1698,15 +1692,8 @@
 
     def setUp(self):
         tests.TestCaseInTempDir.setUp(self)
-
-        # Save platform specific info and reset it
-        cur_dir_reader = osutils._selected_dir_reader
-
-        def restore():
-            osutils._selected_dir_reader = cur_dir_reader
-        self.addCleanup(restore)
-
-        osutils._selected_dir_reader = self._dir_reader_class()
+        self.overrideAttr(osutils,
+                          '_selected_dir_reader', self._dir_reader_class())
 
     def _get_ascii_tree(self):
         tree = [
@@ -1859,10 +1846,7 @@
 
     def setUp(self):
         super(TestConcurrency, self).setUp()
-        orig = osutils._cached_local_concurrency
-        def restore():
-            osutils._cached_local_concurrency = orig
-        self.addCleanup(restore)
+        self.overrideAttr(osutils, '_cached_local_concurrency')
 
     def test_local_concurrency(self):
         concurrency = osutils.local_concurrency()
@@ -1895,12 +1879,7 @@
 
     def setUp(self):
         super(TestFailedToLoadExtension, self).setUp()
-        self.saved_failures = osutils._extension_load_failures[:]
-        del osutils._extension_load_failures[:]
-        self.addCleanup(self.restore_failures)
-
-    def restore_failures(self):
-        osutils._extension_load_failures = self.saved_failures
+        self.overrideAttr(osutils, '_extension_load_failures', [])
 
     def test_failure_to_load(self):
         self._try_loading()
@@ -1929,18 +1908,10 @@
 class TestTerminalWidth(tests.TestCase):
 
     def replace_stdout(self, new):
-        orig_stdout = sys.stdout
-        def restore():
-            sys.stdout = orig_stdout
-        self.addCleanup(restore)
-        sys.stdout = new
+        self.overrideAttr(sys, 'stdout', new)
 
     def replace__terminal_size(self, new):
-        orig__terminal_size = osutils._terminal_size
-        def restore():
-            osutils._terminal_size = orig__terminal_size
-        self.addCleanup(restore)
-        osutils._terminal_size = new
+        self.overrideAttr(osutils, '_terminal_size', new)
 
     def set_fake_tty(self):
 
@@ -1996,9 +1967,7 @@
             # We won't remove TIOCGWINSZ, because it doesn't exist anyway :)
             pass
         else:
-            def restore():
-                termios.TIOCGWINSZ = orig
-            self.addCleanup(restore)
+            self.overrideAttr(termios, 'TIOCGWINSZ')
             del termios.TIOCGWINSZ
         del os.environ['BZR_COLUMNS']
         del os.environ['COLUMNS']

=== modified file 'bzrlib/tests/test_osutils_encodings.py'
--- bzrlib/tests/test_osutils_encodings.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/test_osutils_encodings.py	2010-01-25 17:48:22 +0000
@@ -75,12 +75,10 @@
 
     def setUp(self):
         TestCase.setUp(self)
-        self._stdout = sys.stdout
-        self._stderr = sys.stderr
-        self._stdin = sys.stdin
-        self._user_encoding = osutils._cached_user_encoding
-
-        self.addCleanup(self._reset)
+        self.overrideAttr(sys, 'stdin')
+        self.overrideAttr(sys, 'stdout')
+        self.overrideAttr(sys, 'stderr')
+        self.overrideAttr(osutils, '_cached_user_encoding')
 
     def make_wrapped_streams(self,
                              stdout_encoding,
@@ -100,12 +98,6 @@
             fake_codec.add(stderr_encoding)
             fake_codec.add(stdin_encoding)
 
-    def _reset(self):
-        sys.stdout = self._stdout
-        sys.stderr = self._stderr
-        sys.stdin = self._stdin
-        osutils._cached_user_encoding = self._user_encoding
-
     def test_get_terminal_encoding(self):
         self.make_wrapped_streams('stdout_encoding',
                                   'stderr_encoding',
@@ -158,18 +150,10 @@
 
     def setUp(self):
         TestCase.setUp(self)
-        self._stderr = sys.stderr
-        self._getpreferredencoding = locale.getpreferredencoding
-        self.addCleanup(self._reset)
-        sys.stderr = StringIOWrapper()
-        # save $LANG
-        self._LANG = os.environ.get('LANG')
-
-    def _reset(self):
-        locale.getpreferredencoding = self._getpreferredencoding
-        sys.stderr = self._stderr
-        # restore $LANG
-        osutils.set_or_unset_env('LANG', self._LANG)
+        self.overrideAttr(locale, 'getpreferredencoding')
+        self.addCleanup(osutils.set_or_unset_env,
+                        'LANG', os.environ.get('LANG'))
+        self.overrideAttr(sys, 'stderr', StringIOWrapper())
 
     def test_get_user_encoding(self):
         def f():

=== modified file 'bzrlib/tests/test_plugins.py'
--- bzrlib/tests/test_plugins.py	2009-09-18 14:53:37 +0000
+++ bzrlib/tests/test_plugins.py	2010-01-25 17:48:22 +0000
@@ -575,26 +575,12 @@
 
     def setUp(self):
         super(TestLoadFromPath, self).setUp()
-        # Save the attributes that we're about to monkey-patch.
-        old_plugins_path = bzrlib.plugins.__path__
-        old_loaded = plugin._loaded
-        old_load_from_path = plugin.load_from_path
-
-        def restore():
-            bzrlib.plugins.__path__ = old_plugins_path
-            plugin._loaded = old_loaded
-            plugin.load_from_path = old_load_from_path
-
-        self.addCleanup(restore)
-
         # Change bzrlib.plugin to think no plugins have been loaded yet.
-        bzrlib.plugins.__path__ = []
-        plugin._loaded = False
+        self.overrideAttr(bzrlib.plugins, '__path__', [])
+        self.overrideAttr(plugin, '_loaded', False)
 
         # Monkey-patch load_from_path to stop it from actually loading anything.
-        def load_from_path(dirs):
-            pass
-        plugin.load_from_path = load_from_path
+        self.overrideAttr(plugin, 'load_from_path', lambda dirs: None)
 
     def test_set_plugins_path_with_args(self):
         plugin.set_plugins_path(['a', 'b'])
@@ -645,14 +631,7 @@
 
     def setUp(self):
         super(TestEnvPluginPath, self).setUp()
-        old_default = plugin.DEFAULT_PLUGIN_PATH
-
-        def restore():
-            plugin.DEFAULT_PLUGIN_PATH = old_default
-
-        self.addCleanup(restore)
-
-        plugin.DEFAULT_PLUGIN_PATH = None
+        self.overrideAttr(plugin, 'DEFAULT_PLUGIN_PATH', None)
 
         self.user = plugin.get_user_plugin_path()
         self.site = plugin.get_site_plugin_path()

=== modified file 'bzrlib/tests/test_remote.py'
--- bzrlib/tests/test_remote.py	2010-01-11 05:58:22 +0000
+++ bzrlib/tests/test_remote.py	2010-01-25 17:48:22 +0000
@@ -134,6 +134,10 @@
         b = BzrDir.open_from_transport(self.transport).open_branch()
         self.assertStartsWith(str(b), 'RemoteBranch(')
 
+    def test_remote_bzrdir_repr(self):
+        b = BzrDir.open_from_transport(self.transport)
+        self.assertStartsWith(str(b), 'RemoteBzrDir(')
+
     def test_remote_branch_format_supports_stacking(self):
         t = self.transport
         self.make_branch('unstackable', format='pack-0.92')
@@ -2004,11 +2008,8 @@
         self.assertLength(1, self.hpss_calls)
 
     def disableExtraResults(self):
-        old_flag = SmartServerRepositoryGetParentMap.no_extra_results
-        SmartServerRepositoryGetParentMap.no_extra_results = True
-        def reset_values():
-            SmartServerRepositoryGetParentMap.no_extra_results = old_flag
-        self.addCleanup(reset_values)
+        self.overrideAttr(SmartServerRepositoryGetParentMap,
+                          'no_extra_results', True)
 
     def test_null_cached_missing_and_stop_key(self):
         self.setup_smart_server_with_call_log()

=== modified file 'bzrlib/tests/test_repository.py'
--- bzrlib/tests/test_repository.py	2010-01-04 06:56:46 +0000
+++ bzrlib/tests/test_repository.py	2010-01-31 12:10:40 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -63,6 +63,7 @@
     revision as _mod_revision,
     symbol_versioning,
     upgrade,
+    versionedfile,
     workingtree,
     )
 from bzrlib.repofmt import (
@@ -464,7 +465,7 @@
         repo = self.make_repository('.',
                 format=bzrdir.format_registry.get('knit')())
         inv_xml = '<inventory format="5">\n</inventory>\n'
-        inv = repo.deserialise_inventory('test-rev-id', inv_xml)
+        inv = repo._deserialise_inventory('test-rev-id', inv_xml)
         self.assertEqual('test-rev-id', inv.root.revision)
 
     def test_deserialise_uses_global_revision_id(self):
@@ -476,9 +477,9 @@
         # Arguably, the deserialise_inventory should detect a mismatch, and
         # raise an error, rather than silently using one revision_id over the
         # other.
-        self.assertRaises(AssertionError, repo.deserialise_inventory,
+        self.assertRaises(AssertionError, repo._deserialise_inventory,
             'test-rev-id', inv_xml)
-        inv = repo.deserialise_inventory('other-rev-id', inv_xml)
+        inv = repo._deserialise_inventory('other-rev-id', inv_xml)
         self.assertEqual('other-rev-id', inv.root.revision)
 
     def test_supports_external_lookups(self):
@@ -1143,6 +1144,31 @@
         packs.ensure_loaded()
         return tree, r, packs, [rev1, rev2, rev3]
 
+    def test__clear_obsolete_packs(self):
+        packs = self.get_packs()
+        obsolete_pack_trans = packs.transport.clone('obsolete_packs')
+        obsolete_pack_trans.put_bytes('a-pack.pack', 'content\n')
+        obsolete_pack_trans.put_bytes('a-pack.rix', 'content\n')
+        obsolete_pack_trans.put_bytes('a-pack.iix', 'content\n')
+        obsolete_pack_trans.put_bytes('another-pack.pack', 'foo\n')
+        obsolete_pack_trans.put_bytes('not-a-pack.rix', 'foo\n')
+        res = packs._clear_obsolete_packs()
+        self.assertEqual(['a-pack', 'another-pack'], sorted(res))
+        self.assertEqual([], obsolete_pack_trans.list_dir('.'))
+
+    def test__clear_obsolete_packs_preserve(self):
+        packs = self.get_packs()
+        obsolete_pack_trans = packs.transport.clone('obsolete_packs')
+        obsolete_pack_trans.put_bytes('a-pack.pack', 'content\n')
+        obsolete_pack_trans.put_bytes('a-pack.rix', 'content\n')
+        obsolete_pack_trans.put_bytes('a-pack.iix', 'content\n')
+        obsolete_pack_trans.put_bytes('another-pack.pack', 'foo\n')
+        obsolete_pack_trans.put_bytes('not-a-pack.rix', 'foo\n')
+        res = packs._clear_obsolete_packs(preserve=set(['a-pack']))
+        self.assertEqual(['a-pack', 'another-pack'], sorted(res))
+        self.assertEqual(['a-pack.iix', 'a-pack.pack', 'a-pack.rix'],
+                         sorted(obsolete_pack_trans.list_dir('.')))
+
     def test__max_pack_count(self):
         """The maximum pack count is a function of the number of revisions."""
         # no revisions - one pack, so that we can have a revision free repo
@@ -1173,6 +1199,28 @@
         self.assertContainsRe(repr(packs),
             'RepositoryPackCollection(.*Repository(.*))')
 
+    def test__obsolete_packs(self):
+        tree, r, packs, revs = self.make_packs_and_alt_repo(write_lock=True)
+        names = packs.names()
+        pack = packs.get_pack_by_name(names[0])
+        # Schedule this one for removal
+        packs._remove_pack_from_memory(pack)
+        # Simulate a concurrent update by renaming the .pack file and one of
+        # the indices
+        packs.transport.rename('packs/%s.pack' % (names[0],),
+                               'obsolete_packs/%s.pack' % (names[0],))
+        packs.transport.rename('indices/%s.iix' % (names[0],),
+                               'obsolete_packs/%s.iix' % (names[0],))
+        # Now trigger the obsoletion, and ensure that all the remaining files
+        # are still renamed
+        packs._obsolete_packs([pack])
+        self.assertEqual([n + '.pack' for n in names[1:]],
+                         sorted(packs._pack_transport.list_dir('.')))
+        # names[0] should not be present in the index anymore
+        self.assertEqual(names[1:],
+            sorted(set([osutils.splitext(n)[0] for n in
+                        packs._index_transport.list_dir('.')])))
+
     def test_pack_distribution_zero(self):
         packs = self.get_packs()
         self.assertEqual([0], packs.pack_distribution(0))
@@ -1346,6 +1394,60 @@
         self.assertEqual({revs[-1]:(revs[-2],)}, r.get_parent_map([revs[-1]]))
         self.assertFalse(packs.reload_pack_names())
 
+    def test_reload_pack_names_preserves_pending(self):
+        # TODO: Update this to also test for pending-deleted names
+        tree, r, packs, revs = self.make_packs_and_alt_repo(write_lock=True)
+        # We will add one pack (via start_write_group + insert_record_stream),
+        # and remove another pack (via _remove_pack_from_memory)
+        orig_names = packs.names()
+        orig_at_load = packs._packs_at_load
+        to_remove_name = iter(orig_names).next()
+        r.start_write_group()
+        self.addCleanup(r.abort_write_group)
+        r.texts.insert_record_stream([versionedfile.FulltextContentFactory(
+            ('text', 'rev'), (), None, 'content\n')])
+        new_pack = packs._new_pack
+        self.assertTrue(new_pack.data_inserted())
+        new_pack.finish()
+        packs.allocate(new_pack)
+        packs._new_pack = None
+        removed_pack = packs.get_pack_by_name(to_remove_name)
+        packs._remove_pack_from_memory(removed_pack)
+        names = packs.names()
+        all_nodes, deleted_nodes, new_nodes, _ = packs._diff_pack_names()
+        new_names = set([x[0][0] for x in new_nodes])
+        self.assertEqual(names, sorted([x[0][0] for x in all_nodes]))
+        self.assertEqual(set(names) - set(orig_names), new_names)
+        self.assertEqual(set([new_pack.name]), new_names)
+        self.assertEqual([to_remove_name],
+                         sorted([x[0][0] for x in deleted_nodes]))
+        packs.reload_pack_names()
+        reloaded_names = packs.names()
+        self.assertEqual(orig_at_load, packs._packs_at_load)
+        self.assertEqual(names, reloaded_names)
+        all_nodes, deleted_nodes, new_nodes, _ = packs._diff_pack_names()
+        new_names = set([x[0][0] for x in new_nodes])
+        self.assertEqual(names, sorted([x[0][0] for x in all_nodes]))
+        self.assertEqual(set(names) - set(orig_names), new_names)
+        self.assertEqual(set([new_pack.name]), new_names)
+        self.assertEqual([to_remove_name],
+                         sorted([x[0][0] for x in deleted_nodes]))
+
+    def test_autopack_obsoletes_new_pack(self):
+        tree, r, packs, revs = self.make_packs_and_alt_repo(write_lock=True)
+        packs._max_pack_count = lambda x: 1
+        packs.pack_distribution = lambda x: [10]
+        r.start_write_group()
+        r.revisions.insert_record_stream([versionedfile.FulltextContentFactory(
+            ('bogus-rev',), (), None, 'bogus-content\n')])
+        # This should trigger an autopack, which will combine everything into a
+        # single pack file.
+        new_names = r.commit_write_group()
+        names = packs.names()
+        self.assertEqual(1, len(names))
+        self.assertEqual([names[0] + '.pack'],
+                         packs._pack_transport.list_dir('.'))
+
     def test_autopack_reloads_and_stops(self):
         tree, r, packs, revs = self.make_packs_and_alt_repo(write_lock=True)
         # After we have determined what needs to be autopacked, trigger a
@@ -1363,6 +1465,38 @@
         self.assertEqual(tree.branch.repository._pack_collection.names(),
                          packs.names())
 
+    def test__save_pack_names(self):
+        tree, r, packs, revs = self.make_packs_and_alt_repo(write_lock=True)
+        names = packs.names()
+        pack = packs.get_pack_by_name(names[0])
+        packs._remove_pack_from_memory(pack)
+        packs._save_pack_names(obsolete_packs=[pack])
+        cur_packs = packs._pack_transport.list_dir('.')
+        self.assertEqual([n + '.pack' for n in names[1:]], sorted(cur_packs))
+        # obsolete_packs will also have stuff like .rix and .iix present.
+        obsolete_packs = packs.transport.list_dir('obsolete_packs')
+        obsolete_names = set([osutils.splitext(n)[0] for n in obsolete_packs])
+        self.assertEqual([pack.name], sorted(obsolete_names))
+
+    def test__save_pack_names_already_obsoleted(self):
+        tree, r, packs, revs = self.make_packs_and_alt_repo(write_lock=True)
+        names = packs.names()
+        pack = packs.get_pack_by_name(names[0])
+        packs._remove_pack_from_memory(pack)
+        # We are going to simulate a concurrent autopack by manually obsoleting
+        # the pack directly.
+        packs._obsolete_packs([pack])
+        packs._save_pack_names(clear_obsolete_packs=True,
+                               obsolete_packs=[pack])
+        cur_packs = packs._pack_transport.list_dir('.')
+        self.assertEqual([n + '.pack' for n in names[1:]], sorted(cur_packs))
+        # Note that while we set clear_obsolete_packs=True, it should not
+        # delete a pack file that we have also scheduled for obsoletion.
+        obsolete_packs = packs.transport.list_dir('obsolete_packs')
+        obsolete_names = set([osutils.splitext(n)[0] for n in obsolete_packs])
+        self.assertEqual([pack.name], sorted(obsolete_names))
+
+
 
 class TestPack(TestCaseWithTransport):
     """Tests for the Pack object."""

=== modified file 'bzrlib/tests/test_revisiontree.py'
--- bzrlib/tests/test_revisiontree.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/test_revisiontree.py	2010-01-20 23:21:35 +0000
@@ -18,9 +18,11 @@
 """Tests for the RevisionTree class."""
 
 from bzrlib import (
+    errors,
     revision,
     )
 import bzrlib
+from bzrlib.inventory import ROOT_ID
 from bzrlib.tests import TestCaseWithTransport
 
 
@@ -59,3 +61,9 @@
         null_tree = self.t.branch.repository.revision_tree(
             revision.NULL_REVISION)
         self.assertIs(None, null_tree.inventory.root)
+
+    def test_get_file_mtime_ghost(self):
+        file_id = iter(self.rev_tree).next()
+        self.rev_tree.inventory[file_id].revision = 'ghostrev'
+        self.assertRaises(errors.FileTimestampUnavailable, 
+            self.rev_tree.get_file_mtime, file_id)

=== modified file 'bzrlib/tests/test_selftest.py'
--- bzrlib/tests/test_selftest.py	2010-01-16 10:06:21 +0000
+++ bzrlib/tests/test_selftest.py	2010-02-03 07:16:18 +0000
@@ -754,13 +754,7 @@
     def _patch_get_bzr_source_tree(self):
         # Reading from the actual source tree breaks isolation, but we don't
         # want to assume that thats *all* that would happen.
-        def _get_bzr_source_tree():
-            return None
-        orig_get_bzr_source_tree = bzrlib.version._get_bzr_source_tree
-        bzrlib.version._get_bzr_source_tree = _get_bzr_source_tree
-        def restore():
-            bzrlib.version._get_bzr_source_tree = orig_get_bzr_source_tree
-        self.addCleanup(restore)
+        self.overrideAttr(bzrlib.version, '_get_bzr_source_tree', lambda: None)
 
     def test_assigned_benchmark_file_stores_date(self):
         self._patch_get_bzr_source_tree()
@@ -1057,7 +1051,7 @@
             '(?sm)^bzr selftest.*$'
             '.*'
             '^======================================================================\n'
-            '^FAIL: unittest.FunctionTestCase \\(failing_test\\)\n'
+            '^FAIL: failing_test\n'
             '^----------------------------------------------------------------------\n'
             'Traceback \\(most recent call last\\):\n'
             '  .*' # File .*, line .*, in failing_test' - but maybe not from .pyc
@@ -1201,14 +1195,10 @@
         # Reading from the actual source tree breaks isolation, but we don't
         # want to assume that thats *all* that would happen.
         self._get_source_tree_calls = []
-        def _get_bzr_source_tree():
+        def new_get():
             self._get_source_tree_calls.append("called")
             return None
-        orig_get_bzr_source_tree = bzrlib.version._get_bzr_source_tree
-        bzrlib.version._get_bzr_source_tree = _get_bzr_source_tree
-        def restore():
-            bzrlib.version._get_bzr_source_tree = orig_get_bzr_source_tree
-        self.addCleanup(restore)
+        self.overrideAttr(bzrlib.version, '_get_bzr_source_tree',  new_get)
 
     def test_bench_history(self):
         # tests that the running the benchmark passes bench_history into
@@ -1322,12 +1312,7 @@
         self.assertEqual(flags, bzrlib.debug.debug_flags)
 
     def change_selftest_debug_flags(self, new_flags):
-        orig_selftest_flags = tests.selftest_debug_flags
-        self.addCleanup(self._restore_selftest_debug_flags, orig_selftest_flags)
-        tests.selftest_debug_flags = set(new_flags)
-
-    def _restore_selftest_debug_flags(self, flags):
-        tests.selftest_debug_flags = flags
+        self.overrideAttr(tests, 'selftest_debug_flags', set(new_flags))
 
     def test_allow_debug_flag(self):
         """The -Eallow_debug flag prevents bzrlib.debug.debug_flags from being
@@ -1634,6 +1619,42 @@
         self.assertRaises(AssertionError,
             self.assertListRaises, _TestException, success_generator)
 
+    def test_overrideAttr_without_value(self):
+        self.test_attr = 'original' # Define a test attribute
+        obj = self # Make 'obj' visible to the embedded test
+        class Test(tests.TestCase):
+
+            def setUp(self):
+                tests.TestCase.setUp(self)
+                self.orig = self.overrideAttr(obj, 'test_attr')
+
+            def test_value(self):
+                self.assertEqual('original', self.orig)
+                self.assertEqual('original', obj.test_attr)
+                obj.test_attr = 'modified'
+                self.assertEqual('modified', obj.test_attr)
+
+        test = Test('test_value')
+        test.run(unittest.TestResult())
+        self.assertEqual('original', obj.test_attr)
+
+    def test_overrideAttr_with_value(self):
+        self.test_attr = 'original' # Define a test attribute
+        obj = self # Make 'obj' visible to the embedded test
+        class Test(tests.TestCase):
+
+            def setUp(self):
+                tests.TestCase.setUp(self)
+                self.orig = self.overrideAttr(obj, 'test_attr', new='modified')
+
+            def test_value(self):
+                self.assertEqual('original', self.orig)
+                self.assertEqual('modified', obj.test_attr)
+
+        test = Test('test_value')
+        test.run(unittest.TestResult())
+        self.assertEqual('original', obj.test_attr)
+
 
 # NB: Don't delete this; it's not actually from 0.11!
 @deprecated_function(deprecated_in((0, 11, 0)))
@@ -2763,24 +2784,18 @@
         # test doubles that supply a few sample tests to load, and check they
         # are loaded.
         calls = []
-        def _test_suite_testmod_names():
+        def testmod_names():
             calls.append("testmod_names")
             return [
                 'bzrlib.tests.blackbox.test_branch',
                 'bzrlib.tests.per_transport',
                 'bzrlib.tests.test_selftest',
                 ]
-        original_testmod_names = tests._test_suite_testmod_names
-        def _test_suite_modules_to_doctest():
+        self.overrideAttr(tests, '_test_suite_testmod_names', testmod_names)
+        def doctests():
             calls.append("modules_to_doctest")
             return ['bzrlib.timestamp']
-        orig_modules_to_doctest = tests._test_suite_modules_to_doctest
-        def restore_names():
-            tests._test_suite_testmod_names = original_testmod_names
-            tests._test_suite_modules_to_doctest = orig_modules_to_doctest
-        self.addCleanup(restore_names)
-        tests._test_suite_testmod_names = _test_suite_testmod_names
-        tests._test_suite_modules_to_doctest = _test_suite_modules_to_doctest
+        self.overrideAttr(tests, '_test_suite_modules_to_doctest', doctests)
         expected_test_list = [
             # testmod_names
             'bzrlib.tests.blackbox.test_branch.TestBranch.test_branch',

=== modified file 'bzrlib/tests/test_sftp_transport.py'
--- bzrlib/tests/test_sftp_transport.py	2010-01-07 03:03:01 +0000
+++ bzrlib/tests/test_sftp_transport.py	2010-01-25 17:48:22 +0000
@@ -302,23 +302,17 @@
     def setUp(self):
         self.requireFeature(features.paramiko)
         super(SSHVendorBadConnection, self).setUp()
-        import bzrlib.transport.ssh
 
         # open a random port, so we know nobody else is using it
         # but don't actually listen on the port.
         s = socket.socket()
         s.bind(('localhost', 0))
+        self.addCleanup(s.close)
         self.bogus_url = 'sftp://%s:%s/' % s.getsockname()
 
-        orig_vendor = bzrlib.transport.ssh._ssh_vendor_manager._cached_ssh_vendor
-        def reset():
-            bzrlib.transport.ssh._ssh_vendor_manager._cached_ssh_vendor = orig_vendor
-            s.close()
-        self.addCleanup(reset)
-
     def set_vendor(self, vendor):
-        import bzrlib.transport.ssh
-        bzrlib.transport.ssh._ssh_vendor_manager._cached_ssh_vendor = vendor
+        from bzrlib.transport import ssh
+        self.overrideAttr(ssh._ssh_vendor_manager, '_cached_ssh_vendor', vendor)
 
     def test_bad_connection_paramiko(self):
         """Test that a real connection attempt raises the right error"""

=== modified file 'bzrlib/tests/test_trace.py'
--- bzrlib/tests/test_trace.py	2010-01-12 06:30:41 +0000
+++ bzrlib/tests/test_trace.py	2010-01-25 17:48:22 +0000
@@ -253,17 +253,18 @@
         # If _open_bzr_log cannot open the file, then we should write the
         # warning to stderr. Since this is normally happening before logging is
         # set up.
-        self.addCleanup(setattr, sys, 'stderr', sys.stderr)
-        self.addCleanup(setattr, trace, '_bzr_log_filename',
-                        trace._bzr_log_filename)
-        sys.stderr = StringIO()
+        self.overrideAttr(sys, 'stderr', StringIO())
         # Set the log file to something that cannot exist
+        # FIXME: A bit dangerous: we are not in an isolated dir here -- vilajam
+        # 20100125
         os.environ['BZR_LOG'] = os.getcwd() + '/no-dir/bzr.log'
+        self.overrideAttr(trace, '_bzr_log_filename')
         logf = trace._open_bzr_log()
         self.assertIs(None, logf)
         self.assertContainsRe(sys.stderr.getvalue(),
                               'failed to open trace file: .*/no-dir/bzr.log')
 
+
 class TestVerbosityLevel(TestCase):
 
     def test_verbosity_level(self):

=== modified file 'bzrlib/tests/test_transform.py'
--- bzrlib/tests/test_transform.py	2010-01-13 23:06:42 +0000
+++ bzrlib/tests/test_transform.py	2010-01-25 15:55:48 +0000
@@ -1923,6 +1923,10 @@
         self.assertTrue(source.is_executable('file1-id'))
 
     def install_rot13_content_filter(self, pattern):
+        # We could use
+        # self.addCleanup(filters._reset_registry, filters._reset_registry())
+        # below, but that looks a bit... hard to read even if it's exactly
+        # the same thing.
         original_registry = filters._reset_registry()
         def restore_registry():
             filters._reset_registry(original_registry)

=== modified file 'bzrlib/tests/test_version_info.py'
--- bzrlib/tests/test_version_info.py	2009-08-12 21:27:50 +0000
+++ bzrlib/tests/test_version_info.py	2010-01-25 17:48:22 +0000
@@ -23,6 +23,7 @@
 
 from bzrlib import (
     errors,
+    registry,
     symbol_versioning,
     tests,
     version_info_formats,
@@ -325,20 +326,8 @@
 
     def setUp(self):
         super(TestVersionInfoFormatRegistry, self).setUp()
-        registry = version_info_formats.format_registry
-        self._default_key = registry._default_key
-        self._dict = registry._dict.copy()
-        self._help_dict = registry._help_dict.copy()
-        self._info_dict = registry._info_dict.copy()
-        self.addCleanup(self._cleanup)
-
-    def _cleanup(self):
-        # Restore the registry to pristine state after the test runs
-        registry = version_info_formats.format_registry
-        registry._default_key = self._default_key
-        registry._dict = self._dict
-        registry._help_dict = self._help_dict
-        registry._info_dict = self._info_dict
+        self.overrideAttr(version_info_formats,
+                          'format_registry', registry.Registry())
 
     def test_register_remove(self):
         registry = version_info_formats.format_registry

=== modified file 'bzrlib/tests/test_win32utils.py'
--- bzrlib/tests/test_win32utils.py	2009-11-20 16:42:28 +0000
+++ bzrlib/tests/test_win32utils.py	2010-01-25 17:48:22 +0000
@@ -266,12 +266,8 @@
         super(TestLocationsPywin32, self).setUp()
         # We perform the exact same tests after disabling the use of ctypes.
         # This causes the implementation to fall back to pywin32.
-        self.old_ctypes = win32utils.has_ctypes
-        win32utils.has_ctypes = False
-        self.addCleanup(self.restoreCtypes)
-
-    def restoreCtypes(self):
-        win32utils.has_ctypes = self.old_ctypes
+        self.overrideAttr(win32utils, 'has_ctypes', False)
+        # FIXME: this should be done by parametrization -- vila 100123
 
 
 class TestSetHidden(TestCaseInTempDir):

=== modified file 'bzrlib/tests/test_workingtree_4.py'
--- bzrlib/tests/test_workingtree_4.py	2009-11-18 15:47:16 +0000
+++ bzrlib/tests/test_workingtree_4.py	2010-01-31 12:05:38 +0000
@@ -176,7 +176,7 @@
         repo = tree.branch.repository
         repo.get_revision = self.fail
         repo.get_inventory = self.fail
-        repo.get_inventory_xml = self.fail
+        repo._get_inventory_xml = self.fail
         # try to set the parent trees.
         tree.set_parent_trees([(rev1, rev1_tree)])
 
@@ -215,7 +215,7 @@
         # cache the parents of a parent tree at this point.
         #repo.get_revision = self.fail
         repo.get_inventory = self.fail
-        repo.get_inventory_xml = self.fail
+        repo._get_inventory_xml = self.fail
         # set the parent trees.
         tree.set_parent_trees([(rev1, rev1_tree), (rev2, rev2_tree)])
         # read the first tree
@@ -555,15 +555,11 @@
         tree.commit('one', rev_id='rev-1')
         # Trap osutils._walkdirs_utf8 to spy on what dirs have been accessed.
         returned = []
-        orig_walkdirs = osutils._walkdirs_utf8
-        def reset():
-            osutils._walkdirs_utf8 = orig_walkdirs
-        self.addCleanup(reset)
         def walkdirs_spy(*args, **kwargs):
-            for val in orig_walkdirs(*args, **kwargs):
+            for val in orig(*args, **kwargs):
                 returned.append(val[0][0])
                 yield val
-        osutils._walkdirs_utf8 = walkdirs_spy
+        orig = self.overrideAttr(osutils, '_walkdirs_utf8', walkdirs_spy)
 
         basis = tree.basis_tree()
         tree.lock_read()

=== modified file 'bzrlib/tests/transport_util.py'
--- bzrlib/tests/transport_util.py	2009-12-22 16:38:07 +0000
+++ bzrlib/tests/transport_util.py	2010-01-25 17:48:22 +0000
@@ -100,12 +100,9 @@
     def setUp(self):
         register_urlparse_netloc_protocol(_hooked_scheme)
         register_transport(_hooked_scheme, ConnectionHookedTransport)
-
-        def unregister():
-            unregister_transport(_hooked_scheme, ConnectionHookedTransport)
-            _unregister_urlparse_netloc_protocol(_hooked_scheme)
-
-        self.addCleanup(unregister)
+        self.addCleanup(unregister_transport, _hooked_scheme,
+                        ConnectionHookedTransport)
+        self.addCleanup(_unregister_urlparse_netloc_protocol, _hooked_scheme)
         super(TestCaseWithConnectionHookedTransport, self).setUp()
         self.reset_connections()
         # Add the 'hooked' url to the permitted url list.
@@ -128,13 +125,10 @@
         return url
 
     def start_logging_connections(self):
+        self.overrideAttr(InstrumentedTransport, 'hooks', TransportHooks())
+        # We preserved the hooks class attribute. Now we install our hook.
         ConnectionHookedTransport.hooks.install_named_hook(
             '_set_connection', self._collect_connection, None)
-        # uninstall our hooks when we are finished
-        self.addCleanup(self.reset_hooks)
-
-    def reset_hooks(self):
-        InstrumentedTransport.hooks = TransportHooks()
 
     def reset_connections(self):
         self.connections = []

=== modified file 'bzrlib/version.py'
--- bzrlib/version.py	2009-12-10 00:13:16 +0000
+++ bzrlib/version.py	2010-01-29 10:36:23 +0000
@@ -83,7 +83,7 @@
     if show_copyright:
         to_file.write('\n')
         to_file.write(bzrlib.__copyright__ + '\n')
-        to_file.write("http://bazaar-vcs.org/\n")
+        to_file.write("http://bazaar.canonical.com/\n")
         to_file.write('\n')
         to_file.write("bzr comes with ABSOLUTELY NO WARRANTY.  bzr is free software, and\n")
         to_file.write("you may use, modify and redistribute it under the terms of the GNU\n")

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2010-01-16 10:06:21 +0000
+++ bzrlib/workingtree.py	2010-02-03 07:16:18 +0000
@@ -1745,13 +1745,15 @@
         r"""Check whether the filename matches an ignore pattern.
 
         Patterns containing '/' or '\' need to match the whole path;
-        others match against only the last component.
+        others match against only the last component.  Patterns starting
+        with '!' are ignore exceptions.  Exceptions take precedence
+        over regular patterns and cause the filename to not be ignored.
 
         If the file is ignored, returns the pattern which caused it to
         be ignored, otherwise None.  So this can simply be used as a
         boolean if desired."""
         if getattr(self, '_ignoreglobster', None) is None:
-            self._ignoreglobster = globbing.Globster(self.get_ignore_list())
+            self._ignoreglobster = globbing.ExceptionGlobster(self.get_ignore_list())
         return self._ignoreglobster.match(filename)
 
     def kind(self, file_id):
@@ -1905,7 +1907,7 @@
             # revision_id is set. We must check for this full string, because a
             # root node id can legitimately look like 'revision_id' but cannot
             # contain a '"'.
-            xml = self.branch.repository.get_inventory_xml(new_revision)
+            xml = self.branch.repository._get_inventory_xml(new_revision)
             firstline = xml.split('\n', 1)[0]
             if (not 'revision_id="' in firstline or
                 'format="7"' not in firstline):

=== modified file 'bzrlib/workingtree_4.py'
--- bzrlib/workingtree_4.py	2009-12-22 17:05:47 +0000
+++ bzrlib/workingtree_4.py	2010-01-20 23:21:35 +0000
@@ -1755,7 +1755,11 @@
             return None
         parent_index = self._get_parent_index()
         last_changed_revision = entry[1][parent_index][4]
-        return self._repository.get_revision(last_changed_revision).timestamp
+        try:
+            rev = self._repository.get_revision(last_changed_revision)
+        except errors.NoSuchRevision:
+            raise errors.FileTimestampUnavailable(self.id2path(file_id))
+        return rev.timestamp
 
     def get_file_sha1(self, file_id, path=None, stat_value=None):
         entry = self._get_entry(file_id=file_id, path=path)

=== removed file 'contrib/fortune'
--- contrib/fortune	2005-09-19 06:05:19 +0000
+++ contrib/fortune	1970-01-01 00:00:00 +0000
@@ -1,20 +0,0 @@
-#! /bin/sh
-
-# Put this on your $BZRPATH to use it to demonstrate bzr external plugins
-
-
-if [ x$1 == x--bzr-usage ]
-then
-    # options
-    echo ""
-    # arguments
-    echo ""
-    exit 0
-elif [ x$1 == x--bzr-help ]
-then
-    echo "display a fortune cookie"
-    echo 
-    exit 0
-else
-    /usr/games/fortune
-fi

=== modified file 'doc/developers/HACKING.txt'
--- doc/developers/HACKING.txt	2009-12-29 14:29:08 +0000
+++ doc/developers/HACKING.txt	2010-01-21 22:45:35 +0000
@@ -1147,13 +1147,16 @@
  * new features - should be brought to their attention
  * bug fixes - may be of interest if the bug was affecting them, and
    should include the bug number if any
- * major documentation changes
+ * major documentation changes, including fixed documentation bugs
  * changes to internal interfaces
 
 People who made significant contributions to each change are listed in
 parenthesis.  This can include reporting bugs (particularly with good
 details or reproduction recipes), submitting patches, etc.
 
+To help with merging, NEWS entries should be sorted lexicographically
+within each section.
+
 Commands
 --------
 

=== modified file 'doc/developers/_templates/layout.html'
--- doc/developers/_templates/layout.html	2009-11-18 02:08:40 +0000
+++ doc/developers/_templates/layout.html	2010-01-29 10:36:23 +0000
@@ -6,9 +6,9 @@
 {% endblock %}
 
 {% block rootrellink %}
-<li><a href="http://bazaar-vcs.org/">
+<li><a href="http://bazaar.canonical.com/">
     <img src="{{ pathto("_static/bzr icon 16.png", 1) }}" /> Home</a>&nbsp;|&nbsp;</li>
-<a href="http://doc.bazaar-vcs.org/en/">Documentation</a>&nbsp;|&nbsp;</li>
+<a href="http://doc.bazaar.canonical.com/en/">Documentation</a>&nbsp;|&nbsp;</li>
 {{ super() }}
 {% endblock %}
 

=== modified file 'doc/developers/win32_build_setup.txt'
--- doc/developers/win32_build_setup.txt	2009-12-18 16:13:54 +0000
+++ doc/developers/win32_build_setup.txt	2010-01-25 10:18:24 +0000
@@ -37,6 +37,7 @@
    g) zip
    h) unzip
    i) patch
+   j) gettext-devel # brings 'msgfmt'
 
 
 2) Download the supported versions of python from http://www.python.org
@@ -111,6 +112,7 @@
       http://launchpadlibrarian.net/16133025/win32_clock.patch
       This may not end up necessary w/ pycrypto 2.1, especially if paramiko can
       be taught to use the new functionality (avoiding the warning).
+   l) easy_install testtools
 
 5) Get Pageant, not strictly necessary, but it is a pretty good ssh-agent for
    Windows, and paramiko knows how to use keys from Pageant.

=== modified file 'doc/en/_static/en/bzr-en-quick-reference.svg'
--- doc/en/_static/en/bzr-en-quick-reference.svg	2009-09-09 00:49:50 +0000
+++ doc/en/_static/en/bzr-en-quick-reference.svg	2010-01-29 10:36:23 +0000
@@ -1579,7 +1579,7 @@
         <a
            id="a6316"
            style="fill:#333333;fill-opacity:1"
-           xlink:href="http://bazaar-vcs.org">
+           xlink:href="http://bazaar.canonical.com">
           <text
              sodipodi:linespacing="100%"
              id="text6302"
@@ -1590,7 +1590,7 @@
                y="97.901367"
                x="787.79535"
                id="tspan6304"
-               sodipodi:role="line">http://bazaar-vcs.org</tspan></text>
+               sodipodi:role="line">http://bazaar.canonical.com</tspan></text>
         </a>
       </g>
     </g>

=== modified file 'doc/en/_templates/index.html'
--- doc/en/_templates/index.html	2010-01-08 00:27:40 +0000
+++ doc/en/_templates/index.html	2010-01-29 10:36:23 +0000
@@ -39,7 +39,7 @@
         <p class="biglink"><a class="biglink" href="https://answers.launchpad.net/bzr/+faqs">FAQ</a><br/>
       <span class="linkdescr">frequently asked questions</span>
       </p>
-      <p class="biglink"><a class="biglink" href="http://bazaar-vcs.org/BzrGlossary/">Glossary</a><br/>
+      <p class="biglink"><a class="biglink" href="http://bazaar.canonical.com/BzrGlossary/">Glossary</a><br/>
       <span class="linkdescr">help with terminology</span>
       </p>
       <p class="biglink"><a class="biglink" href="../developers/">Developer Docs</a><br/>
@@ -47,10 +47,10 @@
       </p>
     </td>
     <td width="50%">
-      <p class="biglink"><a class="biglink" href="http://doc.bazaar-vcs.org/migration/en/">Migration Docs</a><br/>
+      <p class="biglink"><a class="biglink" href="http://doc.bazaar.canonical.com/migration/en/">Migration Docs</a><br/>
       <span class="linkdescr">for refugees of other tools</span>
       </p>
-      <p class="biglink"><a class="biglink" href="http://doc.bazaar-vcs.org/plugins/en/">Plugins Guide</a><br/>
+      <p class="biglink"><a class="biglink" href="http://doc.bazaar.canonical.com/plugins/en/">Plugins Guide</a><br/>
       <span class="linkdescr">help on popular plugins</span>
       </p>
     </td></tr>

=== modified file 'doc/en/_templates/layout.html'
--- doc/en/_templates/layout.html	2009-10-30 07:51:16 +0000
+++ doc/en/_templates/layout.html	2010-01-29 10:36:23 +0000
@@ -1,9 +1,9 @@
 {% extends "!layout.html" %}
 
 {% block rootrellink %}
-<li><a href="http://bazaar-vcs.org/">
+<li><a href="http://bazaar.canonical.com/">
     <img src="{{ pathto("_static/bzr icon 16.png", 1) }}" /> Home</a>&nbsp;|&nbsp;</li>
-<a href="http://doc.bazaar-vcs.org/en/">Documentation</a>&nbsp;|&nbsp;</li>
+<a href="http://doc.bazaar.canonical.com/en/">Documentation</a>&nbsp;|&nbsp;</li>
 {{ super() }}
 {% endblock %}
 

=== modified file 'doc/en/user-guide/introducing_bazaar.txt'
--- doc/en/user-guide/introducing_bazaar.txt	2010-01-04 02:25:11 +0000
+++ doc/en/user-guide/introducing_bazaar.txt	2010-01-26 09:15:44 +0000
@@ -134,7 +134,7 @@
 details on the commands and options available.
 
 .. _Bazaar in five minutes: ../mini-tutorial/index.html
-.. _Bazaar Quick Start Card: ../quick-reference/quick-start-summary.svg
+.. _Bazaar Quick Start Card: ../quick-reference/index.html
 .. _Bazaar User Reference: ../user-reference/index.html
 
 We hope you find this manual useful. If you have suggestions on how it

=== modified file 'doc/es/_static/es/bzr-es-quick-reference.svg'
--- doc/es/_static/es/bzr-es-quick-reference.svg	2009-09-09 00:49:50 +0000
+++ doc/es/_static/es/bzr-es-quick-reference.svg	2010-01-29 10:36:23 +0000
@@ -1672,7 +1672,7 @@
         <a
            id="a6316"
            style="fill:#333333;fill-opacity:1"
-           xlink:href="http://bazaar-vcs.org">
+           xlink:href="http://bazaar.canonical.com">
           <text
              sodipodi:linespacing="100%"
              id="text6302"
@@ -1683,7 +1683,7 @@
                y="97.901367"
                x="787.79535"
                id="tspan6304"
-               sodipodi:role="line">http://bazaar-vcs.org</tspan></text>
+               sodipodi:role="line">http://bazaar.canonical.com</tspan></text>
         </a>
       </g>
     </g>

=== modified file 'doc/es/_templates/layout.html'
--- doc/es/_templates/layout.html	2009-10-30 07:51:16 +0000
+++ doc/es/_templates/layout.html	2010-01-29 14:10:05 +0000
@@ -1,9 +1,9 @@
 {% extends "!layout.html" %}
 
 {% block rootrellink %}
-<li><a href="http://bazaar-vcs.org/">
+<li><a href="http://bazaar.canonical.com/">
     <img src="{{ pathto("_static/bzr icon 16.png", 1) }}" /> Inicio</a>&nbsp;|&nbsp;</li>
-<a href="http://doc.bazaar-vcs.org/en/">Documentación</a>&nbsp;|&nbsp;</li>
+<a href="http://doc.bazaar.canonical.com/">Documentación</a>&nbsp;|&nbsp;</li>
 {{ super() }}
 {% endblock %}
 

=== modified file 'doc/ru/_static/ru/bzr-ru-quick-reference.svg'
--- doc/ru/_static/ru/bzr-ru-quick-reference.svg	2009-09-09 00:49:50 +0000
+++ doc/ru/_static/ru/bzr-ru-quick-reference.svg	2010-01-29 10:36:23 +0000
@@ -1582,7 +1582,7 @@
         <a
            id="a6316"
            style="fill:#333333;fill-opacity:1"
-           xlink:href="http://bazaar-vcs.org">
+           xlink:href="http://bazaar.canonical.com">
           <text
              sodipodi:linespacing="100%"
              id="text6302"
@@ -1593,7 +1593,7 @@
                y="97.901367"
                x="787.79535"
                id="tspan6304"
-               sodipodi:role="line">http://bazaar-vcs.org</tspan></text>
+               sodipodi:role="line">http://bazaar.canonical.com</tspan></text>
         </a>
       </g>
     </g>

=== modified file 'doc/ru/_templates/layout.html'
--- doc/ru/_templates/layout.html	2009-10-30 07:51:16 +0000
+++ doc/ru/_templates/layout.html	2010-01-29 10:36:23 +0000
@@ -1,9 +1,9 @@
 {% extends "!layout.html" %}
 
 {% block rootrellink %}
-<li><a href="http://bazaar-vcs.org/">
+<li><a href="http://bazaar.canonical.com/">
     <img src="{{ pathto("_static/bzr icon 16.png", 1) }}" /> Главная</a>&nbsp;|&nbsp;</li>
-<a href="http://doc.bazaar-vcs.org/ru/">Документация</a>&nbsp;|&nbsp;</li>
+<a href="http://doc.bazaar.canonical.com/ru/">Документация</a>&nbsp;|&nbsp;</li>
 {{ super() }}
 {% endblock %}
 

=== modified file 'setup.py'
--- setup.py	2010-01-12 06:30:41 +0000
+++ setup.py	2010-01-29 10:36:23 +0000
@@ -37,7 +37,7 @@
     'version':      bzrlib.__version__,
     'author':       'Canonical Ltd',
     'author_email': 'bazaar@lists.canonical.com',
-    'url':          'http://www.bazaar-vcs.org/',
+    'url':          'http://www.bazaar.canonical.com/',
     'description':  'Friendly distributed version control system',
     'license':      'GNU GPL v2',
     'download_url': 'https://launchpad.net/bzr/+download',

=== removed file 'tools/biobench.py'
--- tools/biobench.py	2005-11-04 01:46:31 +0000
+++ tools/biobench.py	1970-01-01 00:00:00 +0000
@@ -1,92 +0,0 @@
-#! /usr/bin/env python
-
-# (C) 2005 Canonical Ltd
-
-"""Benchmark for basicio
-
-Tries serializing an inventory to basic_io repeatedly.
-"""
-
-if True:
-    import psyco
-    psyco.full()
-
-
-import sys
-from timeit import Timer
-from tempfile import TemporaryFile, NamedTemporaryFile
-
-from bzrlib.branch import Branch
-from bzrlib.xml5 import serializer_v5
-from bzrlib.basicio import write_inventory, BasicWriter, \
-        read_inventory
-from bzrlib.inventory import Inventory, InventoryEntry, InventoryFile, ROOT_ID
-
-## b = Branch.open('.')
-## inv = b.get_inventory(b.last_revision())
-
-nrepeats = 3
-ntimes = 5
-NFILES = 30000
-
-def make_inventory():
-    inv = Inventory()
-    for i in range(NFILES):
-        ie = InventoryFile('%08d-id' % i, '%08d-file' % i, ROOT_ID)
-        ie.text_sha1='1212121212121212121212121212121212121212'
-        ie.text_size=12312
-        inv.add(ie)
-    return inv
-
-inv = make_inventory()
-
-bio_tmp = NamedTemporaryFile()
-xml_tmp = NamedTemporaryFile()
-
-def bio_test():
-    bio_tmp.seek(0)
-    w = BasicWriter(bio_tmp)
-    write_inventory(w, inv)
-    bio_tmp.seek(0)
-    new_inv = read_inventory(bio_tmp)
-
-def xml_test():
-    xml_tmp.seek(0)
-    serializer_v5.write_inventory(inv, xml_tmp)
-    xml_tmp.seek(0)
-    new_inv = serializer_v5.read_inventory(xml_tmp)
-
-def run_benchmark(function_name, tmp_file):
-    t = Timer(function_name + '()', 
-              'from __main__ import ' + function_name)
-    times = t.repeat(nrepeats, ntimes)
-    tmp_file.seek(0, 2)
-    size = tmp_file.tell()
-    print 'wrote inventory to %10s %5d times, each %6d bytes, total %6dkB' \
-            % (function_name, ntimes, size, (size * ntimes)>>10), 
-    each = (min(times)/ntimes*1000)
-    print 'in %.1fms each' % each 
-    return each
-
-def profileit(fn): 
-    import hotshot, hotshot.stats
-    prof_f = NamedTemporaryFile()
-    prof = hotshot.Profile(prof_f.name)
-    prof.runcall(fn) 
-    prof.close()
-    stats = hotshot.stats.load(prof_f.name)
-    #stats.strip_dirs()
-    stats.sort_stats('time')
-    ## XXX: Might like to write to stderr or the trace file instead but
-    ## print_stats seems hardcoded to stdout
-    stats.print_stats(20)
-
-if '-p' in sys.argv[1:]:
-    profileit(bio_test)
-else:
-    bio_each = run_benchmark('bio_test', bio_tmp)
-    xml_each = run_benchmark('xml_test', xml_tmp)
-    print 'so bio is %.1f%% faster' % (100 * ((xml_each / bio_each) - 1))
-
-# make sure it was a fair comparison
-# assert 'cElementTree' in sys.modules

=== removed file 'tools/history2revfiles.py'
--- tools/history2revfiles.py	2009-03-23 14:59:43 +0000
+++ tools/history2revfiles.py	1970-01-01 00:00:00 +0000
@@ -1,99 +0,0 @@
-#! /usr/bin/python
-
-# Copyright (C) 2005 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Experiment in converting existing bzr branches to weaves."""
-
-
-import bzrlib.branch
-from bzrlib.revfile import Revfile
-from bzrlib.progress import ProgressBar
-import tempfile
-import hotshot, hotshot.stats
-import sys
-
-def convert():
-    pb = ProgressBar()
-
-    inv_rf = Revfile('revfiles/inventory', 'w')
-    last_text_sha = {}
-    text_rfs = {}
-
-    b = bzrlib.branch.find_branch('.')
-
-    revno = 1
-    rev_history = b.revision_history()
-    last_idx = None
-    for rev_id in rev_history:
-        pb.update('converting inventory', revno, len(rev_history))
-        inv_xml = b.get_inventory_xml(rev_id).read()
-        new_idx = inv_rf.add(inv_xml, last_idx, compress=False)
-
-        tree = b.revision_tree(rev_id)
-        inv = tree.inventory
-
-        # for each file in the inventory, put it into its own revfile
-        for file_id in inv:
-            ie = inv[file_id]
-            if ie.kind != 'file':
-                continue
-            if last_text_sha.get(file_id) == ie.text_sha1:
-                # same as last time
-                continue
-            last_text_sha[file_id] = ie.text_sha1
-
-            # new text (though possibly already stored); need to store it
-            text = tree.get_file(file_id).read()
-            
-            if file_id not in text_rfs:
-                text_rfs[file_id] = Revfile('revfiles/' + file_id, 'w')
-            rf = text_rfs[file_id]
-
-            last = len(rf)
-            if last == 0:
-                last = None
-            else:
-                last -= 1
-            rf.add(text, last, compress=True)
-        
-        last_idx = new_idx
-        revno += 1
-
-    pb.clear()
-
-
-def profile_convert(): 
-    prof_f = tempfile.NamedTemporaryFile()
-
-    prof = hotshot.Profile(prof_f.name)
-
-    prof.runcall(convert) 
-    prof.close()
-
-    stats = hotshot.stats.load(prof_f.name)
-    #stats.strip_dirs()
-    stats.sort_stats('time')
-    ## XXX: Might like to write to stderr or the trace file instead but
-    ## print_stats seems hardcoded to stdout
-    stats.print_stats(20)
-            
-
-if '-p' in sys.argv[1:]:
-    profile_convert()
-else:
-    convert()
-    

=== modified file 'tools/win32/bzr_postinstall.py'
--- tools/win32/bzr_postinstall.py	2009-03-23 14:59:43 +0000
+++ tools/win32/bzr_postinstall.py	2010-01-29 10:36:23 +0000
@@ -341,7 +341,7 @@
                          "this library manually and put it to directory\n"
                          "where Bzr installed.\n"
                          "For detailed instructions see:\n"
-                         "http://bazaar-vcs.org/BzrOnPureWindows"
+                         "http://wiki.bazaar.canonical.com/BzrOnPureWindows"
                         ),
                         "Warning",
                         MB_OK | MB_ICONEXCLAMATION)

